// This code conforms with the UFC specification version 2018.1.0
// and was automatically generated by FFC version 2019.1.0.post0.
//
// This code was generated with the option '-l dolfin' and
// contains DOLFIN-specific wrappers that depend on DOLFIN.
//
// This code was generated with the following parameters:
//

//  add_tabulate_tensor_timing:     False
//  convert_exceptions_to_warnings: False
//  cpp_optimize:                   True
//  cpp_optimize_flags:             '-O2'
//  epsilon:                        1e-14
//  error_control:                  False
//  external_include_dirs:          ''
//  external_includes:              ''
//  external_libraries:             ''
//  external_library_dirs:          ''
//  form_postfix:                   True
//  format:                         'dolfin'
//  generate_dummy_tabulate_tensor: False
//  max_signature_length:           0
//  optimize:                       True
//  precision:                      None
//  quadrature_degree:              None
//  quadrature_rule:                None
//  representation:                 'auto'
//  split:                          False

#ifndef __FORMS_H
#define __FORMS_H
#include <algorithm>
#include <cmath>
#include <iostream>
#include <stdexcept>
#include <ufc.h>

class forms_finite_element_0: public ufc::finite_element
{
public:

  forms_finite_element_0() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Lagrange', triangle, 1)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 3;
  }

  std::size_t value_rank() const final override
  {
    return 0;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t value_size() const final override
  {
    return 1;
  }

  std::size_t reference_value_rank() const final override
  {
    return 0;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t reference_value_size() const final override
  {
    return 1;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 3; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 2] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 3 * num_derivatives, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[3] = {};
    const std::size_t num_components[3] = { 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 3; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[3 * num_derivatives * ip + num_derivatives * i + r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 3 * num_derivatives, 0.0);
    const std::size_t reference_offsets[3] = {};
    const std::size_t physical_offsets[3] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 3; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[3 * num_derivatives * ip + num_derivatives * d + s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[3 * num_derivatives * ip + num_derivatives * d + r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[3];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[3];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 1; ++k)
        values[k] = physical_values[i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold value of a single dof.
    double dof_values = 0.0;
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis(r, &dof_values, x, coordinate_dofs, cell_orientation);
        values[r] = dof_values;
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, num_derivatives * 3, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < num_derivatives; ++s)
            values[num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[6] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 6, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_0();
  }

};


class forms_finite_element_1: public ufc::finite_element
{
public:

  forms_finite_element_1() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 6;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 6 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 2] += coefficients2[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 3 + 1] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 4 + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 5 + 1] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 6 * num_derivatives * 2, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t num_components[6] = { 1, 1, 1, 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 6; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 6 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t physical_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 6; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[12];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[12];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 3:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 4:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 5:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 6, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[4] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 3:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 4:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 5:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[3] = vals[1];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[4] = vals[1];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[1];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[1];
    vertex_values[4] = dof_values[2];
    // Evaluate function and change variables
    vertex_values[1] = dof_values[3];
    vertex_values[3] = dof_values[4];
    vertex_values[5] = dof_values[5];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
    dof_coordinates[2 * 3] = coordinate_dofs[0];
    dof_coordinates[2 * 3 + 1] = coordinate_dofs[1];
    dof_coordinates[2 * 4] = coordinate_dofs[2];
    dof_coordinates[2 * 4 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 5] = coordinate_dofs[4];
    dof_coordinates[2 * 5 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[12] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 12, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 2;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_0();
    case 1:
        return new forms_finite_element_0();
    default:
        return nullptr;
    }
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_1();
  }

};


class forms_finite_element_2: public ufc::finite_element
{
public:

  forms_finite_element_2() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 15;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 3;
  }

  const char * family() const final override
  {
    return "Nedelec 1st kind H(curl)";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.16953317256112296, 0.08417937871268427, -0.11664236870396115, 0.0, -0.1468200342221035, 0.07290148043997553, -0.101015254455221 },
          { 0.0, 0.0, 0.0, 0.32167832742366925, -0.1346870059402947, 0.09720197391996732, 0.26057971086461396, -0.12987926104263, 0.09768798378956722, -0.0631345340345132 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.07824607964359519, -0.16835875742536816, 0.34992710611188244, 0.0, 0.06776309271789388, -0.14580296087995084, 0.30304576336566275 },
          { 0.0, 0.0, 0.0, -0.1651861681364796, 0.2357022603955161, -0.2721655269759086, -0.12026755886059132, 0.14682003422210382, -0.22453655975512457, 0.176776695296637 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.03912303982179774, -0.08417937871268412, -0.3499271061118825, 0.0, -0.03388154635894707, -0.07290148043997553, -0.30304576336566313 },
          { 0.0, 0.0, 0.0, 0.06085806194501906, 0.0, 0.21384434262392837, 0.060133779430295645, 0.0395284707521044, 0.11226827987756245, -0.13889597487592936 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.169533172561123, 0.08417937871268383, 0.11664236870396089, 0.0, 0.14682003422210338, 0.0729014804399753, 0.10101525445522107 },
          { 0.0, 0.0, 0.0, 0.4912114999847922, 0.21886638465297895, 0.21384434262392818, -0.26057971086461346, 0.016940773179473376, -0.024786503349591746, 0.037880720420707996 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.07824607964359517, -0.16835875742536804, -0.34992710611188227, 0.0, -0.06776309271789399, -0.14580296087995084, -0.30304576336566313 },
          { 0.0, 0.0, 0.0, -0.2434322477800738, -0.40406101782088427, -0.622092633087791, 0.12026755886059083, 0.07905694150420921, 0.07873359887517377, -0.12626906806902674 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.039123039821797406, -0.0841793787126843, 0.3499271061118826, 0.0, 0.03388154635894686, -0.07290148043997552, 0.3030457633656629 },
          { 0.0, 0.0, 0.0, 0.09998110176681531, -0.08417937871268423, 0.5637714487358111, -0.060133779430295596, 0.07341001711105213, -0.18516976031753793, 0.16414978848973452 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686871, 0.3030457633656631, 0.3110463165438957, 0.0, -0.09035079029052527, -0.14580296087995107, -0.20203050891044225 },
          { 0.0, 0.0, 0.0, 0.16953317256112274, 0.08417937871268412, 0.11664236870396119, 0.16035674514745438, 0.0677630927178939, 0.03207665139358929, -0.07576144084141609 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.7650727787373746, 0.0, -0.15552315827194774, 0.0, 0.1807015805810504, 0.0, 0.10101525445522128 },
          { 0.0, 0.0, 0.0, -0.3825363893686875, 0.0673435029701475, -0.07776157913597398, -0.320713490294909, 0.09035079029052515, -0.06415330278717857, 0.05050762722761069 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.38253638936868734, -0.30304576336566397, 0.3110463165438959, 0.0, -0.09035079029052506, 0.14580296087995093, -0.20203050891044205 },
          { 0.0, 0.0, 0.0, 0.21300321680756507, -0.2188663846529795, 0.19440394783993487, 0.16035674514745465, -0.15811388300841925, 0.17787961227354035, -0.1262690680690265 } };
    static const double coefficients9[2][10] =
        { { 3.999999999999999, 0.0, 0.0, -0.3688555567816592, -0.47619047619047555, -1.6495721976846462, 0.0, -0.31943828249997064, -0.41239304942115984, 0.5714285714285696 },
          { 0.0, 0.0, 0.0, 0.6147592613027624, 0.4761904761904764, -0.5498573992282139, 0.5669467095138401, 0.1597191412499857, -0.4536323543632764, 0.357142857142857 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.9999999999999987, 0.0, -0.6776309271789396, 1.8079567149113944, 0.0, 0.0, -0.5868455973269647, -1.2626906806902627, 0.0 },
          { 0.0, 0.0, 0.0, 1.0540925533894576, 1.1664236870396096, -0.3367175148507363, 1.0415476122441187, 0.6846531968814602, -0.5808377131175213, 0.21870444131992606 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 4.0, 0.13041013273932467, -0.8417937871268429, 0.9331389496316886, 0.0, 0.11293848786315551, -0.7290148043997555, -2.020305089104419 },
          { 0.0, 0.0, 0.0, -0.3477603539715303, 0.33671751485073415, 1.3608276348795438, -0.2004459314343179, 0.6211616832473579, 0.5977921396078003, -0.8838834764831863 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.9523809523809513, 0.0, 0.0, 0.0, 0.8247860988423221, 0.0 },
          { 3.999999999999999, 0.0, 0.0, -1.598374079387187, 0.4761904761904759, -0.5498573992282173, 0.0, -0.638876564999941, 0.4123930494211607, -0.14285714285714218 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.3552618543578772, 0.0, 0.0, 0.0, 1.173691194653928, 0.0, 0.0 },
          { 0.0, 3.9999999999999973, 0.0, 0.6776309271789404, -0.5248906591678236, 0.0, -2.0830952244882392, 0.5868455973269614, -0.10101525445522037, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.6835875742536826, 0.0, 0.0, 0.0, 1.4580296087995093, 0.0 },
          { 0.0, 0.0, 3.9999999999999982, 0.8259308406823936, 0.8417937871268419, -1.788516320127401, 0.0, -1.1293848786315646, 0.7290148043997541, -0.2525381361380519 } };
    for (std::size_t k = 0; k < num_points * 15 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + c] += coefficients0[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 + c] += coefficients1[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 2 + c] += coefficients2[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 3 + c] += coefficients3[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 4 + c] += coefficients4[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 5 + c] += coefficients5[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 6 + c] += coefficients6[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 7 + c] += coefficients7[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 8 + c] += coefficients8[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 9 + c] += coefficients9[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 10 + c] += coefficients10[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 11 + c] += coefficients11[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 12 + c] += coefficients12[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 13 + c] += coefficients13[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 14 + c] += coefficients14[c][r] * basisvalues3[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 15 * num_derivatives * 2, 0.0);
    if (order > 3)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][10][10] =
        { { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 5.291502622129201, 0.0, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
            { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
            { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
            { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } } };
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.16953317256112296, 0.08417937871268427, -0.11664236870396115, 0.0, -0.1468200342221035, 0.07290148043997553, -0.101015254455221 },
          { 0.0, 0.0, 0.0, 0.32167832742366925, -0.1346870059402947, 0.09720197391996732, 0.26057971086461396, -0.12987926104263, 0.09768798378956722, -0.0631345340345132 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.07824607964359519, -0.16835875742536816, 0.34992710611188244, 0.0, 0.06776309271789388, -0.14580296087995084, 0.30304576336566275 },
          { 0.0, 0.0, 0.0, -0.1651861681364796, 0.2357022603955161, -0.2721655269759086, -0.12026755886059132, 0.14682003422210382, -0.22453655975512457, 0.176776695296637 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.03912303982179774, -0.08417937871268412, -0.3499271061118825, 0.0, -0.03388154635894707, -0.07290148043997553, -0.30304576336566313 },
          { 0.0, 0.0, 0.0, 0.06085806194501906, 0.0, 0.21384434262392837, 0.060133779430295645, 0.0395284707521044, 0.11226827987756245, -0.13889597487592936 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.169533172561123, 0.08417937871268383, 0.11664236870396089, 0.0, 0.14682003422210338, 0.0729014804399753, 0.10101525445522107 },
          { 0.0, 0.0, 0.0, 0.4912114999847922, 0.21886638465297895, 0.21384434262392818, -0.26057971086461346, 0.016940773179473376, -0.024786503349591746, 0.037880720420707996 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.07824607964359517, -0.16835875742536804, -0.34992710611188227, 0.0, -0.06776309271789399, -0.14580296087995084, -0.30304576336566313 },
          { 0.0, 0.0, 0.0, -0.2434322477800738, -0.40406101782088427, -0.622092633087791, 0.12026755886059083, 0.07905694150420921, 0.07873359887517377, -0.12626906806902674 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.039123039821797406, -0.0841793787126843, 0.3499271061118826, 0.0, 0.03388154635894686, -0.07290148043997552, 0.3030457633656629 },
          { 0.0, 0.0, 0.0, 0.09998110176681531, -0.08417937871268423, 0.5637714487358111, -0.060133779430295596, 0.07341001711105213, -0.18516976031753793, 0.16414978848973452 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686871, 0.3030457633656631, 0.3110463165438957, 0.0, -0.09035079029052527, -0.14580296087995107, -0.20203050891044225 },
          { 0.0, 0.0, 0.0, 0.16953317256112274, 0.08417937871268412, 0.11664236870396119, 0.16035674514745438, 0.0677630927178939, 0.03207665139358929, -0.07576144084141609 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.7650727787373746, 0.0, -0.15552315827194774, 0.0, 0.1807015805810504, 0.0, 0.10101525445522128 },
          { 0.0, 0.0, 0.0, -0.3825363893686875, 0.0673435029701475, -0.07776157913597398, -0.320713490294909, 0.09035079029052515, -0.06415330278717857, 0.05050762722761069 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.38253638936868734, -0.30304576336566397, 0.3110463165438959, 0.0, -0.09035079029052506, 0.14580296087995093, -0.20203050891044205 },
          { 0.0, 0.0, 0.0, 0.21300321680756507, -0.2188663846529795, 0.19440394783993487, 0.16035674514745465, -0.15811388300841925, 0.17787961227354035, -0.1262690680690265 } };
    static const double coefficients9[2][10] =
        { { 3.999999999999999, 0.0, 0.0, -0.3688555567816592, -0.47619047619047555, -1.6495721976846462, 0.0, -0.31943828249997064, -0.41239304942115984, 0.5714285714285696 },
          { 0.0, 0.0, 0.0, 0.6147592613027624, 0.4761904761904764, -0.5498573992282139, 0.5669467095138401, 0.1597191412499857, -0.4536323543632764, 0.357142857142857 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.9999999999999987, 0.0, -0.6776309271789396, 1.8079567149113944, 0.0, 0.0, -0.5868455973269647, -1.2626906806902627, 0.0 },
          { 0.0, 0.0, 0.0, 1.0540925533894576, 1.1664236870396096, -0.3367175148507363, 1.0415476122441187, 0.6846531968814602, -0.5808377131175213, 0.21870444131992606 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 4.0, 0.13041013273932467, -0.8417937871268429, 0.9331389496316886, 0.0, 0.11293848786315551, -0.7290148043997555, -2.020305089104419 },
          { 0.0, 0.0, 0.0, -0.3477603539715303, 0.33671751485073415, 1.3608276348795438, -0.2004459314343179, 0.6211616832473579, 0.5977921396078003, -0.8838834764831863 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.9523809523809513, 0.0, 0.0, 0.0, 0.8247860988423221, 0.0 },
          { 3.999999999999999, 0.0, 0.0, -1.598374079387187, 0.4761904761904759, -0.5498573992282173, 0.0, -0.638876564999941, 0.4123930494211607, -0.14285714285714218 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.3552618543578772, 0.0, 0.0, 0.0, 1.173691194653928, 0.0, 0.0 },
          { 0.0, 3.9999999999999973, 0.0, 0.6776309271789404, -0.5248906591678236, 0.0, -2.0830952244882392, 0.5868455973269614, -0.10101525445522037, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.6835875742536826, 0.0, 0.0, 0.0, 1.4580296087995093, 0.0 },
          { 0.0, 0.0, 3.9999999999999982, 0.8259308406823936, 0.8417937871268419, -1.788516320127401, 0.0, -1.1293848786315646, 0.7290148043997541, -0.2525381361380519 } };
    const std::size_t reference_offset[15] = {};
    const std::size_t num_components[15] = { 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2 };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 15; ++i)
        {
            double derivatives[16] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients0[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients0[1][s] * aux[s];
                    }
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients1[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients1[1][s] * aux[s];
                    }
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients2[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients2[1][s] * aux[s];
                    }
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients3[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients3[1][s] * aux[s];
                    }
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients4[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients4[1][s] * aux[s];
                    }
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients5[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients5[1][s] * aux[s];
                    }
                }
                break;
            case 6:
                // Compute reference derivatives for dof 6.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients6[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients6[1][s] * aux[s];
                    }
                }
                break;
            case 7:
                // Compute reference derivatives for dof 7.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients7[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients7[1][s] * aux[s];
                    }
                }
                break;
            case 8:
                // Compute reference derivatives for dof 8.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients8[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients8[1][s] * aux[s];
                    }
                }
                break;
            case 9:
                // Compute reference derivatives for dof 9.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients9[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients9[1][s] * aux[s];
                    }
                }
                break;
            case 10:
                // Compute reference derivatives for dof 10.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients10[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients10[1][s] * aux[s];
                    }
                }
                break;
            case 11:
                // Compute reference derivatives for dof 11.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients11[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients11[1][s] * aux[s];
                    }
                }
                break;
            case 12:
                // Compute reference derivatives for dof 12.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients12[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients12[1][s] * aux[s];
                    }
                }
                break;
            case 13:
                // Compute reference derivatives for dof 13.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients13[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients13[1][s] * aux[s];
                    }
                }
                break;
            case 14:
                // Compute reference derivatives for dof 14.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients14[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients14[1][s] * aux[s];
                    }
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    std::fill_n(values, num_points * 15 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[15] = {};
    const std::size_t physical_offsets[15] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[8][8];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 15; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 2; ++i)
                {
                    // Using covariant Piola transform to map values back to the physical element.
                    const double mapped_value = K[2 * 2 * ip + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]] + K[2 * 2 * ip + 2 + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + (reference_offsets[d] + 1)];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[30];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[30];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    // Declare transformation matrix
    double transform[8][8] =
        { { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.16953317256112296, 0.08417937871268427, -0.11664236870396115, 0.0, -0.1468200342221035, 0.07290148043997553, -0.101015254455221 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.32167832742366925, -0.1346870059402947, 0.09720197391996732, 0.26057971086461396, -0.12987926104263, 0.09768798378956722, -0.0631345340345132 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 1:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.07824607964359519, -0.16835875742536816, 0.34992710611188244, 0.0, 0.06776309271789388, -0.14580296087995084, 0.30304576336566275 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.1651861681364796, 0.2357022603955161, -0.2721655269759086, -0.12026755886059132, 0.14682003422210382, -0.22453655975512457, 0.176776695296637 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 2:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.03912303982179774, -0.08417937871268412, -0.3499271061118825, 0.0, -0.03388154635894707, -0.07290148043997553, -0.30304576336566313 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.06085806194501906, 0.0, 0.21384434262392837, 0.060133779430295645, 0.0395284707521044, 0.11226827987756245, -0.13889597487592936 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 3:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.169533172561123, 0.08417937871268383, 0.11664236870396089, 0.0, 0.14682003422210338, 0.0729014804399753, 0.10101525445522107 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.4912114999847922, 0.21886638465297895, 0.21384434262392818, -0.26057971086461346, 0.016940773179473376, -0.024786503349591746, 0.037880720420707996 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 4:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.07824607964359517, -0.16835875742536804, -0.34992710611188227, 0.0, -0.06776309271789399, -0.14580296087995084, -0.30304576336566313 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.2434322477800738, -0.40406101782088427, -0.622092633087791, 0.12026755886059083, 0.07905694150420921, 0.07873359887517377, -0.12626906806902674 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 5:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.039123039821797406, -0.0841793787126843, 0.3499271061118826, 0.0, 0.03388154635894686, -0.07290148043997552, 0.3030457633656629 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.09998110176681531, -0.08417937871268423, 0.5637714487358111, -0.060133779430295596, 0.07341001711105213, -0.18516976031753793, 0.16414978848973452 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 6:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.3825363893686871, 0.3030457633656631, 0.3110463165438957, 0.0, -0.09035079029052527, -0.14580296087995107, -0.20203050891044225 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.16953317256112274, 0.08417937871268412, 0.11664236870396119, 0.16035674514745438, 0.0677630927178939, 0.03207665139358929, -0.07576144084141609 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 7:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.7650727787373746, 0.0, -0.15552315827194774, 0.0, 0.1807015805810504, 0.0, 0.10101525445522128 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.3825363893686875, 0.0673435029701475, -0.07776157913597398, -0.320713490294909, 0.09035079029052515, -0.06415330278717857, 0.05050762722761069 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 8:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.38253638936868734, -0.30304576336566397, 0.3110463165438959, 0.0, -0.09035079029052506, 0.14580296087995093, -0.20203050891044205 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.21300321680756507, -0.2188663846529795, 0.19440394783993487, 0.16035674514745465, -0.15811388300841925, 0.17787961227354035, -0.1262690680690265 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 9:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 3.999999999999999, 0.0, 0.0, -0.3688555567816592, -0.47619047619047555, -1.6495721976846462, 0.0, -0.31943828249997064, -0.41239304942115984, 0.5714285714285696 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.6147592613027624, 0.4761904761904764, -0.5498573992282139, 0.5669467095138401, 0.1597191412499857, -0.4536323543632764, 0.357142857142857 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 10:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 3.9999999999999987, 0.0, -0.6776309271789396, 1.8079567149113944, 0.0, 0.0, -0.5868455973269647, -1.2626906806902627, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 1.0540925533894576, 1.1664236870396096, -0.3367175148507363, 1.0415476122441187, 0.6846531968814602, -0.5808377131175213, 0.21870444131992606 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 11:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 4.0, 0.13041013273932467, -0.8417937871268429, 0.9331389496316886, 0.0, 0.11293848786315551, -0.7290148043997555, -2.020305089104419 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.3477603539715303, 0.33671751485073415, 1.3608276348795438, -0.2004459314343179, 0.6211616832473579, 0.5977921396078003, -0.8838834764831863 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 12:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 0.9523809523809513, 0.0, 0.0, 0.0, 0.8247860988423221, 0.0 };
            static const double coefficients1[10] = { 3.999999999999999, 0.0, 0.0, -1.598374079387187, 0.4761904761904759, -0.5498573992282173, 0.0, -0.638876564999941, 0.4123930494211607, -0.14285714285714218 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 13:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 1.3552618543578772, 0.0, 0.0, 0.0, 1.173691194653928, 0.0, 0.0 };
            static const double coefficients1[10] = { 0.0, 3.9999999999999973, 0.0, 0.6776309271789404, -0.5248906591678236, 0.0, -2.0830952244882392, 0.5868455973269614, -0.10101525445522037, 0.0 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 14:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 1.6835875742536826, 0.0, 0.0, 0.0, 1.4580296087995093, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 3.9999999999999982, 0.8259308406823936, 0.8417937871268419, -1.788516320127401, 0.0, -1.1293848786315646, 0.7290148043997541, -0.2525381361380519 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 15, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[16] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    switch (i)
    {
    case 0:
        {
            y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 1:
        {
            y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 2:
        {
            y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 3:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 4:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 5:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 6:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 7:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 8:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 9:
        {
            result = 0.0;
            double X_9[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_9[36][1] = {};
            double W_9[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_9[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_9[r][0] - X_9[r][1];
                const double w1 = X_9[r][0];
                const double w2 = X_9[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_9[D_9[r][s]] * W_9[r][s];
            }
            return result;
        }
        break;
    case 10:
        {
            result = 0.0;
            double X_10[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_10[36][1] = {};
            double W_10[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_10[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_10[r][0] - X_10[r][1];
                const double w1 = X_10[r][0];
                const double w2 = X_10[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_10[D_10[r][s]] * W_10[r][s];
            }
            return result;
        }
        break;
    case 11:
        {
            result = 0.0;
            double X_11[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_11[36][1] = {};
            double W_11[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_11[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_11[r][0] - X_11[r][1];
                const double w1 = X_11[r][0];
                const double w2 = X_11[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_11[D_11[r][s]] * W_11[r][s];
            }
            return result;
        }
        break;
    case 12:
        {
            result = 0.0;
            double X_12[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_12[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_12[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_12[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_12[r][0] - X_12[r][1];
                const double w1 = X_12[r][0];
                const double w2 = X_12[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_12[D_12[r][s]] * W_12[r][s];
            }
            return result;
        }
        break;
    case 13:
        {
            result = 0.0;
            double X_13[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_13[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_13[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_13[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_13[r][0] - X_13[r][1];
                const double w1 = X_13[r][0];
                const double w2 = X_13[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_13[D_13[r][s]] * W_13[r][s];
            }
            return result;
        }
        break;
    case 14:
        {
            result = 0.0;
            double X_14[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_14[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_14[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_14[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_14[r][0] - X_14[r][1];
                const double w1 = X_14[r][0];
                const double w2 = X_14[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_14[D_14[r][s]] * W_14[r][s];
            }
            return result;
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[0] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[1] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[3] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[4] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[6] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[7] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[8] = vals[0] * J[0] + vals[1] * J[2];
    result = 0.0;
    double X_9[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_9[36][1] = {};
    double W_9[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_9[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_9[r][0] - X_9[r][1];
        const double w1 = X_9[r][0];
        const double w2 = X_9[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_9[D_9[r][s]] * W_9[r][s];
    }
    values[9] = result;
    result = 0.0;
    double X_10[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_10[36][1] = {};
    double W_10[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_10[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_10[r][0] - X_10[r][1];
        const double w1 = X_10[r][0];
        const double w2 = X_10[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_10[D_10[r][s]] * W_10[r][s];
    }
    values[10] = result;
    result = 0.0;
    double X_11[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_11[36][1] = {};
    double W_11[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_11[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_11[r][0] - X_11[r][1];
        const double w1 = X_11[r][0];
        const double w2 = X_11[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_11[D_11[r][s]] * W_11[r][s];
    }
    values[11] = result;
    result = 0.0;
    double X_12[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_12[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_12[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_12[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_12[r][0] - X_12[r][1];
        const double w1 = X_12[r][0];
        const double w2 = X_12[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_12[D_12[r][s]] * W_12[r][s];
    }
    values[12] = result;
    result = 0.0;
    double X_13[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_13[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_13[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_13[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_13[r][0] - X_13[r][1];
        const double w1 = X_13[r][0];
        const double w2 = X_13[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_13[D_13[r][s]] * W_13[r][s];
    }
    values[13] = result;
    result = 0.0;
    double X_14[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_14[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_14[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_14[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_14[r][0] - X_14[r][1];
        const double w1 = X_14[r][0];
        const double w2 = X_14[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_14[D_14[r][s]] * W_14[r][s];
    }
    values[14] = result;
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Evaluate function and change variables
    vertex_values[0] = dof_values[3] * (K[2] * 3.0) + dof_values[4] * (K[2] * -2.9999999999999973) + dof_values[5] * K[2] + dof_values[6] * (K[0] * 2.9999999999999996) + dof_values[7] * (K[0] * -2.9999999999999996) + dof_values[8] * K[0];
    vertex_values[2] = dof_values[0] * (K[2] * 3.0000000000000013) + dof_values[1] * (K[2] * -3.0000000000000053) + dof_values[2] * K[2] + dof_values[6] * (K[0] + K[2]) + dof_values[7] * (K[0] * -3.0 + K[2] * -2.999999999999999) + dof_values[8] * (K[0] * 3.0 + K[2] * 3.000000000000003);
    vertex_values[4] = dof_values[0] * -K[0] + dof_values[1] * (K[0] * 2.9999999999999973) + dof_values[2] * (K[0] * -2.999999999999999) + dof_values[3] * (K[0] + K[2]) + dof_values[4] * (K[0] * -2.9999999999999987 + K[2] * -3.0000000000000004) + dof_values[5] * (K[0] * 2.9999999999999982 + K[2] * 3.0000000000000013);
    vertex_values[1] = dof_values[3] * (K[2 + 1] * 3.0) + dof_values[4] * (K[2 + 1] * -2.9999999999999973) + dof_values[5] * K[2 + 1] + dof_values[6] * (K[1] * 2.9999999999999996) + dof_values[7] * (K[1] * -2.9999999999999996) + dof_values[8] * K[1];
    vertex_values[3] = dof_values[0] * (K[2 + 1] * 3.0000000000000013) + dof_values[1] * (K[2 + 1] * -3.0000000000000053) + dof_values[2] * K[2 + 1] + dof_values[6] * (K[1] + K[2 + 1]) + dof_values[7] * (K[1] * -3.0 + K[2 + 1] * -2.999999999999999) + dof_values[8] * (K[1] * 3.0 + K[2 + 1] * 3.000000000000003);
    vertex_values[5] = dof_values[0] * -K[1] + dof_values[1] * (K[1] * 2.9999999999999973) + dof_values[2] * (K[1] * -2.999999999999999) + dof_values[3] * (K[1] + K[2 + 1]) + dof_values[4] * (K[1] * -2.9999999999999987 + K[2 + 1] * -3.0000000000000004) + dof_values[5] * (K[1] * 2.9999999999999982 + K[2 + 1] * 3.0000000000000013);
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    throw std::runtime_error("tabulate_dof_coordinates is not defined for this element");
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    throw std::runtime_error("tabulate_reference_dof_coordinates is not defined for this element");
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_2();
  }

};


class forms_dofmap_0: public ufc::dofmap
{
public:

  forms_dofmap_0() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Lagrange', triangle, 1)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 3;
  }

  std::size_t num_element_dofs() const final override
  {
    return 3;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 2;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 2, 3 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    dofs[0] = entity_indices[0][0];
    dofs[1] = entity_indices[0][1];
    dofs[2] = entity_indices[0][2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_0();
  }

};


class forms_dofmap_1: public ufc::dofmap
{
public:

  forms_dofmap_1() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 2 * num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 6;
  }

  std::size_t num_element_dofs() const final override
  {
    return 6;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 4;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 4, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + entity_indices[0][0];
    dofs[1] = offset + entity_indices[0][1];
    dofs[2] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
    dofs[3] = offset + entity_indices[0][0];
    dofs[4] = offset + entity_indices[0][1];
    dofs[5] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 4;
        dofs[3] = 5;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 5;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 3;
        dofs[3] = 4;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            dofs[2] = 4;
            dofs[3] = 5;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            dofs[2] = 3;
            dofs[3] = 5;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 3;
            dofs[3] = 4;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 2;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_0();
    case 1:
        return new forms_dofmap_0();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_1();
  }

};


class forms_dofmap_2: public ufc::dofmap
{
public:

  forms_dofmap_2() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { false, true, true };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 3 * num_global_entities[1] + 6 * num_global_entities[2];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 15;
  }

  std::size_t num_element_dofs() const final override
  {
    return 15;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 3;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 15 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + 3 * entity_indices[1][0];
    dofs[1] = offset + 3 * entity_indices[1][0] + 1;
    dofs[2] = offset + 3 * entity_indices[1][0] + 2;
    dofs[3] = offset + 3 * entity_indices[1][1];
    dofs[4] = offset + 3 * entity_indices[1][1] + 1;
    dofs[5] = offset + 3 * entity_indices[1][1] + 2;
    dofs[6] = offset + 3 * entity_indices[1][2];
    dofs[7] = offset + 3 * entity_indices[1][2] + 1;
    dofs[8] = offset + 3 * entity_indices[1][2] + 2;
    offset += 3 * num_global_entities[1];
    dofs[9] = offset + 6 * entity_indices[2][0];
    dofs[10] = offset + 6 * entity_indices[2][0] + 1;
    dofs[11] = offset + 6 * entity_indices[2][0] + 2;
    dofs[12] = offset + 6 * entity_indices[2][0] + 3;
    dofs[13] = offset + 6 * entity_indices[2][0] + 4;
    dofs[14] = offset + 6 * entity_indices[2][0] + 5;
    offset += 6 * num_global_entities[2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 2;
        break;
    case 1:
        dofs[0] = 3;
        dofs[1] = 4;
        dofs[2] = 5;
        break;
    case 2:
        dofs[0] = 6;
        dofs[1] = 7;
        dofs[2] = 8;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 9;
            dofs[1] = 10;
            dofs[2] = 11;
            dofs[3] = 12;
            dofs[4] = 13;
            dofs[5] = 14;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            break;
        case 1:
            break;
        case 2:
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            dofs[6] = 6;
            dofs[7] = 7;
            dofs[8] = 8;
            dofs[9] = 9;
            dofs[10] = 10;
            dofs[11] = 11;
            dofs[12] = 12;
            dofs[13] = 13;
            dofs[14] = 14;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_2();
  }

};


class forms_coordinate_mapping_1: public ufc::coordinate_mapping
{
public:

  forms_coordinate_mapping_1() : ufc::coordinate_mapping()
  {
    // Do nothing
  }

  ~forms_coordinate_mapping_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC coordinate_mapping from VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::coordinate_mapping * create() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
  }

  void compute_physical_coordinates(
      double * x, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double phi[3];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis values of coordinate element
        xelement.evaluate_reference_basis(phi, 1, &X[2 * ip]);
        // Compute x
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t d = 0; d < 3; ++d)
                x[2 * ip + i] += coordinate_dofs[2 * d + i] * phi[d];
    }
  }

  void compute_reference_coordinates(
      double * X, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double J[4];
    double detJ[1];
    double K[4];
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_reference_geometry(
      double * X, double * J, double * detJ, double * K, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_jacobians(
      double * J, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double dphi[6];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis derivatives of coordinate element
        xelement.evaluate_reference_basis_derivatives(dphi, 1, 1, &X[2 * ip]);
        // Compute J
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t j = 0; j < 2; ++j)
                for (std::size_t d = 0; d < 3; ++d)
                    J[2 * 2 * ip + 2 * i + j] += coordinate_dofs[2 * d + i] * dphi[2 * d + j];
    }
  }

  void compute_jacobian_determinants(
      double * detJ, std::size_t num_points,
      const double * J,
      int cell_orientation) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
        detJ[ip] = J[2 * 2 * ip] * J[2 * 2 * ip + 2 + 1] - J[2 * 2 * ip + 1] * J[2 * 2 * ip + 2];
  }

  void compute_jacobian_inverses(
      double * K, std::size_t num_points,
      const double * J, const double * detJ) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        K[2 * 2 * ip] = J[2 * 2 * ip + 2 + 1] / detJ[ip];
        K[2 * 2 * ip + 1] = -J[2 * 2 * ip + 1] / detJ[ip];
        K[2 * 2 * ip + 2] = -J[2 * 2 * ip + 2] / detJ[ip];
        K[2 * 2 * ip + 2 + 1] = J[2 * 2 * ip] / detJ[ip];
    }
  }

  void compute_geometry(
      double * x, double * J, double * detJ, double * K, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    compute_physical_coordinates(x, num_points, X, coordinate_dofs);
    compute_jacobians(J, num_points, X, coordinate_dofs);
    compute_jacobian_determinants(detJ, num_points, J, cell_orientation);
    compute_jacobian_inverses(K, num_points, J, detJ);
  }

  void compute_midpoint_geometry(
      double * x, double * J,
      const double * coordinate_dofs) const final override
  {
    const double phi_Xm[3] = { 0.3333333333333333, 0.3333333333333333, 0.3333333333333333 };
    const double dphi_Xm[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    // Compute x
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t d = 0; d < 3; ++d)
            x[i] += coordinate_dofs[2 * d + i] * phi_Xm[d];
    // Compute J
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t d = 0; d < 3; ++d)
                J[2 * i + j] += coordinate_dofs[2 * d + i] * dphi_Xm[j][d];
  }

};


class forms_cell_integral_0_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_0_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_0_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 4
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 4
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           4
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q6[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q6[0][0][1];
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q6[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q6[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q6[0][0][1];
    alignas(32) double sp[36];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c3 / sp[2];
    sp[4] = -1 * J_c2 / sp[2];
    sp[5] = J_c0 / sp[2];
    sp[6] = sp[5] * sp[3];
    sp[7] = sp[5] * sp[4];
    sp[8] = -1 * J_c1 / sp[2];
    sp[9] = sp[3] * sp[8];
    sp[10] = sp[8] * sp[4];
    sp[11] = -1 * sp[10] + sp[6];
    sp[12] = -1 * sp[7] + sp[7];
    sp[13] = -1 * sp[9] + sp[9];
    sp[14] = -1 * sp[6] + sp[10];
    sp[15] = sp[11] * sp[11];
    sp[16] = sp[11] * sp[12];
    sp[17] = sp[11] * sp[13];
    sp[18] = sp[11] * sp[14];
    sp[19] = sp[12] * sp[12];
    sp[20] = sp[13] * sp[12];
    sp[21] = sp[12] * sp[14];
    sp[22] = sp[13] * sp[13];
    sp[23] = sp[13] * sp[14];
    sp[24] = sp[14] * sp[14];
    sp[25] = std::abs(sp[2]);
    sp[26] = sp[15] * sp[25];
    sp[27] = sp[16] * sp[25];
    sp[28] = sp[17] * sp[25];
    sp[29] = sp[18] * sp[25];
    sp[30] = sp[19] * sp[25];
    sp[31] = sp[20] * sp[25];
    sp[32] = sp[21] * sp[25];
    sp[33] = sp[22] * sp[25];
    sp[34] = sp[23] * sp[25];
    sp[35] = sp[24] * sp[25];
    A[0] = 2.633333333333336 * sp[33] + 0.3583333333333374 * sp[34] + -0.6083333333333348 * sp[28] + -0.6083333333333291 * sp[31] + 0.3583333333333374 * sp[34] + 0.858333333333347 * sp[35] + -1.875000000000022 * sp[29] + -0.6083333333333407 * sp[32] + -0.6083333333333348 * sp[28] + -1.875000000000022 * sp[29] + 6.191666666666705 * sp[26] + 1.691666666666671 * sp[27] + -0.6083333333333291 * sp[31] + -0.6083333333333407 * sp[32] + 1.691666666666671 * sp[27] + 0.6333333333333341 * sp[30];
    A[1] = -2.016666666666664 * sp[33] + 1.116666666666661 * sp[34] + -0.6166666666666643 * sp[28] + -0.6166666666666774 * sp[31] + 0.2833333333333356 * sp[34] + -0.8000000000000108 * sp[35] + sp[29] + -0.6166666666666782 * sp[32] + 0.216666666666665 * sp[28] + 1.666666666666682 * sp[29] + -3.466666666666694 * sp[26] + 2.783333333333349 * sp[27] + 0.2166666666666592 * sp[31] + 0.2166666666666753 * sp[32] + -0.7166666666666721 * sp[27] + 0.8166666666666651 * sp[30];
    A[2] = -0.03333333333332955 * sp[33] + -0.8916666666666629 * sp[34] + -0.1916666666666674 * sp[28] + -0.1916666666666647 * sp[31] + 0.4416666666666716 * sp[34] + 1.275000000000011 * sp[35] + -0.7916666666666764 * sp[29] + -0.1916666666666623 * sp[32] + -0.1916666666666686 * sp[28] + -0.791666666666674 * sp[29] + 1.275000000000013 * sp[26] + -0.8916666666666719 * sp[27] + -0.1916666666666704 * sp[31] + -0.1916666666666744 * sp[32] + 0.4416666666666713 * sp[27] + -0.03333333333333011 * sp[30];
    A[3] = -1.591666666666673 * sp[33] + -0.650000000000003 * sp[34] + -2.283333333333346 * sp[28] + -0.6500000000000106 * sp[31] + -0.9416666666666758 * sp[34] + -1.295833333333348 * sp[35] + -0.1125000000000039 * sp[29] + -0.4666666666666743 * sp[32] + 0.6916666666666711 * sp[28] + 1.520833333333352 * sp[29] + -1.095833333333331 * sp[26] + -0.2666666666666583 * sp[27] + 0.6916666666666693 * sp[31] + 0.6916666666666739 * sp[32] + 0.6916666666666709 * sp[27] + 0.5083333333333409 * sp[30];
    A[4] = -0.06666666666666055 * sp[33] + -0.5333333333333299 * sp[34] + -0.09999999999998943 * sp[28] + -0.5333333333333296 * sp[31] + 0.8833333333333415 * sp[34] + 1.675000000000014 * sp[35] + 0.1416666666666706 * sp[29] + 0.9333333333333329 * sp[32] + -0.383333333333336 * sp[28] + -0.9583333333333426 * sp[29] + 0.4416666666666627 * sp[26] + -0.1333333333333335 * sp[27] + -0.3833333333333396 * sp[31] + -0.3833333333333419 * sp[32] + -0.3833333333333412 * sp[27] + -0.6000000000000082 * sp[30];
    A[5] = -1.008333333333332 * sp[33] + 1.183333333333331 * sp[34] + -2.116666666666667 * sp[28] + 1.183333333333329 * sp[31] + 0.141666666666669 * sp[34] + -0.8375000000000078 * sp[35] + 0.5125000000000066 * sp[29] + -0.4666666666666683 * sp[32] + 0.1083333333333315 * sp[28] + 1.145833333333341 * sp[29] + -0.6375000000000115 * sp[26] + 0.4000000000000077 * sp[27] + 0.1083333333333288 * sp[31] + 0.1083333333333398 * sp[32] + 0.108333333333324 * sp[27] + 0.09166666666667565 * sp[30];
    A[6] = -1.091666666666672 * sp[33] + -1.10833333333334 * sp[34] + -1.108333333333335 * sp[28] + -1.108333333333334 * sp[31] + -0.7333333333333425 * sp[34] + -0.3624999999999933 * sp[35] + -1.479166666666682 * sp[29] + -1.10833333333334 * sp[32] + 2.133333333333348 * sp[28] + 1.154166666666656 * sp[29] + 3.170833333333348 * sp[26] + 2.191666666666672 * sp[27] + 1.150000000000004 * sp[31] + 1.116666666666665 * sp[32] + 1.150000000000003 * sp[27] + 1.008333333333335 * sp[30];
    A[7] = 2.600000000000009 * sp[33] + 1.216666666666668 * sp[34] + 1.216666666666669 * sp[28] + 1.216666666666663 * sp[31] + 1.466666666666682 * sp[34] + 0.3083333333333381 * sp[35] + 2.375000000000026 * sp[29] + 1.216666666666679 * sp[32] + -4.933333333333358 * sp[28] + -1.05833333333333 * sp[29] + -7.258333333333372 * sp[26] + -3.38333333333334 * sp[27] + -2.133333333333335 * sp[31] + -0.8999999999999994 * sp[32] + -2.133333333333338 * sp[27] + -1.266666666666666 * sp[30];
    A[8] = -1.508333333333339 * sp[33] + 0.3083333333333441 * sp[34] + 0.3083333333333312 * sp[28] + 0.3083333333333438 * sp[31] + -0.7333333333333388 * sp[34] + 0.7625000000000103 * sp[35] + -1.187500000000012 * sp[29] + 0.3083333333333412 * sp[32] + 2.800000000000011 * sp[28] + -2.887500000000013 * sp[29] + 4.295833333333359 * sp[26] + -1.391666666666683 * sp[27] + 0.9833333333333305 * sp[31] + -0.7166666666666647 * sp[32] + 0.9833333333333367 * sp[27] + -0.408333333333335 * sp[30];
    A[9] = 1.649915822768635 * sp[33] + 0.4714045207910287 * sp[34] + -5.185449728701343 * sp[28] + -5.185449728701368 * sp[31] + 3.064129385141737 * sp[34] + 1.767766952966354 * sp[35] + -3.889087296526054 * sp[29] + -5.185449728701419 * sp[32] + -1.649915822768626 * sp[28] + 5.067598598503595 * sp[29] + 10.72445284799602 * sp[26] + 17.44196726926824 * sp[27] + -1.649915822768631 * sp[31] + -0.2357022603955441 * sp[32] + 4.006938426723768 * sp[27] + 5.892556509887892 * sp[30];
    A[10] = 10.96965511460289 * sp[33] + 0.721687836486982 * sp[34] + -10.53664241271069 * sp[28] + -10.53664241271072 * sp[31] + 0.1443375672973277 * sp[34] + -1.732050807568891 * sp[35] + -8.660254037844483 * sp[29] + -10.53664241271079 * sp[32] + 0.7216878364871102 * sp[28] + 11.5470053837925 * sp[29] + 18.47520861406811 * sp[26] + 29.30052616137365 * sp[27] + 0.721687836487091 * sp[31] + 5.051814855409215 * sp[32] + 7.649891066762555 * sp[27] + 10.9696551146029 * sp[30];
    A[11] = -6.833333333333317 * sp[33] + 1.583333333333353 * sp[34] + 0.08333333333333037 * sp[28] + 0.08333333333334547 * sp[31] + 2.416666666666694 * sp[34] + 3.750000000000001 * sp[35] + -1.250000000000015 * sp[29] + 0.08333333333338833 * sp[32] + 0.08333333333332907 * sp[28] + -4.916666666666638 * sp[29] + -5.916666666666665 * sp[26] + -10.91666666666672 * sp[27] + 0.08333333333329609 * sp[31] + 0.5833333333333717 * sp[32] + -0.9166666666666456 * sp[27] + -1.833333333333317 * sp[30];
    A[12] = 5.892556509887876 * sp[33] + -1.649915822768607 * sp[34] + 16.73486048808164 * sp[28] + 4.006938426723789 * sp[31] + -3.299831645537255 * sp[34] + -2.474873734152929 * sp[35] + 3.181980515339498 * sp[29] + 4.006938426723837 * sp[32] + 0.4714045207910428 * sp[28] + -2.003469213361903 * sp[29] + -7.660323462854287 * sp[26] + -10.13519719700728 * sp[27] + 0.4714045207910712 * sp[31] + 0.471404520791032 * sp[32] + -5.185449728701323 * sp[27] + -4.006938426723801 * sp[30];
    A[13] = -16.8874953737966 * sp[33] + -7.361215932167751 * sp[34] + -7.361215932167751 * sp[28] + 3.897114317029957 * sp[31] + -5.196152422706669 * sp[34] + -6.278684177437277 * sp[35] + 4.979646071760503 * sp[29] + 3.89711431702994 * sp[32] + 5.196152422706643 * sp[28] + 11.90784930203617 * sp[29] + -21.86714144555713 * sp[26] + -15.15544456622762 * sp[27] + 5.196152422706621 * sp[31] + 5.196152422706671 * sp[32] + -1.732050807568867 * sp[27] + -3.897114317029917 * sp[30];
    A[14] = 10.41666666666662 * sp[33] + -2.916666666666664 * sp[34] + 10.0833333333333 * sp[28] + -1.416666666666663 * sp[31] + -5.833333333333392 * sp[34] + -4.37500000000002 * sp[35] + -2.875000000000033 * sp[29] + -1.416666666666763 * sp[32] + 0.8333333333333517 * sp[28] + -3.541666666666699 * sp[29] + 7.958333333333401 * sp[26] + 3.583333333333356 * sp[27] + 0.8333333333334049 * sp[31] + 0.8333333333333355 * sp[32] + 1.833333333333382 * sp[27] + 2.916666666666667 * sp[30];
    A[15] = -2.016666666666664 * sp[33] + 0.2833333333333356 * sp[34] + 0.216666666666665 * sp[28] + 0.2166666666666592 * sp[31] + 1.116666666666661 * sp[34] + -0.8000000000000108 * sp[35] + 1.666666666666682 * sp[29] + 0.2166666666666753 * sp[32] + -0.6166666666666643 * sp[28] + sp[29] + -3.466666666666694 * sp[26] + -0.7166666666666721 * sp[27] + -0.6166666666666774 * sp[31] + -0.6166666666666782 * sp[32] + 2.783333333333349 * sp[27] + 0.8166666666666651 * sp[30];
    A[16] = 2.533333333333331 * sp[33] + -1.733333333333337 * sp[34] + 0.7333333333333336 * sp[28] + 0.7333333333333463 * sp[31] + -1.733333333333337 * sp[34] + 2.766666666666671 * sp[35] + -2.166666666666673 * sp[29] + 0.7333333333333427 * sp[32] + 0.7333333333333336 * sp[28] + -2.166666666666673 * sp[29] + 2.766666666666684 * sp[26] + -1.733333333333344 * sp[27] + 0.7333333333333463 * sp[31] + 0.7333333333333427 * sp[32] + -1.733333333333344 * sp[27] + 2.53333333333334 * sp[30];
    A[17] = 0.8166666666666671 * sp[33] + 2.783333333333339 * sp[34] + -0.6166666666666709 * sp[28] + -0.6166666666666708 * sp[31] + -0.7166666666666739 * sp[34] + -3.466666666666687 * sp[35] + sp[29] + -0.6166666666666726 * sp[32] + 0.2166666666666686 * sp[28] + 1.666666666666674 * sp[29] + -0.8000000000000103 * sp[26] + 1.11666666666667 * sp[27] + 0.2166666666666713 * sp[31] + 0.2166666666666691 * sp[32] + 0.2833333333333363 * sp[27] + -2.016666666666674 * sp[30];
    A[18] = -0.06666666666666718 * sp[33] + -0.9500000000000026 * sp[34] + 0.3166666666666718 * sp[28] + -0.9499999999999935 * sp[31] + 0.4666666666666806 * sp[34] + 1.258333333333355 * sp[35] + -0.1083333333333288 * sp[29] + 0.6833333333333441 * sp[32] + 0.03333333333332844 * sp[28] + -0.708333333333347 * sp[29] + 0.8583333333333275 * sp[26] + 0.1166666666666589 * sp[27] + 0.03333333333333327 * sp[31] + 0.03333333333333999 * sp[32] + 0.03333333333332261 * sp[27] + -0.1833333333333409 * sp[30];
    A[19] = 1.633333333333332 * sp[33] + 3.066666666666672 * sp[34] + 1.19999999999999 * sp[28] + 3.066666666666663 * sp[31] + -1.433333333333346 * sp[34] + -3.683333333333361 * sp[35] + -0.2833333333333348 * sp[29] + -2.533333333333333 * sp[32] + 0.4333333333333363 * sp[28] + 1.583333333333344 * sp[29] + -0.2166666666666634 * sp[26] + 0.9333333333333411 * sp[27] + 0.4333333333333427 * sp[31] + 0.4333333333333364 * sp[32] + 0.4333333333333488 * sp[27] + 1.200000000000025 * sp[30];
    A[20] = 1.266666666666666 * sp[33] + -2.116666666666671 * sp[34] + 2.483333333333335 * sp[28] + -2.116666666666669 * sp[31] + -0.8666666666666695 * sp[34] + 3.008333333333342 * sp[35] + -2.02500000000001 * sp[29] + 1.849999999999993 * sp[32] + 0.3666666666666673 * sp[28] + -1.958333333333339 * sp[29] + 1.275000000000007 * sp[26] + -1.050000000000005 * sp[27] + 0.3666666666666731 * sp[31] + 0.3666666666666698 * sp[32] + 0.3666666666666729 * sp[27] + -1.01666666666667 * sp[30];
    A[21] = 0.1833333333333404 * sp[33] + -0.0333333333333195 * sp[34] + -0.03333333333333655 * sp[28] + -0.03333333333333399 * sp[31] + -0.1166666666666601 * sp[34] + -0.8583333333333502 * sp[35] + 0.708333333333352 * sp[29] + -0.03333333333332755 * sp[32] + -0.6833333333333476 * sp[28] + 0.1083333333333337 * sp[29] + -1.258333333333346 * sp[26] + -0.466666666666673 * sp[27] + 0.9499999999999976 * sp[31] + -0.3166666666666949 * sp[32] + 0.950000000000005 * sp[27] + 0.06666666666665924 * sp[30];
    A[22] = -1.200000000000005 * sp[33] + -0.4333333333333348 * sp[34] + -0.4333333333333315 * sp[28] + -0.4333333333333275 * sp[31] + -0.9333333333333425 * sp[34] + 0.2166666666666626 * sp[35] + -1.583333333333355 * sp[29] + -0.4333333333333466 * sp[32] + 2.533333333333359 * sp[28] + 0.2833333333333353 * sp[29] + 3.683333333333363 * sp[26] + 1.433333333333342 * sp[27] + -3.066666666666672 * sp[31] + -1.199999999999985 * sp[32] + -3.066666666666684 * sp[27] + -1.633333333333329 * sp[30];
    A[23] = 1.01666666666667 * sp[33] + -0.3666666666666798 * sp[34] + -0.3666666666666659 * sp[28] + -0.3666666666666785 * sp[31] + 1.049999999999999 * sp[34] + -1.275000000000011 * sp[35] + 1.95833333333334 * sp[29] + -0.3666666666666715 * sp[32] + -1.85000000000001 * sp[28] + 2.025000000000009 * sp[29] + -3.008333333333352 * sp[26] + 0.8666666666666755 * sp[27] + 2.116666666666676 * sp[31] + -2.48333333333334 * sp[32] + 2.116666666666677 * sp[27] + -1.266666666666675 * sp[30];
    A[24] = 3.771236166328252 * sp[33] + 6.128258770283431 * sp[34] + 3.299831645537213 * sp[28] + 3.29983164553724 * sp[31] + -3.771236166328294 * sp[34] + 1.178511301977588 * sp[35] + -1.649915822768562 * sp[29] + 3.299831645537288 * sp[32] + 0.9428090415820738 * sp[28] + -5.421151989096854 * sp[29] + -2.592724864350716 * sp[26] + -8.956685895029658 * sp[27] + 0.9428090415820821 * sp[31] + 12.25651754056687 * sp[32] + 3.771236166328279 * sp[27] + 11.7851130197758 * sp[30];
    A[25] = -8.948929172439152 * sp[33] + -1.443375672973965 * sp[34] + 3.752776749732559 * sp[28] + 3.75277674973261 * sp[31] + -3.17542648054281 * sp[34] + 2.020725942163681 * sp[35] + -1.443375672973955 * sp[29] + 3.75277674973267 * sp[32] + 1.44337567297402 * sp[28] + -7.216878364870331 * sp[29] + -3.752776749732638 * sp[26] + -12.41303078757707 * sp[27] + 1.443375672973962 * sp[31] + 10.10362971081832 * sp[32] + 4.907477288111857 * sp[27] + 14.14508159514584 * sp[30];
    A[26] = 11.16666666666667 * sp[33] + 1.833333333333341 * sp[34] + -5.166666666666687 * sp[28] + -5.166666666666679 * sp[31] + -8.166666666666712 * sp[34] + -16.6666666666667 * sp[35] + 3.333333333333395 * sp[29] + -5.166666666666729 * sp[32] + 3.166666666666671 * sp[28] + 10.66666666666666 * sp[29] + 2.666666666666658 * sp[26] + 10.1666666666667 * sp[27] + 3.166666666666734 * sp[31] + -7.833333333333402 * sp[32] + -4.833333333333346 * sp[27] + -17.16666666666671 * sp[30];
    A[27] = -11.78511301977579 * sp[33] + -3.771236166328268 * sp[34] + -12.2565175405668 * sp[28] + -0.9428090415820527 * sp[31] + 8.956685895029656 * sp[34] + 2.592724864350744 * sp[35] + 5.421151989096823 * sp[29] + -0.9428090415821071 * sp[32] + -3.299831645537234 * sp[28] + 1.6499158227686 * sp[29] + -1.178511301977546 * sp[26] + 3.771236166328307 * sp[27] + -3.299831645537289 * sp[31] + -3.299831645537262 * sp[32] + -6.128258770283468 * sp[27] + -3.771236166328288 * sp[30];
    A[28] = 7.794228634059971 * sp[33] + 1.732050807568867 * sp[34] + 1.732050807568875 * sp[28] + -3.464101615137753 * sp[31] + -2.598076211353278 * sp[34] + -0.4330127018921175 * sp[35] + -5.629165124598742 * sp[29] + -3.464101615137693 * sp[32] + 2.598076211353306 * sp[28] + -2.165063509461185 * sp[29] + 13.42339375865882 * sp[26] + 8.66025403784438 * sp[27] + 2.59807621135336 * sp[31] + 2.598076211353387 * sp[32] + -0.8660254037845523 * sp[27] + -5.196152422706589 * sp[30];
    A[29] = -20.83333333333332 * sp[33] + -6.666666666666683 * sp[34] + -12.66666666666663 * sp[28] + 0.3333333333333502 * sp[31] + 15.83333333333342 * sp[34] + 4.583333333333446 * sp[35] + 11.58333333333334 * sp[29] + 0.3333333333335449 * sp[32] + -5.833333333333348 * sp[28] + 2.916666666666654 * sp[29] + -10.08333333333338 * sp[26] + -1.333333333333372 * sp[27] + -5.833333333333451 * sp[31] + -5.833333333333407 * sp[32] + 2.166666666666601 * sp[27] + 13.33333333333323 * sp[30];
    A[30] = -0.03333333333332955 * sp[33] + 0.4416666666666716 * sp[34] + -0.1916666666666686 * sp[28] + -0.1916666666666704 * sp[31] + -0.8916666666666629 * sp[34] + 1.275000000000011 * sp[35] + -0.791666666666674 * sp[29] + -0.1916666666666744 * sp[32] + -0.1916666666666674 * sp[28] + -0.7916666666666764 * sp[29] + 1.275000000000013 * sp[26] + 0.4416666666666713 * sp[27] + -0.1916666666666647 * sp[31] + -0.1916666666666623 * sp[32] + -0.8916666666666719 * sp[27] + -0.03333333333333011 * sp[30];
    A[31] = 0.8166666666666671 * sp[33] + -0.7166666666666739 * sp[34] + 0.2166666666666686 * sp[28] + 0.2166666666666713 * sp[31] + 2.783333333333339 * sp[34] + -3.466666666666687 * sp[35] + 1.666666666666674 * sp[29] + 0.2166666666666691 * sp[32] + -0.6166666666666709 * sp[28] + sp[29] + -0.8000000000000103 * sp[26] + 0.2833333333333363 * sp[27] + -0.6166666666666708 * sp[31] + -0.6166666666666726 * sp[32] + 1.11666666666667 * sp[27] + -2.016666666666674 * sp[30];
    A[32] = 0.6333333333333372 * sp[33] + 1.691666666666677 * sp[34] + -0.6083333333333384 * sp[28] + -0.6083333333333366 * sp[31] + 1.691666666666677 * sp[34] + 6.191666666666702 * sp[35] + -1.875000000000014 * sp[29] + -0.6083333333333306 * sp[32] + -0.6083333333333384 * sp[28] + -1.875000000000014 * sp[29] + 0.8583333333333408 * sp[26] + 0.3583333333333331 * sp[27] + -0.6083333333333366 * sp[31] + -0.6083333333333306 * sp[32] + 0.3583333333333331 * sp[27] + 2.633333333333344 * sp[30];
    A[33] = -1.00833333333334 * sp[33] + -1.150000000000006 * sp[34] + -1.116666666666673 * sp[28] + -1.150000000000004 * sp[31] + -2.19166666666668 * sp[34] + -3.170833333333351 * sp[35] + -1.154166666666677 * sp[29] + -2.133333333333344 * sp[32] + 1.10833333333334 * sp[28] + 1.479166666666676 * sp[29] + 0.3625000000000092 * sp[26] + 0.7333333333333416 * sp[27] + 1.108333333333335 * sp[31] + 1.108333333333329 * sp[32] + 1.108333333333344 * sp[27] + 1.09166666666667 * sp[30];
    A[34] = 1.266666666666672 * sp[33] + 2.133333333333344 * sp[34] + 0.9000000000000004 * sp[28] + 2.133333333333338 * sp[31] + 3.383333333333349 * sp[34] + 7.258333333333369 * sp[35] + 1.058333333333333 * sp[29] + 4.933333333333344 * sp[32] + -1.216666666666674 * sp[28] + -2.375000000000014 * sp[29] + -0.3083333333333391 * sp[26] + -1.466666666666678 * sp[27] + -1.216666666666671 * sp[31] + -1.216666666666662 * sp[32] + -1.216666666666676 * sp[27] + -2.600000000000014 * sp[30];
    A[35] = 0.4083333333333349 * sp[33] + -0.9833333333333405 * sp[34] + 0.7166666666666694 * sp[28] + -0.9833333333333398 * sp[31] + 1.391666666666673 * sp[34] + -4.295833333333356 * sp[35] + 2.887500000000012 * sp[29] + -2.800000000000014 * sp[32] + -0.3083333333333369 * sp[28] + 1.187500000000012 * sp[29] + -0.7625000000000074 * sp[26] + 0.733333333333346 * sp[27] + -0.3083333333333367 * sp[31] + -0.3083333333333385 * sp[32] + -0.3083333333333353 * sp[27] + 1.508333333333338 * sp[30];
    A[36] = -0.5083333333333317 * sp[33] + -0.6916666666666618 * sp[34] + -0.6916666666666711 * sp[28] + -0.6916666666666689 * sp[31] + 0.2666666666666718 * sp[34] + 1.095833333333357 * sp[35] + -1.520833333333346 * sp[29] + -0.6916666666666663 * sp[32] + 0.4666666666666724 * sp[28] + 0.1124999999999994 * sp[29] + 1.295833333333341 * sp[26] + 0.9416666666666704 * sp[27] + 0.6500000000000015 * sp[31] + 2.283333333333355 * sp[32] + 0.649999999999998 * sp[27] + 1.591666666666676 * sp[30];
    A[37] = 0.6000000000000029 * sp[33] + 0.3833333333333339 * sp[34] + 0.3833333333333362 * sp[28] + 0.3833333333333365 * sp[31] + 0.133333333333338 * sp[34] + -0.4416666666666683 * sp[35] + 0.9583333333333428 * sp[29] + 0.3833333333333405 * sp[32] + -0.9333333333333476 * sp[28] + -0.1416666666666699 * sp[29] + -1.675000000000014 * sp[26] + -0.8833333333333395 * sp[27] + 0.5333333333333332 * sp[31] + 0.09999999999999087 * sp[32] + 0.5333333333333408 * sp[27] + 0.06666666666666143 * sp[30];
    A[38] = -0.0916666666666683 * sp[33] + -0.1083333333333378 * sp[34] + -0.1083333333333337 * sp[28] + -0.1083333333333368 * sp[31] + -0.4000000000000021 * sp[34] + 0.6374999999999993 * sp[35] + -1.145833333333338 * sp[29] + -0.108333333333337 * sp[32] + 0.4666666666666733 * sp[28] + -0.5125000000000017 * sp[29] + 0.8375000000000093 * sp[26] + -0.1416666666666689 * sp[27] + -1.183333333333335 * sp[31] + 2.116666666666675 * sp[32] + -1.183333333333338 * sp[27] + 1.00833333333334 * sp[30];
    A[39] = 4.006938426723791 * sp[33] + 5.185449728701373 * sp[34] + -0.4714045207910348 * sp[28] + -0.4714045207910292 * sp[31] + 10.13519719700723 * sp[34] + 7.660323462854288 * sp[35] + 2.003469213361875 * sp[29] + -0.4714045207910499 * sp[32] + -4.006938426723797 * sp[28] + -3.181980515339482 * sp[29] + 2.47487373415293 * sp[26] + 3.29983164553725 * sp[27] + -4.006938426723783 * sp[31] + -16.73486048808168 * sp[32] + 1.649915822768599 * sp[27] + -5.8925565098879 * sp[30];
    A[40] = -0.5773502691895827 * sp[33] + -0.7216878364869836 * sp[34] + -3.319764047840371 * sp[28] + -3.319764047840348 * sp[31] + 4.474464586219635 * sp[34] + 4.041451884327476 * sp[35] + -2.886751345948176 * sp[29] + -3.319764047840353 * sp[32] + -0.7216878364870394 * sp[28] + 6.928203230275546 * sp[26] + 7.649891066762594 * sp[27] + -0.7216878364870225 * sp[31] + -5.051814855409166 * sp[32] + 6.206515393788468 * sp[27] + -0.5773502691896102 * sp[30];
    A[41] = 4.833333333333358 * sp[33] + 2.416666666666691 * sp[34] + -4.083333333333361 * sp[28] + -4.083333333333345 * sp[31] + 14.91666666666675 * sp[34] + 22.91666666666678 * sp[35] + -12.08333333333341 * sp[29] + -4.083333333333294 * sp[32] + -4.083333333333372 * sp[28] + -5.750000000000016 * sp[29] + 3.250000000000018 * sp[26] + 1.583333333333316 * sp[27] + -4.08333333333337 * sp[31] + 11.41666666666674 * sp[32] + 4.916666666666671 * sp[27] + 19.83333333333339 * sp[30];
    A[42] = -5.89255650988792 * sp[33] + -4.006938426723786 * sp[34] + 0.2357022603955412 * sp[28] + 1.649915822768633 * sp[31] + -17.44196726926825 * sp[34] + -10.72445284799604 * sp[35] + -5.06759859850356 * sp[29] + 1.649915822768647 * sp[32] + 5.185449728701389 * sp[28] + 3.88908729652602 * sp[29] + -1.767766952966387 * sp[26] + -3.064129385141751 * sp[27] + 5.18544972870138 * sp[31] + 5.185449728701363 * sp[32] + -0.4714045207910238 * sp[27] + -1.649915822768615 * sp[30];
    A[43] = -3.897114317029995 * sp[33] + -3.031088913245561 * sp[34] + -3.031088913245561 * sp[28] + -0.4330127018922288 * sp[31] + -5.196152422706633 * sp[34] + -4.113620667976138 * sp[35] + -1.515544456622852 * sp[29] + -0.4330127018922545 * sp[32] + 5.196152422706639 * sp[28] + 5.412658773652788 * sp[29] + -2.381569860407203 * sp[26] + -2.165063509461089 * sp[27] + 5.19615242270662 * sp[31] + 5.196152422706607 * sp[32] + -1.732050807568821 * sp[27] + 0.4330127018921683 * sp[30];
    A[44] = -10.41666666666671 * sp[33] + -7.08333333333336 * sp[34] + -4.083333333333329 * sp[28] + -0.5833333333333175 * sp[31] + -30.83333333333346 * sp[34] + -18.95833333333343 * sp[35] + -12.45833333333334 * sp[29] + -0.5833333333333943 * sp[32] + 9.166666666666735 * sp[28] + 6.875000000000011 * sp[29] + 3.375000000000046 * sp[26] + 1.083333333333329 * sp[27] + 9.166666666666725 * sp[31] + 9.166666666666696 * sp[32] + 0.1666666666666976 * sp[27] + -12.91666666666666 * sp[30];
    A[45] = -1.591666666666673 * sp[33] + -0.9416666666666758 * sp[34] + 0.6916666666666711 * sp[28] + 0.6916666666666693 * sp[31] + -0.650000000000003 * sp[34] + -1.295833333333348 * sp[35] + 1.520833333333352 * sp[29] + 0.6916666666666739 * sp[32] + -2.283333333333346 * sp[28] + -0.1125000000000039 * sp[29] + -1.095833333333331 * sp[26] + 0.6916666666666709 * sp[27] + -0.6500000000000106 * sp[31] + -0.4666666666666743 * sp[32] + -0.2666666666666583 * sp[27] + 0.5083333333333409 * sp[30];
    A[46] = -0.06666666666666718 * sp[33] + 0.4666666666666806 * sp[34] + 0.03333333333332844 * sp[28] + 0.03333333333333327 * sp[31] + -0.9500000000000026 * sp[34] + 1.258333333333355 * sp[35] + -0.708333333333347 * sp[29] + 0.03333333333333999 * sp[32] + 0.3166666666666718 * sp[28] + -0.1083333333333288 * sp[29] + 0.8583333333333275 * sp[26] + 0.03333333333332261 * sp[27] + -0.9499999999999935 * sp[31] + 0.6833333333333441 * sp[32] + 0.1166666666666589 * sp[27] + -0.1833333333333409 * sp[30];
    A[47] = -1.00833333333334 * sp[33] + -2.19166666666668 * sp[34] + 1.10833333333334 * sp[28] + 1.108333333333335 * sp[31] + -1.150000000000006 * sp[34] + -3.170833333333351 * sp[35] + 1.479166666666676 * sp[29] + 1.108333333333329 * sp[32] + -1.116666666666673 * sp[28] + -1.154166666666677 * sp[29] + 0.3625000000000092 * sp[26] + 1.108333333333344 * sp[27] + -1.150000000000004 * sp[31] + -2.133333333333344 * sp[32] + 0.7333333333333416 * sp[27] + 1.09166666666667 * sp[30];
    A[48] = 2.633333333333343 * sp[33] + 2.275000000000007 * sp[34] + 3.24166666666668 * sp[28] + 2.275000000000008 * sp[31] + 2.275000000000007 * sp[34] + 2.77500000000001 * sp[35] + 1.008333333333341 * sp[29] + 1.50833333333334 * sp[32] + 3.24166666666668 * sp[28] + 1.008333333333341 * sp[29] + 10.04166666666667 * sp[26] + 5.508333333333336 * sp[27] + 2.275000000000008 * sp[31] + 1.50833333333334 * sp[32] + 5.508333333333336 * sp[27] + 3.683333333333332 * sp[30];
    A[49] = -2.016666666666675 * sp[33] + -3.133333333333346 * sp[34] + -1.400000000000004 * sp[28] + -3.133333333333336 * sp[31] + -2.300000000000008 * sp[34] + -4.216666666666682 * sp[35] + -0.6833333333333362 * sp[29] + -2.600000000000002 * sp[32] + -2.233333333333341 * sp[28] + -1.683333333333344 * sp[29] + -5.083333333333326 * sp[26] + -7.933333333333325 * sp[27] + -2.300000000000003 * sp[31] + -2.766666666666675 * sp[32] + -3.433333333333324 * sp[27] + -5.866666666666656 * sp[30];
    A[50] = -0.03333333333333645 * sp[33] + 0.8583333333333436 * sp[34] + 0.1583333333333303 * sp[28] + 0.8583333333333442 * sp[31] + -0.4750000000000041 * sp[34] + 1.691666666666683 * sp[35] + -1.075000000000008 * sp[29] + 1.091666666666681 * sp[32] + 0.1583333333333323 * sp[28] + 0.2583333333333372 * sp[29] + 1.624999999999996 * sp[26] + 2.424999999999996 * sp[27] + -0.4749999999999998 * sp[31] + 1.091666666666675 * sp[32] + -0.2416666666666686 * sp[27] + 2.183333333333334 * sp[30];
    A[51] = 1.508333333333332 * sp[33] + 1.81666666666666 * sp[34] + 1.816666666666672 * sp[28] + 1.816666666666668 * sp[31] + 0.7750000000000026 * sp[34] + 0.320833333333322 * sp[35] + 2.270833333333343 * sp[29] + 1.816666666666668 * sp[32] + 4.308333333333324 * sp[28] + 7.504166666666658 * sp[29] + 0.3208333333333422 * sp[26] + 1.816666666666672 * sp[27] + 2.591666666666658 * sp[31] + 4.308333333333317 * sp[32] + 0.7750000000000079 * sp[27] + 1.508333333333335 * sp[30];
    A[52] = -2.600000000000006 * sp[33] + -1.383333333333333 * sp[34] + -1.383333333333339 * sp[28] + -1.383333333333335 * sp[31] + -1.133333333333348 * sp[34] + -0.2250000000000025 * sp[35] + -2.291666666666686 * sp[29] + -1.383333333333342 * sp[32] + -7.533333333333332 * sp[28] + -5.258333333333325 * sp[29] + 0.9416666666666592 * sp[26] + -1.383333333333335 * sp[27] + -3.933333333333337 * sp[31] + -2.866666666666663 * sp[32] + 0.03333333333332233 * sp[27] + -1.016666666666673 * sp[30];
    A[53] = 1.091666666666672 * sp[33] + -0.01666666666666677 * sp[34] + -0.01666666666666405 * sp[28] + -0.01666666666666798 * sp[31] + 0.3583333333333426 * sp[34] + -0.3875000000000038 * sp[35] + 0.7291666666666791 * sp[29] + -0.01666666666667033 * sp[32] + 3.225000000000005 * sp[28] + 0.962499999999999 * sp[29] + -1.054166666666662 * sp[26] + -0.01666666666666172 * sp[27] + 1.341666666666673 * sp[31] + 0.558333333333336 * sp[32] + -0.3083333333333271 * sp[27] + 0.09166666666667227 * sp[30];
    A[54] = -7.542472332656542 * sp[33] + -8.720983634634104 * sp[34] + 4.006938426723768 * sp[28] + 4.006938426723776 * sp[31] + -7.778174593052055 * sp[34] + -8.249579113843042 * sp[35] + 4.47834294751482 * sp[29] + 4.006938426723815 * sp[32] + -8.720983634634122 * sp[28] + -12.96362432175341 * sp[29] + -0.2357022603955241 * sp[26] + 4.006938426723748 * sp[27] + -7.778174593052043 * sp[31] + -11.07800623858924 * sp[32] + 0.2357022603955206 * sp[27] + 2.357022603955157 * sp[30];
    A[55] = -5.917840259193728 * sp[33] + 0.7216878364869882 * sp[34] + 11.98001808568477 * sp[28] + 11.98001808568475 * sp[31] + -0.8660254037844592 * sp[34] + -2.237232293109831 * sp[35] + 13.35122497501015 * sp[29] + 11.9800180856848 * sp[32] + -11.83568051838747 * sp[28] + 18.25870226312183 * sp[29] + 2.670244995002061 * sp[26] + 11.98001808568473 * sp[27] + -0.8660254037845609 * sp[31] + 10.96965511460279 * sp[32] + 4.041451884327416 * sp[27] + 8.804591605141788 * sp[30];
    A[56] = -3.58333333333337 * sp[33] + -4.916666666666707 * sp[34] + 6.583333333333362 * sp[28] + 6.583333333333328 * sp[31] + -7.000000000000044 * sp[34] + -7.708333333333372 * sp[35] + 7.29166666666668 * sp[29] + 6.58333333333327 * sp[32] + -2.666666666666693 * sp[28] + 4.458333333333243 * sp[29] + 5.458333333333393 * sp[26] + 6.583333333333381 * sp[27] + -7.000000000000012 * sp[31] + 2.166666666666591 * sp[32] + 6.1666666666667 * sp[27] + 6.916666666666661 * sp[30];
    A[57] = 5.892556509887932 * sp[33] + 7.542472332656516 * sp[34] + -10.84230397819377 * sp[28] + -5.185449728701391 * sp[31] + 9.19238815542516 * sp[34] + 8.367430244040809 * sp[35] + -4.360491817317075 * sp[29] + -5.185449728701417 * sp[32] + 5.421151989096883 * sp[28] + 5.067598598503618 * sp[29] + -18.97403196183908 * sp[26] + -5.18544972870136 * sp[27] + 9.192388155425123 * sp[31] + 5.892556509887902 * sp[32] + -6.835365551470019 * sp[27] + -4.006938426723801 * sp[30];
    A[58] = 16.88749537379659 * sp[33] + 9.526279441628866 * sp[34] + 9.526279441628859 * sp[28] + -1.732050807568853 * sp[31] + 11.69134295108993 * sp[34] + 10.60881119635944 * sp[35] + -0.6495190528383219 * sp[29] + -1.732050807568856 * sp[32] + 22.08364779650326 * sp[28] + 2.814582562299453 * sp[29] + 36.58957330989254 * sp[26] + -1.732050807568895 * sp[27] + 11.69134295108997 * sp[31] + 3.897114317030008 * sp[32] + 19.48557158514987 * sp[27] + 0.4330127018922156 * sp[30];
    A[59] = 10.41666666666673 * sp[33] + 13.33333333333334 * sp[34] + 0.3333333333333397 * sp[28] + 1.833333333333303 * sp[31] + 16.25000000000007 * sp[34] + 14.79166666666665 * sp[35] + 3.291666666666705 * sp[29] + 1.833333333333343 * sp[32] + 9.583333333333377 * sp[28] + 8.958333333333389 * sp[29] + 7.458333333333284 * sp[26] + 1.833333333333285 * sp[27] + 16.25000000000001 * sp[31] + 10.41666666666667 * sp[32] + 9.416666666666625 * sp[27] + 2.916666666666629 * sp[30];
    A[60] = -0.06666666666666055 * sp[33] + 0.8833333333333415 * sp[34] + -0.383333333333336 * sp[28] + -0.3833333333333396 * sp[31] + -0.5333333333333299 * sp[34] + 1.675000000000014 * sp[35] + -0.9583333333333426 * sp[29] + -0.3833333333333419 * sp[32] + -0.09999999999998943 * sp[28] + 0.1416666666666706 * sp[29] + 0.4416666666666627 * sp[26] + -0.3833333333333412 * sp[27] + -0.5333333333333296 * sp[31] + 0.9333333333333329 * sp[32] + -0.1333333333333335 * sp[27] + -0.6000000000000082 * sp[30];
    A[61] = 1.633333333333332 * sp[33] + -1.433333333333346 * sp[34] + 0.4333333333333363 * sp[28] + 0.4333333333333427 * sp[31] + 3.066666666666672 * sp[34] + -3.683333333333361 * sp[35] + 1.583333333333344 * sp[29] + 0.4333333333333364 * sp[32] + 1.19999999999999 * sp[28] + -0.2833333333333348 * sp[29] + -0.2166666666666634 * sp[26] + 0.4333333333333488 * sp[27] + 3.066666666666663 * sp[31] + -2.533333333333333 * sp[32] + 0.9333333333333411 * sp[27] + 1.200000000000025 * sp[30];
    A[62] = 1.266666666666672 * sp[33] + 3.383333333333349 * sp[34] + -1.216666666666674 * sp[28] + -1.216666666666671 * sp[31] + 2.133333333333344 * sp[34] + 7.258333333333369 * sp[35] + -2.375000000000014 * sp[29] + -1.216666666666662 * sp[32] + 0.9000000000000004 * sp[28] + 1.058333333333333 * sp[29] + -0.3083333333333391 * sp[26] + -1.216666666666676 * sp[27] + 2.133333333333338 * sp[31] + 4.933333333333344 * sp[32] + -1.466666666666678 * sp[27] + -2.600000000000014 * sp[30];
    A[63] = -2.016666666666675 * sp[33] + -2.300000000000008 * sp[34] + -2.233333333333341 * sp[28] + -2.300000000000003 * sp[31] + -3.133333333333346 * sp[34] + -4.216666666666682 * sp[35] + -1.683333333333344 * sp[29] + -2.766666666666675 * sp[32] + -1.400000000000004 * sp[28] + -0.6833333333333362 * sp[29] + -5.083333333333326 * sp[26] + -3.433333333333324 * sp[27] + -3.133333333333336 * sp[31] + -2.600000000000002 * sp[32] + -7.933333333333325 * sp[27] + -5.866666666666656 * sp[30];
    A[64] = 2.53333333333334 * sp[33] + 4.266666666666682 * sp[34] + 1.799999999999997 * sp[28] + 4.266666666666668 * sp[31] + 4.266666666666682 * sp[34] + 8.766666666666707 * sp[35] + 1.366666666666665 * sp[29] + 5.866666666666675 * sp[32] + 1.799999999999997 * sp[28] + 1.366666666666665 * sp[29] + 3.833333333333317 * sp[26] + 5.866666666666648 * sp[27] + 4.266666666666668 * sp[31] + 5.866666666666675 * sp[32] + 5.866666666666648 * sp[27] + 11.73333333333332 * sp[30];
    A[65] = 0.8166666666666691 * sp[33] + -1.966666666666678 * sp[34] + 1.433333333333337 * sp[28] + -1.966666666666677 * sp[31] + 1.53333333333334 * sp[34] + -4.716666666666694 * sp[35] + 3.150000000000013 * sp[29] + -3.100000000000021 * sp[32] + 0.5999999999999975 * sp[28] + -0.5166666666666659 * sp[29] + 0.4166666666666662 * sp[26] + -2.433333333333326 * sp[27] + 1.533333333333337 * sp[31] + -3.266666666666669 * sp[32] + 2.066666666666678 * sp[27] + -5.866666666666662 * sp[30];
    A[66] = -1.016666666666661 * sp[33] + -1.38333333333332 * sp[34] + -1.383333333333339 * sp[28] + -1.383333333333335 * sp[31] + 0.03333333333334115 * sp[34] + 0.9416666666666937 * sp[35] + -2.291666666666678 * sp[29] + -1.383333333333331 * sp[32] + -2.866666666666655 * sp[28] + -5.258333333333314 * sp[29] + -0.2250000000000056 * sp[26] + -1.383333333333336 * sp[27] + -3.93333333333331 * sp[31] + -7.533333333333307 * sp[32] + -1.133333333333337 * sp[27] + -2.600000000000002 * sp[30];
    A[67] = 1.200000000000001 * sp[33] + 0.7666666666666651 * sp[34] + 0.7666666666666702 * sp[28] + 0.7666666666666708 * sp[31] + 0.2666666666666729 * sp[34] + -0.383333333333336 * sp[35] + 1.416666666666677 * sp[29] + 0.7666666666666734 * sp[32] + 3.733333333333326 * sp[28] + 3.01666666666666 * sp[29] + -0.3833333333333272 * sp[26] + 0.7666666666666717 * sp[27] + 5.866666666666648 * sp[31] + 3.733333333333318 * sp[32] + 0.2666666666666663 * sp[27] + 1.200000000000002 * sp[30];
    A[68] = -0.1833333333333347 * sp[33] + -0.2166666666666759 * sp[34] + -0.216666666666667 * sp[28] + -0.2166666666666737 * sp[31] + -0.3000000000000051 * sp[34] + 0.5249999999999974 * sp[35] + -1.041666666666674 * sp[29] + -0.2166666666666709 * sp[32] + -0.8666666666666665 * sp[28] + -1.008333333333343 * sp[29] + 0.3583333333333317 * sp[26] + -0.2166666666666778 * sp[27] + -1.933333333333327 * sp[31] + -1.533333333333347 * sp[32] + -0.466666666666669 * sp[27] + -0.6000000000000172 * sp[30];
    A[69] = 8.013876853447567 * sp[33] + 10.37089945740273 * sp[34] + -0.9428090415820647 * sp[28] + -0.9428090415820513 * sp[31] + 13.19932658214894 * sp[34] + 11.7851130197758 * sp[35] + 0.4714045207910287 * sp[29] + -0.9428090415820797 * sp[32] + 5.656854249492382 * sp[28] + 11.7851130197758 * sp[29] + 0.4714045207910273 * sp[26] + -0.9428090415820357 * sp[27] + 13.19932658214889 * sp[31] + 24.5130350811337 * sp[32] + 1.885618083164152 * sp[27];
    A[70] = -1.154700538379169 * sp[33] + -1.44337567297396 * sp[34] + -6.639528095680724 * sp[28] + -6.639528095680678 * sp[31] + 4.618802153517086 * sp[34] + 5.917840259193782 * sp[35] + -7.938566201357389 * sp[29] + -6.639528095680689 * sp[32] + -5.196152422706515 * sp[28] + -14.86676943163273 * sp[29] + -1.010362971081874 * sp[26] + -6.639528095680661 * sp[27] + 4.618802153517127 * sp[31] + -16.16580753730935 * sp[32] + -2.309401076758486 * sp[27] + -10.39230484541318 * sp[30];
    A[71] = 9.666666666666703 * sp[33] + 4.833333333333372 * sp[34] + -8.166666666666707 * sp[28] + -8.166666666666679 * sp[31] + 17.33333333333342 * sp[34] + 24.58333333333346 * sp[35] + -15.41666666666674 * sp[29] + -8.166666666666611 * sp[32] + 6.999999999999985 * sp[28] + -11.41666666666663 * sp[29] + -3.416666666666694 * sp[26] + -8.1666666666667 * sp[27] + 17.33333333333337 * sp[31] + -2.66666666666661 * sp[32] + -10.66666666666674 * sp[27] + -18.00000000000005 * sp[30];
    A[72] = -11.78511301977582 * sp[33] + -8.01387685344756 * sp[34] + 0.4714045207910718 * sp[28] + 3.299831645537258 * sp[31] + -20.74179891480548 * sp[34] + -14.37783788412652 * sp[35] + -3.06412938514167 * sp[29] + 3.29983164553727 * sp[32] + -8.485281374238545 * sp[28] + -3.064129385141705 * sp[29] + 2.592724864350726 * sp[26] + 3.299831645537241 * sp[27] + -20.74179891480541 * sp[31] + -9.42809041582068 * sp[32] + 1.885618083164133 * sp[27] + 5.656854249492373 * sp[30];
    A[73] = -7.794228634059968 * sp[33] + -6.062177826491108 * sp[34] + -6.062177826491103 * sp[28] + -0.8660254037844588 * sp[31] + -10.39230484541325 * sp[34] + -8.227241335952218 * sp[35] + -3.031088913245603 * sp[29] + -0.866025403784471 * sp[32] + -5.196152422706671 * sp[28] + -1.299038105676685 * sp[29] + -16.88749537379653 * sp[26] + -0.8660254037844314 * sp[27] + -10.39230484541322 * sp[31] + -3.464101615137746 * sp[32] + -17.32050807568879 * sp[27] + 3.464101615137788 * sp[30];
    A[74] = -20.83333333333339 * sp[33] + -14.16666666666669 * sp[34] + -8.16666666666665 * sp[28] + -1.166666666666629 * sp[31] + -36.6666666666668 * sp[34] + -25.41666666666673 * sp[35] + -12.41666666666669 * sp[29] + -1.166666666666685 * sp[32] + -14.99999999999995 * sp[28] + -5.41666666666667 * sp[29] + -12.41666666666659 * sp[26] + -1.166666666666611 * sp[27] + -36.6666666666667 * sp[31] + -16.66666666666674 * sp[32] + -24.6666666666666 * sp[27] + 10.00000000000004 * sp[30];
    A[75] = -1.008333333333332 * sp[33] + 0.141666666666669 * sp[34] + 0.1083333333333315 * sp[28] + 0.1083333333333288 * sp[31] + 1.183333333333331 * sp[34] + -0.8375000000000078 * sp[35] + 1.145833333333341 * sp[29] + 0.1083333333333398 * sp[32] + -2.116666666666667 * sp[28] + 0.5125000000000066 * sp[29] + -0.6375000000000115 * sp[26] + 0.108333333333324 * sp[27] + 1.183333333333329 * sp[31] + -0.4666666666666683 * sp[32] + 0.4000000000000077 * sp[27] + 0.09166666666667565 * sp[30];
    A[76] = 1.266666666666666 * sp[33] + -0.8666666666666695 * sp[34] + 0.3666666666666673 * sp[28] + 0.3666666666666731 * sp[31] + -2.116666666666671 * sp[34] + 3.008333333333342 * sp[35] + -1.958333333333339 * sp[29] + 0.3666666666666698 * sp[32] + 2.483333333333335 * sp[28] + -2.02500000000001 * sp[29] + 1.275000000000007 * sp[26] + 0.3666666666666729 * sp[27] + -2.116666666666669 * sp[31] + 1.849999999999993 * sp[32] + -1.050000000000005 * sp[27] + -1.01666666666667 * sp[30];
    A[77] = 0.4083333333333349 * sp[33] + 1.391666666666673 * sp[34] + -0.3083333333333369 * sp[28] + -0.3083333333333367 * sp[31] + -0.9833333333333405 * sp[34] + -4.295833333333356 * sp[35] + 1.187500000000012 * sp[29] + -0.3083333333333385 * sp[32] + 0.7166666666666694 * sp[28] + 2.887500000000012 * sp[29] + -0.7625000000000074 * sp[26] + -0.3083333333333353 * sp[27] + -0.9833333333333398 * sp[31] + -2.800000000000014 * sp[32] + 0.733333333333346 * sp[27] + 1.508333333333338 * sp[30];
    A[78] = -0.03333333333333645 * sp[33] + -0.4750000000000041 * sp[34] + 0.1583333333333323 * sp[28] + -0.4749999999999998 * sp[31] + 0.8583333333333436 * sp[34] + 1.691666666666683 * sp[35] + 0.2583333333333372 * sp[29] + 1.091666666666675 * sp[32] + 0.1583333333333303 * sp[28] + -1.075000000000008 * sp[29] + 1.624999999999996 * sp[26] + -0.2416666666666686 * sp[27] + 0.8583333333333442 * sp[31] + 1.091666666666681 * sp[32] + 2.424999999999996 * sp[27] + 2.183333333333334 * sp[30];
    A[79] = 0.8166666666666691 * sp[33] + 1.53333333333334 * sp[34] + 0.5999999999999975 * sp[28] + 1.533333333333337 * sp[31] + -1.966666666666678 * sp[34] + -4.716666666666694 * sp[35] + -0.5166666666666659 * sp[29] + -3.266666666666669 * sp[32] + 1.433333333333337 * sp[28] + 3.150000000000013 * sp[29] + 0.4166666666666662 * sp[26] + 2.066666666666678 * sp[27] + -1.966666666666677 * sp[31] + -3.100000000000021 * sp[32] + -2.433333333333326 * sp[27] + -5.866666666666662 * sp[30];
    A[80] = 0.633333333333334 * sp[33] + -1.058333333333337 * sp[34] + 1.241666666666669 * sp[28] + -1.058333333333336 * sp[31] + -1.058333333333337 * sp[34] + 3.441666666666679 * sp[35] + -2.32500000000001 * sp[29] + 2.175 * sp[32] + 1.241666666666669 * sp[28] + -2.32500000000001 * sp[29] + 2.708333333333341 * sp[26] + -1.82500000000001 * sp[27] + -1.058333333333336 * sp[31] + 2.175 * sp[32] + -1.82500000000001 * sp[27] + 3.683333333333319 * sp[30];
    A[81] = 0.0916666666666681 * sp[33] + -0.01666666666666239 * sp[34] + -0.01666666666667042 * sp[28] + -0.01666666666666917 * sp[31] + -0.3083333333333335 * sp[34] + -1.054166666666687 * sp[35] + 0.7291666666666795 * sp[29] + -0.01666666666666594 * sp[32] + 0.5583333333333299 * sp[28] + 0.9625000000000036 * sp[29] + -0.3875000000000076 * sp[26] + -0.0166666666666711 * sp[27] + 1.341666666666661 * sp[31] + 3.224999999999986 * sp[32] + 0.3583333333333474 * sp[27] + 1.091666666666677 * sp[30];
    A[82] = -0.5999999999999994 * sp[33] + -0.2166666666666656 * sp[34] + -0.2166666666666639 * sp[28] + -0.2166666666666621 * sp[31] + -0.4666666666666697 * sp[34] + 0.3583333333333333 * sp[35] + -1.041666666666679 * sp[29] + -0.2166666666666744 * sp[32] + -1.533333333333323 * sp[28] + -1.008333333333328 * sp[29] + 0.5250000000000123 * sp[26] + -0.216666666666656 * sp[27] + -1.933333333333326 * sp[31] + -0.8666666666666645 * sp[32] + -0.3000000000000118 * sp[27] + -0.1833333333333457 * sp[30];
    A[83] = 0.5083333333333342 * sp[33] + -0.1833333333333398 * sp[34] + -0.1833333333333333 * sp[28] + -0.1833333333333392 * sp[31] + 0.7749999999999981 * sp[34] + -1.012500000000006 * sp[35] + 1.604166666666671 * sp[29] + -0.183333333333334 * sp[32] + 0.9749999999999973 * sp[28] + 0.170833333333325 * sp[29] + -1.012500000000006 * sp[26] + -0.1833333333333405 * sp[27] + 0.5916666666666606 * sp[31] + 0.9749999999999956 * sp[32] + 0.7750000000000028 * sp[27] + 0.5083333333333377 * sp[30];
    A[84] = 1.885618083164136 * sp[33] + 3.064129385141727 * sp[34] + 1.649915822768603 * sp[28] + 1.649915822768615 * sp[31] + -5.4211519890969 * sp[34] + -1.178511301977577 * sp[35] + -2.592724864350651 * sp[29] + 1.649915822768645 * sp[32] + 3.064129385141719 * sp[28] + 3.535533905932764 * sp[29] + 2.121320343559622 * sp[26] + 1.649915822768596 * sp[27] + -5.421151989096896 * sp[31] + -13.43502884254442 * sp[32] + -2.121320343559619 * sp[27] + -2.357022603955127 * sp[30];
    A[85] = -4.474464586219581 * sp[33] + -0.7216878364869885 * sp[34] + 1.876388374866266 * sp[28] + 1.87638837486629 * sp[31] + -3.752776749732498 * sp[34] + -0.07216878364874507 * sp[35] + -1.804219591217519 * sp[29] + 1.87638837486632 * sp[32] + -8.948929172439193 * sp[28] + 0.216506350946152 * sp[29] + 1.948557158514959 * sp[26] + 1.876388374866266 * sp[27] + -3.752776749732497 * sp[31] + 5.196152422706604 * sp[32] + -1.732050807568805 * sp[27] + 1.587713240271532 * sp[30];
    A[86] = 5.583333333333346 * sp[33] + 0.9166666666666721 * sp[34] + -2.583333333333353 * sp[28] + -2.583333333333347 * sp[31] + -10.33333333333339 * sp[34] + -18.95833333333339 * sp[35] + 6.04166666666673 * sp[29] + -2.583333333333386 * sp[32] + 10.66666666666669 * sp[28] + 4.874999999999995 * sp[29] + -4.125000000000018 * sp[26] + -2.583333333333326 * sp[27] + -10.33333333333338 * sp[31] + 0.5 * sp[32] + 4.500000000000068 * sp[27] + 11.08333333333333 * sp[30];
    A[87] = -5.892556509887907 * sp[33] + -1.885618083164143 * sp[34] + -6.128258770283397 * sp[28] + -0.4714045207910201 * sp[31] + 11.54941075938033 * sp[34] + 4.83189633810814 * sp[35] + 6.24610990048115 * sp[29] + -0.4714045207910558 * sp[32] + -11.07800623858927 * sp[28] + -3.18198051533948 * sp[29] + -13.08147545195111 * sp[26] + -0.4714045207909976 * sp[27] + 11.54941075938032 * sp[31] + 3.535533905932823 * sp[32] + 4.949747468305813 * sp[27] + -1.649915822768619 * sp[30];
    A[88] = 3.897114317029971 * sp[33] + 0.8660254037844235 * sp[34] + 0.8660254037844266 * sp[28] + -1.732050807568876 * sp[31] + -1.299038105676654 * sp[34] + -0.2165063509460481 * sp[35] + -2.814582562299329 * sp[29] + -1.732050807568826 * sp[32] + 9.093266739736631 * sp[28] + 0.6495190528382966 * sp[29] + 8.44374768689827 * sp[26] + -1.732050807568871 * sp[27] + -1.299038105676635 * sp[31] + -0.4330127018921688 * sp[32] + -2.165063509461006 * sp[27] + -3.89711431702999 * sp[30];
    A[89] = -10.41666666666668 * sp[33] + -3.333333333333358 * sp[34] + -6.333333333333325 * sp[28] + 0.1666666666666687 * sp[31] + 20.41666666666676 * sp[34] + 8.541666666666767 * sp[35] + 12.04166666666667 * sp[29] + 0.1666666666668157 * sp[32] + -19.58333333333337 * sp[28] + -5.625000000000016 * sp[29] + -12.12500000000003 * sp[26] + 0.1666666666666603 * sp[27] + 20.41666666666674 * sp[31] + 6.250000000000148 * sp[32] + 15.24999999999998 * sp[27] + -12.91666666666649 * sp[30];
    A[90] = -1.091666666666672 * sp[33] + -0.7333333333333425 * sp[34] + 2.133333333333348 * sp[28] + 1.150000000000004 * sp[31] + -1.10833333333334 * sp[34] + -0.3624999999999933 * sp[35] + 1.154166666666656 * sp[29] + 1.116666666666665 * sp[32] + -1.108333333333335 * sp[28] + -1.479166666666682 * sp[29] + 3.170833333333348 * sp[26] + 1.150000000000003 * sp[27] + -1.108333333333334 * sp[31] + -1.10833333333334 * sp[32] + 2.191666666666672 * sp[27] + 1.008333333333335 * sp[30];
    A[91] = 0.1833333333333404 * sp[33] + -0.1166666666666601 * sp[34] + -0.6833333333333476 * sp[28] + 0.9499999999999976 * sp[31] + -0.0333333333333195 * sp[34] + -0.8583333333333502 * sp[35] + 0.1083333333333337 * sp[29] + -0.3166666666666949 * sp[32] + -0.03333333333333655 * sp[28] + 0.708333333333352 * sp[29] + -1.258333333333346 * sp[26] + 0.950000000000005 * sp[27] + -0.03333333333333399 * sp[31] + -0.03333333333332755 * sp[32] + -0.466666666666673 * sp[27] + 0.06666666666665924 * sp[30];
    A[92] = -0.5083333333333317 * sp[33] + 0.2666666666666718 * sp[34] + 0.4666666666666724 * sp[28] + 0.6500000000000015 * sp[31] + -0.6916666666666618 * sp[34] + 1.095833333333357 * sp[35] + 0.1124999999999994 * sp[29] + 2.283333333333355 * sp[32] + -0.6916666666666711 * sp[28] + -1.520833333333346 * sp[29] + 1.295833333333341 * sp[26] + 0.649999999999998 * sp[27] + -0.6916666666666689 * sp[31] + -0.6916666666666663 * sp[32] + 0.9416666666666704 * sp[27] + 1.591666666666676 * sp[30];
    A[93] = 1.508333333333332 * sp[33] + 0.7750000000000026 * sp[34] + 4.308333333333324 * sp[28] + 2.591666666666658 * sp[31] + 1.81666666666666 * sp[34] + 0.320833333333322 * sp[35] + 7.504166666666658 * sp[29] + 4.308333333333317 * sp[32] + 1.816666666666672 * sp[28] + 2.270833333333343 * sp[29] + 0.3208333333333422 * sp[26] + 0.7750000000000079 * sp[27] + 1.816666666666668 * sp[31] + 1.816666666666668 * sp[32] + 1.816666666666672 * sp[27] + 1.508333333333335 * sp[30];
    A[94] = -1.016666666666661 * sp[33] + 0.03333333333334115 * sp[34] + -2.866666666666655 * sp[28] + -3.93333333333331 * sp[31] + -1.38333333333332 * sp[34] + 0.9416666666666937 * sp[35] + -5.258333333333314 * sp[29] + -7.533333333333307 * sp[32] + -1.383333333333339 * sp[28] + -2.291666666666678 * sp[29] + -0.2250000000000056 * sp[26] + -1.133333333333337 * sp[27] + -1.383333333333335 * sp[31] + -1.383333333333331 * sp[32] + -1.383333333333336 * sp[27] + -2.600000000000002 * sp[30];
    A[95] = 0.0916666666666681 * sp[33] + -0.3083333333333335 * sp[34] + 0.5583333333333299 * sp[28] + 1.341666666666661 * sp[31] + -0.01666666666666239 * sp[34] + -1.054166666666687 * sp[35] + 0.9625000000000036 * sp[29] + 3.224999999999986 * sp[32] + -0.01666666666667042 * sp[28] + 0.7291666666666795 * sp[29] + -0.3875000000000076 * sp[26] + 0.3583333333333474 * sp[27] + -0.01666666666666917 * sp[31] + -0.01666666666666594 * sp[32] + -0.0166666666666711 * sp[27] + 1.091666666666677 * sp[30];
    A[96] = 3.683333333333327 * sp[33] + 5.508333333333313 * sp[34] + 1.508333333333337 * sp[28] + 2.274999999999999 * sp[31] + 5.508333333333313 * sp[34] + 10.04166666666666 * sp[35] + 1.008333333333323 * sp[29] + 3.241666666666668 * sp[32] + 1.508333333333337 * sp[28] + 1.008333333333323 * sp[29] + 2.775000000000005 * sp[26] + 2.275 * sp[27] + 2.274999999999999 * sp[31] + 3.241666666666668 * sp[32] + 2.275 * sp[27] + 2.633333333333337 * sp[30];
    A[97] = -5.866666666666665 * sp[33] + -3.433333333333323 * sp[34] + -2.766666666666682 * sp[28] + -2.300000000000001 * sp[31] + -7.933333333333309 * sp[34] + -5.083333333333313 * sp[35] + -1.683333333333318 * sp[29] + -2.233333333333322 * sp[32] + -2.600000000000011 * sp[28] + -0.6833333333333321 * sp[29] + -4.21666666666668 * sp[26] + -2.300000000000002 * sp[27] + -3.133333333333333 * sp[31] + -1.399999999999996 * sp[32] + -3.133333333333336 * sp[27] + -2.016666666666665 * sp[30];
    A[98] = 2.183333333333337 * sp[33] + -0.2416666666666682 * sp[34] + 1.091666666666678 * sp[28] + -0.475000000000001 * sp[31] + 2.424999999999993 * sp[34] + 1.62500000000002 * sp[35] + 0.258333333333327 * sp[29] + 0.1583333333333475 * sp[32] + 1.091666666666673 * sp[28] + -1.075000000000002 * sp[29] + 1.691666666666676 * sp[26] + -0.475000000000006 * sp[27] + 0.8583333333333335 * sp[31] + 0.1583333333333423 * sp[32] + 0.8583333333333361 * sp[27] + -0.03333333333333138 * sp[30];
    A[99] = -4.006938426723759 * sp[33] + -6.835365551469931 * sp[34] + 5.8925565098879 * sp[28] + 9.192388155425116 * sp[31] + -5.185449728701315 * sp[34] + -18.97403196183908 * sp[35] + 5.067598598503547 * sp[29] + 5.421151989096757 * sp[32] + -5.185449728701375 * sp[28] + -4.360491817317047 * sp[29] + 8.367430244040818 * sp[26] + 9.192388155425137 * sp[27] + -5.185449728701359 * sp[31] + -10.84230397819378 * sp[32] + 7.542472332656498 * sp[27] + 5.892556509887872 * sp[30];
    A[100] = 2.742413778650673 * sp[33] + 17.89785834487831 * sp[34] + 10.96965511460291 * sp[28] + 19.9185842870421 * sp[31] + 0.7216878364868622 * sp[34] + 24.75389279150505 * sp[35] + 9.165435523385243 * sp[29] + 19.34123401785234 * sp[32] + 0.7216878364870287 * sp[28] + 2.525907427704567 * sp[29] + 18.11436469582454 * sp[26] + 19.91858428704214 * sp[27] + 0.7216878364869905 * sp[31] + 5.05181485540917 * sp[32] + 16.31014510460693 * sp[27] + 17.46484564298618 * sp[30];
    A[101] = -1.083333333333311 * sp[33] + 12.16666666666666 * sp[34] + -1.833333333333334 * sp[28] + 1.999999999999981 * sp[31] + -2.416666666666617 * sp[34] + 27.95833333333338 * sp[35] + -2.041666666666651 * sp[29] + 14.33333333333347 * sp[32] + -2.416666666666698 * sp[28] + -2.208333333333339 * sp[29] + 1.791666666666681 * sp[26] + 1.999999999999969 * sp[27] + -2.416666666666683 * sp[31] + 8.083333333333387 * sp[32] + 1.583333333333341 * sp[27] + 9.416666666666718 * sp[30];
    A[102] = 2.357022603955125 * sp[33] + 0.2357022603954775 * sp[34] + -11.07800623858926 * sp[28] + -7.778174593052062 * sp[31] + 4.006938426723697 * sp[34] + -0.2357022603955419 * sp[35] + -12.96362432175338 * sp[29] + -8.720983634634061 * sp[32] + 4.006938426723801 * sp[28] + 4.478342947514787 * sp[29] + -8.249579113843069 * sp[26] + -7.77817459305209 * sp[27] + 4.006938426723781 * sp[31] + 4.006938426723751 * sp[32] + -8.720983634634084 * sp[27] + -7.542472332656548 * sp[30];
    A[103] = 10.39230484541327 * sp[33] + 7.361215932167775 * sp[34] + 7.361215932167664 * sp[28] + -6.495190528383265 * sp[31] + 11.69134295108992 * sp[34] + 6.062177826491039 * sp[35] + 12.99038105676653 * sp[29] + -8.227241335952201 * sp[32] + 11.69134295108993 * sp[28] + 12.99038105676665 * sp[29] + -7.794228634059942 * sp[26] + -6.495190528383231 * sp[27] + 11.69134295108992 * sp[31] + 11.69134295108996 * sp[32] + -3.897114317029998 * sp[27] + -6.062177826491057 * sp[30];
    A[104] = 4.166666666666613 * sp[33] + 0.4166666666666101 * sp[34] + 8.416666666666639 * sp[28] + 2.749999999999956 * sp[31] + 7.083333333333215 * sp[34] + -0.4166666666666909 * sp[35] + 13.58333333333323 * sp[29] + -8.916666666666849 * sp[32] + 7.083333333333389 * sp[28] + 7.916666666666639 * sp[29] + 1.91666666666671 * sp[26] + 2.749999999999976 * sp[27] + 7.083333333333356 * sp[31] + 7.083333333333309 * sp[32] + 3.08333333333335 * sp[27] + -3.33333333333343 * sp[30];
    A[105] = 2.600000000000009 * sp[33] + 1.466666666666682 * sp[34] + -4.933333333333358 * sp[28] + -2.133333333333335 * sp[31] + 1.216666666666668 * sp[34] + 0.3083333333333381 * sp[35] + -1.05833333333333 * sp[29] + -0.8999999999999994 * sp[32] + 1.216666666666669 * sp[28] + 2.375000000000026 * sp[29] + -7.258333333333372 * sp[26] + -2.133333333333338 * sp[27] + 1.216666666666663 * sp[31] + 1.216666666666679 * sp[32] + -3.38333333333334 * sp[27] + -1.266666666666666 * sp[30];
    A[106] = -1.200000000000005 * sp[33] + -0.9333333333333425 * sp[34] + 2.533333333333359 * sp[28] + -3.066666666666672 * sp[31] + -0.4333333333333348 * sp[34] + 0.2166666666666626 * sp[35] + 0.2833333333333353 * sp[29] + -1.199999999999985 * sp[32] + -0.4333333333333315 * sp[28] + -1.583333333333355 * sp[29] + 3.683333333333363 * sp[26] + -3.066666666666684 * sp[27] + -0.4333333333333275 * sp[31] + -0.4333333333333466 * sp[32] + 1.433333333333342 * sp[27] + -1.633333333333329 * sp[30];
    A[107] = 0.6000000000000029 * sp[33] + 0.133333333333338 * sp[34] + -0.9333333333333476 * sp[28] + 0.5333333333333332 * sp[31] + 0.3833333333333339 * sp[34] + -0.4416666666666683 * sp[35] + -0.1416666666666699 * sp[29] + 0.09999999999999087 * sp[32] + 0.3833333333333362 * sp[28] + 0.9583333333333428 * sp[29] + -1.675000000000014 * sp[26] + 0.5333333333333408 * sp[27] + 0.3833333333333365 * sp[31] + 0.3833333333333405 * sp[32] + -0.8833333333333395 * sp[27] + 0.06666666666666143 * sp[30];
    A[108] = -2.600000000000006 * sp[33] + -1.133333333333348 * sp[34] + -7.533333333333332 * sp[28] + -3.933333333333337 * sp[31] + -1.383333333333333 * sp[34] + -0.2250000000000025 * sp[35] + -5.258333333333325 * sp[29] + -2.866666666666663 * sp[32] + -1.383333333333339 * sp[28] + -2.291666666666686 * sp[29] + 0.9416666666666592 * sp[26] + 0.03333333333332233 * sp[27] + -1.383333333333335 * sp[31] + -1.383333333333342 * sp[32] + -1.383333333333335 * sp[27] + -1.016666666666673 * sp[30];
    A[109] = 1.200000000000001 * sp[33] + 0.2666666666666729 * sp[34] + 3.733333333333326 * sp[28] + 5.866666666666648 * sp[31] + 0.7666666666666651 * sp[34] + -0.383333333333336 * sp[35] + 3.01666666666666 * sp[29] + 3.733333333333318 * sp[32] + 0.7666666666666702 * sp[28] + 1.416666666666677 * sp[29] + -0.3833333333333272 * sp[26] + 0.2666666666666663 * sp[27] + 0.7666666666666708 * sp[31] + 0.7666666666666734 * sp[32] + 0.7666666666666717 * sp[27] + 1.200000000000002 * sp[30];
    A[110] = -0.5999999999999994 * sp[33] + -0.4666666666666697 * sp[34] + -1.533333333333323 * sp[28] + -1.933333333333326 * sp[31] + -0.2166666666666656 * sp[34] + 0.3583333333333333 * sp[35] + -1.008333333333328 * sp[29] + -0.8666666666666645 * sp[32] + -0.2166666666666639 * sp[28] + -1.041666666666679 * sp[29] + 0.5250000000000123 * sp[26] + -0.3000000000000118 * sp[27] + -0.2166666666666621 * sp[31] + -0.2166666666666744 * sp[32] + -0.216666666666656 * sp[27] + -0.1833333333333457 * sp[30];
    A[111] = -5.866666666666665 * sp[33] + -7.933333333333309 * sp[34] + -2.600000000000011 * sp[28] + -3.133333333333333 * sp[31] + -3.433333333333323 * sp[34] + -5.083333333333313 * sp[35] + -0.6833333333333321 * sp[29] + -1.399999999999996 * sp[32] + -2.766666666666682 * sp[28] + -1.683333333333318 * sp[29] + -4.21666666666668 * sp[26] + -3.133333333333336 * sp[27] + -2.300000000000001 * sp[31] + -2.233333333333322 * sp[32] + -2.300000000000002 * sp[27] + -2.016666666666665 * sp[30];
    A[112] = 11.73333333333334 * sp[33] + 5.86666666666665 * sp[34] + 5.866666666666694 * sp[28] + 4.266666666666664 * sp[31] + 5.86666666666665 * sp[34] + 3.83333333333332 * sp[35] + 1.366666666666663 * sp[29] + 1.799999999999992 * sp[32] + 5.866666666666694 * sp[28] + 1.366666666666663 * sp[29] + 8.766666666666703 * sp[26] + 4.26666666666667 * sp[27] + 4.266666666666664 * sp[31] + 1.799999999999992 * sp[32] + 4.26666666666667 * sp[27] + 2.533333333333327 * sp[30];
    A[113] = -5.866666666666675 * sp[33] + 2.066666666666682 * sp[34] + -3.266666666666687 * sp[28] + 1.533333333333346 * sp[31] + -2.433333333333326 * sp[34] + 0.4166666666666571 * sp[35] + -0.5166666666666653 * sp[29] + 0.5999999999999945 * sp[32] + -3.100000000000013 * sp[28] + 3.150000000000013 * sp[29] + -4.716666666666693 * sp[26] + 1.533333333333351 * sp[27] + -1.966666666666663 * sp[31] + 1.433333333333328 * sp[32] + -1.966666666666671 * sp[27] + 0.8166666666666692 * sp[30];
    A[114] = 5.656854249492394 * sp[33] + 1.885618083164114 * sp[34] + -9.428090415820641 * sp[28] + -20.74179891480541 * sp[31] + 3.299831645537222 * sp[34] + 2.592724864350696 * sp[35] + -3.064129385141687 * sp[29] + -8.485281374238507 * sp[32] + 3.299831645537243 * sp[28] + -3.064129385141721 * sp[29] + -14.3778378841265 * sp[26] + -20.74179891480546 * sp[27] + 3.299831645537239 * sp[31] + 0.4714045207910678 * sp[32] + -8.013876853447531 * sp[27] + -11.78511301977576 * sp[30];
    A[115] = 10.39230484541329 * sp[33] + -30.02221399786045 * sp[34] + -16.16580753730957 * sp[28] + -36.9504172281361 * sp[31] + -1.443375672974036 * sp[34] + -19.19689645055494 * sp[35] + -5.340489990004029 * sp[29] + -15.58845726811982 * sp[32] + -1.443375672974132 * sp[28] + -12.26869322027951 * sp[29] + -26.12509968083064 * sp[26] + -36.95041722813619 * sp[27] + -1.443375672974094 * sp[31] + -10.10362971081837 * sp[32] + -15.29978213352509 * sp[27] + -21.93931022920577 * sp[30];
    A[116] = -2.000000000000004 * sp[33] + -2.666666666666611 * sp[34] + 5.33333333333329 * sp[28] + 9.333333333333361 * sp[31] + -0.1666666666666645 * sp[34] + -8.416666666666684 * sp[35] + 1.583333333333302 * sp[29] + 2.999999999999945 * sp[32] + -0.1666666666666572 * sp[28] + 3.583333333333312 * sp[29] + 5.58333333333333 * sp[26] + 9.33333333333341 * sp[27] + -0.1666666666666361 * sp[31] + -1.166666666666712 * sp[32] + 1.833333333333307 * sp[27] + 3.666666666666637 * sp[30];
    A[117] = 1.885618083164135 * sp[34] + 24.51303508113368 * sp[28] + 13.19932658214894 * sp[31] + -0.9428090415820565 * sp[34] + 0.4714045207910509 * sp[35] + 11.78511301977577 * sp[29] + 5.656854249492389 * sp[32] + -0.9428090415820791 * sp[28] + 0.4714045207910629 * sp[29] + 11.78511301977582 * sp[26] + 13.199326582149 * sp[27] + -0.9428090415820932 * sp[31] + -0.9428090415820465 * sp[32] + 10.37089945740267 * sp[27] + 8.013876853447586 * sp[30];
    A[118] = -20.78460969082657 * sp[33] + -10.39230484541337 * sp[34] + -10.39230484541323 * sp[28] + 17.32050807568871 * sp[31] + -10.39230484541326 * sp[34] + -3.464101615137777 * sp[35] + -17.32050807568875 * sp[29] + 3.464101615137676 * sp[32] + -10.39230484541328 * sp[28] + -17.32050807568892 * sp[29] + 24.24871130596432 * sp[26] + 17.32050807568868 * sp[27] + -10.39230484541325 * sp[31] + -10.39230484541332 * sp[32] + 3.46410161513777 * sp[27] + 7.794228634059853 * sp[30];
    A[119] = 3.333333333333337 * sp[34] + -12.66666666666666 * sp[28] + -4.666666666666666 * sp[31] + -1.666666666666662 * sp[34] + 0.8333333333333579 * sp[35] + -7.166666666666632 * sp[29] + -7.999999999999927 * sp[32] + -1.666666666666694 * sp[28] + 0.8333333333333881 * sp[29] + -7.166666666666744 * sp[26] + -4.666666666666683 * sp[27] + -1.666666666666723 * sp[31] + -1.666666666666641 * sp[32] + -3.666666666666703 * sp[27] + -5.833333333333274 * sp[30];
    A[120] = -1.508333333333339 * sp[33] + -0.7333333333333388 * sp[34] + 2.800000000000011 * sp[28] + 0.9833333333333305 * sp[31] + 0.3083333333333441 * sp[34] + 0.7625000000000103 * sp[35] + -2.887500000000013 * sp[29] + -0.7166666666666647 * sp[32] + 0.3083333333333312 * sp[28] + -1.187500000000012 * sp[29] + 4.295833333333359 * sp[26] + 0.9833333333333367 * sp[27] + 0.3083333333333438 * sp[31] + 0.3083333333333412 * sp[32] + -1.391666666666683 * sp[27] + -0.408333333333335 * sp[30];
    A[121] = 1.01666666666667 * sp[33] + 1.049999999999999 * sp[34] + -1.85000000000001 * sp[28] + 2.116666666666676 * sp[31] + -0.3666666666666798 * sp[34] + -1.275000000000011 * sp[35] + 2.025000000000009 * sp[29] + -2.48333333333334 * sp[32] + -0.3666666666666659 * sp[28] + 1.95833333333334 * sp[29] + -3.008333333333352 * sp[26] + 2.116666666666677 * sp[27] + -0.3666666666666785 * sp[31] + -0.3666666666666715 * sp[32] + 0.8666666666666755 * sp[27] + -1.266666666666675 * sp[30];
    A[122] = -0.0916666666666683 * sp[33] + -0.4000000000000021 * sp[34] + 0.4666666666666733 * sp[28] + -1.183333333333335 * sp[31] + -0.1083333333333378 * sp[34] + 0.6374999999999993 * sp[35] + -0.5125000000000017 * sp[29] + 2.116666666666675 * sp[32] + -0.1083333333333337 * sp[28] + -1.145833333333338 * sp[29] + 0.8375000000000093 * sp[26] + -1.183333333333338 * sp[27] + -0.1083333333333368 * sp[31] + -0.108333333333337 * sp[32] + -0.1416666666666689 * sp[27] + 1.00833333333334 * sp[30];
    A[123] = 1.091666666666672 * sp[33] + 0.3583333333333426 * sp[34] + 3.225000000000005 * sp[28] + 1.341666666666673 * sp[31] + -0.01666666666666677 * sp[34] + -0.3875000000000038 * sp[35] + 0.962499999999999 * sp[29] + 0.558333333333336 * sp[32] + -0.01666666666666405 * sp[28] + 0.7291666666666791 * sp[29] + -1.054166666666662 * sp[26] + -0.3083333333333271 * sp[27] + -0.01666666666666798 * sp[31] + -0.01666666666667033 * sp[32] + -0.01666666666666172 * sp[27] + 0.09166666666667227 * sp[30];
    A[124] = -0.1833333333333347 * sp[33] + -0.3000000000000051 * sp[34] + -0.8666666666666665 * sp[28] + -1.933333333333327 * sp[31] + -0.2166666666666759 * sp[34] + 0.5249999999999974 * sp[35] + -1.008333333333343 * sp[29] + -1.533333333333347 * sp[32] + -0.216666666666667 * sp[28] + -1.041666666666674 * sp[29] + 0.3583333333333317 * sp[26] + -0.466666666666669 * sp[27] + -0.2166666666666737 * sp[31] + -0.2166666666666709 * sp[32] + -0.2166666666666778 * sp[27] + -0.6000000000000172 * sp[30];
    A[125] = 0.5083333333333342 * sp[33] + 0.7749999999999981 * sp[34] + 0.9749999999999973 * sp[28] + 0.5916666666666606 * sp[31] + -0.1833333333333398 * sp[34] + -1.012500000000006 * sp[35] + 0.170833333333325 * sp[29] + 0.9749999999999956 * sp[32] + -0.1833333333333333 * sp[28] + 1.604166666666671 * sp[29] + -1.012500000000006 * sp[26] + 0.7750000000000028 * sp[27] + -0.1833333333333392 * sp[31] + -0.183333333333334 * sp[32] + -0.1833333333333405 * sp[27] + 0.5083333333333377 * sp[30];
    A[126] = 2.183333333333337 * sp[33] + 2.424999999999993 * sp[34] + 1.091666666666673 * sp[28] + 0.8583333333333335 * sp[31] + -0.2416666666666682 * sp[34] + 1.62500000000002 * sp[35] + -1.075000000000002 * sp[29] + 0.1583333333333423 * sp[32] + 1.091666666666678 * sp[28] + 0.258333333333327 * sp[29] + 1.691666666666676 * sp[26] + 0.8583333333333361 * sp[27] + -0.475000000000001 * sp[31] + 0.1583333333333475 * sp[32] + -0.475000000000006 * sp[27] + -0.03333333333333138 * sp[30];
    A[127] = -5.866666666666675 * sp[33] + -2.433333333333326 * sp[34] + -3.100000000000013 * sp[28] + -1.966666666666663 * sp[31] + 2.066666666666682 * sp[34] + 0.4166666666666571 * sp[35] + 3.150000000000013 * sp[29] + 1.433333333333328 * sp[32] + -3.266666666666687 * sp[28] + -0.5166666666666653 * sp[29] + -4.716666666666693 * sp[26] + -1.966666666666671 * sp[27] + 1.533333333333346 * sp[31] + 0.5999999999999945 * sp[32] + 1.533333333333351 * sp[27] + 0.8166666666666692 * sp[30];
    A[128] = 3.683333333333339 * sp[33] + -1.825000000000014 * sp[34] + 2.17500000000001 * sp[28] + -1.058333333333345 * sp[31] + -1.825000000000014 * sp[34] + 2.708333333333338 * sp[35] + -2.325000000000011 * sp[29] + 1.241666666666675 * sp[32] + 2.17500000000001 * sp[28] + -2.325000000000011 * sp[29] + 3.441666666666684 * sp[26] + -1.058333333333344 * sp[27] + -1.058333333333345 * sp[31] + 1.241666666666675 * sp[32] + -1.058333333333344 * sp[27] + 0.6333333333333404 * sp[30];
    A[129] = -1.649915822768619 * sp[33] + 4.949747468305832 * sp[34] + 3.535533905932748 * sp[28] + 11.54941075938029 * sp[31] + -0.4714045207910507 * sp[34] + -13.08147545195116 * sp[35] + -3.181980515339479 * sp[29] + -11.07800623858925 * sp[32] + -0.4714045207910356 * sp[28] + 6.246109900481174 * sp[29] + 4.831896338108107 * sp[26] + 11.54941075938032 * sp[27] + -0.4714045207910448 * sp[31] + -6.128258770283456 * sp[32] + -1.885618083164156 * sp[27] + -5.892556509887927 * sp[30];
    A[130] = -13.13471862406398 * sp[33] + 12.12435565298213 * sp[34] + 5.196152422706664 * sp[28] + 17.03183294109401 * sp[31] + -0.7216878364868895 * sp[34] + -6.278684177437067 * sp[35] + -4.546633369868314 * sp[29] + -12.41303078757695 * sp[32] + -0.7216878364869894 * sp[28] + 9.021097956087894 * sp[29] + 7.289047148519071 * sp[26] + 17.03183294109405 * sp[27] + -0.7216878364869455 * sp[31] + -5.051814855409168 * sp[32] + -2.453738644055951 * sp[27] + -7.072540797572961 * sp[30];
    A[131] = 3.083333333333343 * sp[33] + -9.500000000000036 * sp[34] + -3.499999999999975 * sp[28] + -11.33333333333335 * sp[31] + -1.5833333333334 * sp[34] + 13.37500000000007 * sp[35] + 3.375000000000018 * sp[29] + 17.66666666666672 * sp[32] + -1.583333333333327 * sp[28] + -8.458333333333329 * sp[29] + -4.458333333333328 * sp[26] + -11.33333333333338 * sp[27] + -1.583333333333389 * sp[31] + 3.916666666666726 * sp[32] + 2.416666666666689 * sp[27] + 8.583333333333387 * sp[30];
    A[132] = -2.357022603955166 * sp[33] + -2.121320343559627 * sp[34] + -13.43502884254443 * sp[28] + -5.421151989096879 * sp[31] + 1.649915822768677 * sp[34] + 2.121320343559685 * sp[35] + 3.535533905932808 * sp[29] + 3.064129385141737 * sp[32] + 1.649915822768609 * sp[28] + -2.592724864350676 * sp[29] + -1.178511301977604 * sp[26] + -5.421151989096916 * sp[27] + 1.649915822768666 * sp[31] + 1.64991582276864 * sp[32] + 3.064129385141772 * sp[27] + 1.885618083164157 * sp[30];
    A[133] = 10.3923048454133 * sp[33] + 3.031088913245591 * sp[34] + 3.031088913245537 * sp[28] + -10.82531754730546 * sp[31] + -1.299038105676697 * sp[34] + -2.598076211353367 * sp[35] + 4.330127018922276 * sp[29] + 4.763139720814385 * sp[32] + -1.299038105676654 * sp[28] + 4.330127018922277 * sp[29] + -16.45448267190435 * sp[26] + -10.82531754730546 * sp[27] + -1.299038105676706 * sp[31] + -1.299038105676708 * sp[32] + 0.4330127018922961 * sp[27] + 2.598076211353324 * sp[30];
    A[134] = -4.166666666666672 * sp[33] + -3.749999999999972 * sp[34] + 4.249999999999994 * sp[28] + 1.916666666666688 * sp[31] + 2.916666666666784 * sp[34] + 3.750000000000083 * sp[35] + -2.249999999999952 * sp[29] + -13.08333333333321 * sp[32] + 2.91666666666666 * sp[28] + -4.583333333333341 * sp[29] + 9.416666666666705 * sp[26] + 1.9166666666667 * sp[27] + 2.916666666666764 * sp[31] + 2.916666666666718 * sp[32] + -1.083333333333285 * sp[27] + -6.666666666666619 * sp[30];
    A[135] = 1.649915822768635 * sp[33] + 3.064129385141737 * sp[34] + -1.649915822768626 * sp[28] + -1.649915822768631 * sp[31] + 0.4714045207910287 * sp[34] + 1.767766952966354 * sp[35] + 5.067598598503595 * sp[29] + -0.2357022603955441 * sp[32] + -5.185449728701343 * sp[28] + -3.889087296526054 * sp[29] + 10.72445284799602 * sp[26] + 4.006938426723768 * sp[27] + -5.185449728701368 * sp[31] + -5.185449728701419 * sp[32] + 17.44196726926824 * sp[27] + 5.892556509887892 * sp[30];
    A[136] = 3.771236166328252 * sp[33] + -3.771236166328294 * sp[34] + 0.9428090415820738 * sp[28] + 0.9428090415820821 * sp[31] + 6.128258770283431 * sp[34] + 1.178511301977588 * sp[35] + -5.421151989096854 * sp[29] + 12.25651754056687 * sp[32] + 3.299831645537213 * sp[28] + -1.649915822768562 * sp[29] + -2.592724864350716 * sp[26] + 3.771236166328279 * sp[27] + 3.29983164553724 * sp[31] + 3.299831645537288 * sp[32] + -8.956685895029658 * sp[27] + 11.7851130197758 * sp[30];
    A[137] = 4.006938426723791 * sp[33] + 10.13519719700723 * sp[34] + -4.006938426723797 * sp[28] + -4.006938426723783 * sp[31] + 5.185449728701373 * sp[34] + 7.660323462854288 * sp[35] + -3.181980515339482 * sp[29] + -16.73486048808168 * sp[32] + -0.4714045207910348 * sp[28] + 2.003469213361875 * sp[29] + 2.47487373415293 * sp[26] + 1.649915822768599 * sp[27] + -0.4714045207910292 * sp[31] + -0.4714045207910499 * sp[32] + 3.29983164553725 * sp[27] + -5.8925565098879 * sp[30];
    A[138] = -7.542472332656542 * sp[33] + -7.778174593052055 * sp[34] + -8.720983634634122 * sp[28] + -7.778174593052043 * sp[31] + -8.720983634634104 * sp[34] + -8.249579113843042 * sp[35] + -12.96362432175341 * sp[29] + -11.07800623858924 * sp[32] + 4.006938426723768 * sp[28] + 4.47834294751482 * sp[29] + -0.2357022603955241 * sp[26] + 0.2357022603955206 * sp[27] + 4.006938426723776 * sp[31] + 4.006938426723815 * sp[32] + 4.006938426723748 * sp[27] + 2.357022603955157 * sp[30];
    A[139] = 8.013876853447567 * sp[33] + 13.19932658214894 * sp[34] + 5.656854249492382 * sp[28] + 13.19932658214889 * sp[31] + 10.37089945740273 * sp[34] + 11.7851130197758 * sp[35] + 11.7851130197758 * sp[29] + 24.5130350811337 * sp[32] + -0.9428090415820647 * sp[28] + 0.4714045207910287 * sp[29] + 0.4714045207910273 * sp[26] + 1.885618083164152 * sp[27] + -0.9428090415820513 * sp[31] + -0.9428090415820797 * sp[32] + -0.9428090415820357 * sp[27];
    A[140] = 1.885618083164136 * sp[33] + -5.4211519890969 * sp[34] + 3.064129385141719 * sp[28] + -5.421151989096896 * sp[31] + 3.064129385141727 * sp[34] + -1.178511301977577 * sp[35] + 3.535533905932764 * sp[29] + -13.43502884254442 * sp[32] + 1.649915822768603 * sp[28] + -2.592724864350651 * sp[29] + 2.121320343559622 * sp[26] + -2.121320343559619 * sp[27] + 1.649915822768615 * sp[31] + 1.649915822768645 * sp[32] + 1.649915822768596 * sp[27] + -2.357022603955127 * sp[30];
    A[141] = -4.006938426723759 * sp[33] + -5.185449728701315 * sp[34] + -5.185449728701375 * sp[28] + -5.185449728701359 * sp[31] + -6.835365551469931 * sp[34] + -18.97403196183908 * sp[35] + -4.360491817317047 * sp[29] + -10.84230397819378 * sp[32] + 5.8925565098879 * sp[28] + 5.067598598503547 * sp[29] + 8.367430244040818 * sp[26] + 7.542472332656498 * sp[27] + 9.192388155425116 * sp[31] + 5.421151989096757 * sp[32] + 9.192388155425137 * sp[27] + 5.892556509887872 * sp[30];
    A[142] = 5.656854249492394 * sp[33] + 3.299831645537222 * sp[34] + 3.299831645537243 * sp[28] + 3.299831645537239 * sp[31] + 1.885618083164114 * sp[34] + 2.592724864350696 * sp[35] + -3.064129385141721 * sp[29] + 0.4714045207910678 * sp[32] + -9.428090415820641 * sp[28] + -3.064129385141687 * sp[29] + -14.3778378841265 * sp[26] + -8.013876853447531 * sp[27] + -20.74179891480541 * sp[31] + -8.485281374238507 * sp[32] + -20.74179891480546 * sp[27] + -11.78511301977576 * sp[30];
    A[143] = -1.649915822768619 * sp[33] + -0.4714045207910507 * sp[34] + -0.4714045207910356 * sp[28] + -0.4714045207910448 * sp[31] + 4.949747468305832 * sp[34] + -13.08147545195116 * sp[35] + 6.246109900481174 * sp[29] + -6.128258770283456 * sp[32] + 3.535533905932748 * sp[28] + -3.181980515339479 * sp[29] + 4.831896338108107 * sp[26] + -1.885618083164156 * sp[27] + 11.54941075938029 * sp[31] + -11.07800623858925 * sp[32] + 11.54941075938032 * sp[27] + -5.892556509887927 * sp[30];
    A[144] = 26.66666666666679 * sp[33] + 33.33333333333343 * sp[34] + -6.666666666666692 * sp[28] + -6.666666666666671 * sp[31] + 33.33333333333343 * sp[34] + 113.3333333333335 * sp[35] + -6.666666666666593 * sp[29] + 33.33333333333334 * sp[32] + -6.666666666666692 * sp[28] + -6.666666666666593 * sp[29] + 33.33333333333334 * sp[26] + 33.33333333333339 * sp[27] + -6.666666666666671 * sp[31] + 33.33333333333334 * sp[32] + 33.33333333333339 * sp[27] + 66.66666666666659 * sp[30];
    A[145] = 4.082482904638836 * sp[33] + -4.082482904638367 * sp[34] + -28.57738033247056 * sp[28] + -28.57738033247044 * sp[31] + 8.164965809277465 * sp[34] + 14.2886901662351 * sp[35] + -34.70110468942833 * sp[29] + -4.082482904638699 * sp[32] + 8.164965809277341 * sp[28] + 14.28869016623509 * sp[29] + 63.27848502189882 * sp[26] + 69.40220937885685 * sp[27] + 8.164965809277032 * sp[31] + 57.15476066494023 * sp[32] + 57.15476066494094 * sp[27] + 102.0620726159658 * sp[30];
    A[146] = 25.92724864350687 * sp[33] + 16.49915822768621 * sp[34] + -25.92724864350688 * sp[28] + -25.92724864350676 * sp[31] + 37.71236166328278 * sp[34] + -64.8181216087669 * sp[35] + -36.53385036130506 * sp[29] + -124.9221980096236 * sp[32] + 9.428090415820609 * sp[28] + 20.03469213361888 * sp[29] + -8.249579113843083 * sp[26] + 2.357022603955038 * sp[27] + 9.428090415820728 * sp[31] + -18.85618083164134 * sp[32] + -18.85618083164123 * sp[27] + -58.92556509887898 * sp[30];
    A[147] = -33.33333333333345 * sp[33] + -26.66666666666674 * sp[34] + 13.33333333333348 * sp[28] + 13.33333333333348 * sp[31] + -46.66666666666687 * sp[34] + -36.66666666666681 * sp[35] + 3.333333333333325 * sp[29] + 13.33333333333336 * sp[32] + -6.666666666666643 * sp[28] + 3.333333333333206 * sp[29] + -36.66666666666662 * sp[26] + -26.66666666666686 * sp[27] + -6.666666666666758 * sp[31] + -6.66666666666682 * sp[32] + -46.66666666666676 * sp[27] + -33.33333333333357 * sp[30];
    A[148] = -36.74234614174779 * sp[33] + -24.49489742783195 * sp[34] + -24.49489742783192 * sp[28] + -36.74234614174762 * sp[34] + -30.61862178478961 * sp[35] + -6.123724356958153 * sp[29] + 36.74234614174766 * sp[28] + 42.86607049870581 * sp[29] + -30.61862178478986 * sp[26] + -24.49489742783157 * sp[27] + 36.74234614174777 * sp[31] + 36.74234614174805 * sp[32] + -12.24744871391627 * sp[27] + -36.7423461417473 * sp[30];
    A[149] = -58.92556509887918 * sp[33] + -47.14045207910327 * sp[34] + -18.85618083164123 * sp[28] + -4.714045207910251 * sp[31] + -82.49579113843089 * sp[34] + -64.81812160876713 * sp[35] + -22.39171473757411 * sp[29] + 80.13876853447539 * sp[32] + -11.78511301977574 * sp[28] + 5.892556509887697 * sp[29] + -8.249579113842936 * sp[26] + 9.428090415820547 * sp[27] + -11.78511301977594 * sp[31] + -11.78511301977606 * sp[32] + 16.49915822768605 * sp[27] + 54.21151989096816 * sp[30];
    A[150] = 10.96965511460289 * sp[33] + 0.1443375672973277 * sp[34] + 0.7216878364871102 * sp[28] + 0.721687836487091 * sp[31] + 0.721687836486982 * sp[34] + -1.732050807568891 * sp[35] + 11.5470053837925 * sp[29] + 5.051814855409215 * sp[32] + -10.53664241271069 * sp[28] + -8.660254037844483 * sp[29] + 18.47520861406811 * sp[26] + 7.649891066762555 * sp[27] + -10.53664241271072 * sp[31] + -10.53664241271079 * sp[32] + 29.30052616137365 * sp[27] + 10.9696551146029 * sp[30];
    A[151] = -8.948929172439152 * sp[33] + -3.17542648054281 * sp[34] + 1.44337567297402 * sp[28] + 1.443375672973962 * sp[31] + -1.443375672973965 * sp[34] + 2.020725942163681 * sp[35] + -7.216878364870331 * sp[29] + 10.10362971081832 * sp[32] + 3.752776749732559 * sp[28] + -1.443375672973955 * sp[29] + -3.752776749732638 * sp[26] + 4.907477288111857 * sp[27] + 3.75277674973261 * sp[31] + 3.75277674973267 * sp[32] + -12.41303078757707 * sp[27] + 14.14508159514584 * sp[30];
    A[152] = -0.5773502691895827 * sp[33] + 4.474464586219635 * sp[34] + -0.7216878364870394 * sp[28] + -0.7216878364870225 * sp[31] + -0.7216878364869836 * sp[34] + 4.041451884327476 * sp[35] + -5.051814855409166 * sp[32] + -3.319764047840371 * sp[28] + -2.886751345948176 * sp[29] + 6.928203230275546 * sp[26] + 6.206515393788468 * sp[27] + -3.319764047840348 * sp[31] + -3.319764047840353 * sp[32] + 7.649891066762594 * sp[27] + -0.5773502691896102 * sp[30];
    A[153] = -5.917840259193728 * sp[33] + -0.8660254037844592 * sp[34] + -11.83568051838747 * sp[28] + -0.8660254037845609 * sp[31] + 0.7216878364869882 * sp[34] + -2.237232293109831 * sp[35] + 18.25870226312183 * sp[29] + 10.96965511460279 * sp[32] + 11.98001808568477 * sp[28] + 13.35122497501015 * sp[29] + 2.670244995002061 * sp[26] + 4.041451884327416 * sp[27] + 11.98001808568475 * sp[31] + 11.9800180856848 * sp[32] + 11.98001808568473 * sp[27] + 8.804591605141788 * sp[30];
    A[154] = -1.154700538379169 * sp[33] + 4.618802153517086 * sp[34] + -5.196152422706515 * sp[28] + 4.618802153517127 * sp[31] + -1.44337567297396 * sp[34] + 5.917840259193782 * sp[35] + -14.86676943163273 * sp[29] + -16.16580753730935 * sp[32] + -6.639528095680724 * sp[28] + -7.938566201357389 * sp[29] + -1.010362971081874 * sp[26] + -2.309401076758486 * sp[27] + -6.639528095680678 * sp[31] + -6.639528095680689 * sp[32] + -6.639528095680661 * sp[27] + -10.39230484541318 * sp[30];
    A[155] = -4.474464586219581 * sp[33] + -3.752776749732498 * sp[34] + -8.948929172439193 * sp[28] + -3.752776749732497 * sp[31] + -0.7216878364869885 * sp[34] + -0.07216878364874507 * sp[35] + 0.216506350946152 * sp[29] + 5.196152422706604 * sp[32] + 1.876388374866266 * sp[28] + -1.804219591217519 * sp[29] + 1.948557158514959 * sp[26] + -1.732050807568805 * sp[27] + 1.87638837486629 * sp[31] + 1.87638837486632 * sp[32] + 1.876388374866266 * sp[27] + 1.587713240271532 * sp[30];
    A[156] = 2.742413778650673 * sp[33] + 0.7216878364868622 * sp[34] + 0.7216878364870287 * sp[28] + 0.7216878364869905 * sp[31] + 17.89785834487831 * sp[34] + 24.75389279150505 * sp[35] + 2.525907427704567 * sp[29] + 5.05181485540917 * sp[32] + 10.96965511460291 * sp[28] + 9.165435523385243 * sp[29] + 18.11436469582454 * sp[26] + 16.31014510460693 * sp[27] + 19.9185842870421 * sp[31] + 19.34123401785234 * sp[32] + 19.91858428704214 * sp[27] + 17.46484564298618 * sp[30];
    A[157] = 10.39230484541329 * sp[33] + -1.443375672974036 * sp[34] + -1.443375672974132 * sp[28] + -1.443375672974094 * sp[31] + -30.02221399786045 * sp[34] + -19.19689645055494 * sp[35] + -12.26869322027951 * sp[29] + -10.10362971081837 * sp[32] + -16.16580753730957 * sp[28] + -5.340489990004029 * sp[29] + -26.12509968083064 * sp[26] + -15.29978213352509 * sp[27] + -36.9504172281361 * sp[31] + -15.58845726811982 * sp[32] + -36.95041722813619 * sp[27] + -21.93931022920577 * sp[30];
    A[158] = -13.13471862406398 * sp[33] + -0.7216878364868895 * sp[34] + -0.7216878364869894 * sp[28] + -0.7216878364869455 * sp[31] + 12.12435565298213 * sp[34] + -6.278684177437067 * sp[35] + 9.021097956087894 * sp[29] + -5.051814855409168 * sp[32] + 5.196152422706664 * sp[28] + -4.546633369868314 * sp[29] + 7.289047148519071 * sp[26] + -2.453738644055951 * sp[27] + 17.03183294109401 * sp[31] + -12.41303078757695 * sp[32] + 17.03183294109405 * sp[27] + -7.072540797572961 * sp[30];
    A[159] = 4.082482904638836 * sp[33] + 8.164965809277465 * sp[34] + 8.164965809277341 * sp[28] + 8.164965809277032 * sp[31] + -4.082482904638367 * sp[34] + 14.2886901662351 * sp[35] + 14.28869016623509 * sp[29] + 57.15476066494023 * sp[32] + -28.57738033247056 * sp[28] + -34.70110468942833 * sp[29] + 63.27848502189882 * sp[26] + 57.15476066494094 * sp[27] + -28.57738033247044 * sp[31] + -4.082482904638699 * sp[32] + 69.40220937885685 * sp[27] + 102.0620726159658 * sp[30];
    A[160] = 189.9999999999993 * sp[33] + 57.49999999999886 * sp[34] + 12.49999999999996 * sp[28] + 12.49999999999949 * sp[31] + 57.49999999999886 * sp[34] + 132.4999999999986 * sp[35] + 12.49999999999971 * sp[29] + 87.49999999999916 * sp[32] + 12.49999999999996 * sp[28] + 12.49999999999971 * sp[29] + 132.5000000000002 * sp[26] + 132.5000000000003 * sp[27] + 12.49999999999949 * sp[31] + 87.49999999999916 * sp[32] + 132.5000000000003 * sp[27] + 190.0000000000002 * sp[30];
    A[161] = -31.75426480542914 * sp[33] + 105.3664241271069 * sp[34] + -7.216878364870604 * sp[28] + -7.216878364870379 * sp[31] + -7.216878364869834 * sp[34] + 57.73502691896258 * sp[35] + -28.8675134594813 * sp[29] + -50.51814855409183 * sp[32] + 1.443375672973942 * sp[28] + 23.09401076758507 * sp[29] + 5.773502691896287 * sp[26] + 27.42413778650705 * sp[27] + 1.443375672974203 * sp[31] + 10.10362971081851 * sp[32] + -15.87713240271471 * sp[27] + -31.75426480542941 * sp[30];
    A[162] = 28.57738033247006 * sp[33] + -4.082482904639244 * sp[34] + 69.4022093788567 * sp[28] + -4.082482904638986 * sp[31] + 8.164965809276689 * sp[34] + -22.45365597551281 * sp[35] + -22.45365597551264 * sp[29] + -28.57738033247039 * sp[32] + 8.164965809277387 * sp[28] + 26.53613888015092 * sp[29] + -71.44345083117614 * sp[26] + -53.07227776030265 * sp[27] + 8.164965809277101 * sp[31] + 8.164965809276964 * sp[32] + -89.81462390205013 * sp[27] + -69.40220937885724 * sp[30];
    A[163] = -67.50000000000026 * sp[33] + 7.500000000000156 * sp[34] + 7.49999999999897 * sp[28] + 52.50000000000029 * sp[31] + 3.750000000000028 * sp[35] + 48.74999999999933 * sp[29] + -22.49999999999978 * sp[32] + 90.00000000000014 * sp[28] + 93.75000000000048 * sp[29] + -41.25000000000006 * sp[26] + -37.49999999999962 * sp[27] + 90.0000000000002 * sp[31] + 90.00000000000067 * sp[32] + -30.00000000000063 * sp[27] + -67.49999999999964 * sp[30];
    A[164] = 50.51814855409158 * sp[33] + -7.216878364871373 * sp[34] + 44.74464586219577 * sp[28] + 105.3664241271056 * sp[31] + 14.43375672973964 * sp[34] + -39.69283100678732 * sp[35] + 72.89047148518956 * sp[29] + 62.06515393788342 * sp[32] + 14.43375672974089 * sp[28] + 46.90970937165681 * sp[29] + -13.71206889325342 * sp[26] + 18.76388374866263 * sp[27] + 14.43375672974039 * sp[31] + 14.43375672974015 * sp[32] + 31.75426480542935 * sp[27] + 50.5181485540914 * sp[30];
    A[165] = -6.833333333333317 * sp[33] + 2.416666666666694 * sp[34] + 0.08333333333332907 * sp[28] + 0.08333333333329609 * sp[31] + 1.583333333333353 * sp[34] + 3.750000000000001 * sp[35] + -4.916666666666638 * sp[29] + 0.5833333333333717 * sp[32] + 0.08333333333333037 * sp[28] + -1.250000000000015 * sp[29] + -5.916666666666665 * sp[26] + -0.9166666666666456 * sp[27] + 0.08333333333334547 * sp[31] + 0.08333333333338833 * sp[32] + -10.91666666666672 * sp[27] + -1.833333333333317 * sp[30];
    A[166] = 11.16666666666667 * sp[33] + -8.166666666666712 * sp[34] + 3.166666666666671 * sp[28] + 3.166666666666734 * sp[31] + 1.833333333333341 * sp[34] + -16.6666666666667 * sp[35] + 10.66666666666666 * sp[29] + -7.833333333333402 * sp[32] + -5.166666666666687 * sp[28] + 3.333333333333395 * sp[29] + 2.666666666666658 * sp[26] + -4.833333333333346 * sp[27] + -5.166666666666679 * sp[31] + -5.166666666666729 * sp[32] + 10.1666666666667 * sp[27] + -17.16666666666671 * sp[30];
    A[167] = 4.833333333333358 * sp[33] + 14.91666666666675 * sp[34] + -4.083333333333372 * sp[28] + -4.08333333333337 * sp[31] + 2.416666666666691 * sp[34] + 22.91666666666678 * sp[35] + -5.750000000000016 * sp[29] + 11.41666666666674 * sp[32] + -4.083333333333361 * sp[28] + -12.08333333333341 * sp[29] + 3.250000000000018 * sp[26] + 4.916666666666671 * sp[27] + -4.083333333333345 * sp[31] + -4.083333333333294 * sp[32] + 1.583333333333316 * sp[27] + 19.83333333333339 * sp[30];
    A[168] = -3.58333333333337 * sp[33] + -7.000000000000044 * sp[34] + -2.666666666666693 * sp[28] + -7.000000000000012 * sp[31] + -4.916666666666707 * sp[34] + -7.708333333333372 * sp[35] + 4.458333333333243 * sp[29] + 2.166666666666591 * sp[32] + 6.583333333333362 * sp[28] + 7.29166666666668 * sp[29] + 5.458333333333393 * sp[26] + 6.1666666666667 * sp[27] + 6.583333333333328 * sp[31] + 6.58333333333327 * sp[32] + 6.583333333333381 * sp[27] + 6.916666666666661 * sp[30];
    A[169] = 9.666666666666703 * sp[33] + 17.33333333333342 * sp[34] + 6.999999999999985 * sp[28] + 17.33333333333337 * sp[31] + 4.833333333333372 * sp[34] + 24.58333333333346 * sp[35] + -11.41666666666663 * sp[29] + -2.66666666666661 * sp[32] + -8.166666666666707 * sp[28] + -15.41666666666674 * sp[29] + -3.416666666666694 * sp[26] + -10.66666666666674 * sp[27] + -8.166666666666679 * sp[31] + -8.166666666666611 * sp[32] + -8.1666666666667 * sp[27] + -18.00000000000005 * sp[30];
    A[170] = 5.583333333333346 * sp[33] + -10.33333333333339 * sp[34] + 10.66666666666669 * sp[28] + -10.33333333333338 * sp[31] + 0.9166666666666721 * sp[34] + -18.95833333333339 * sp[35] + 4.874999999999995 * sp[29] + 0.5 * sp[32] + -2.583333333333353 * sp[28] + 6.04166666666673 * sp[29] + -4.125000000000018 * sp[26] + 4.500000000000068 * sp[27] + -2.583333333333347 * sp[31] + -2.583333333333386 * sp[32] + -2.583333333333326 * sp[27] + 11.08333333333333 * sp[30];
    A[171] = -1.083333333333311 * sp[33] + -2.416666666666617 * sp[34] + -2.416666666666698 * sp[28] + -2.416666666666683 * sp[31] + 12.16666666666666 * sp[34] + 27.95833333333338 * sp[35] + -2.208333333333339 * sp[29] + 8.083333333333387 * sp[32] + -1.833333333333334 * sp[28] + -2.041666666666651 * sp[29] + 1.791666666666681 * sp[26] + 1.583333333333341 * sp[27] + 1.999999999999981 * sp[31] + 14.33333333333347 * sp[32] + 1.999999999999969 * sp[27] + 9.416666666666718 * sp[30];
    A[172] = -2.000000000000004 * sp[33] + -0.1666666666666645 * sp[34] + -0.1666666666666572 * sp[28] + -0.1666666666666361 * sp[31] + -2.666666666666611 * sp[34] + -8.416666666666684 * sp[35] + 3.583333333333312 * sp[29] + -1.166666666666712 * sp[32] + 5.33333333333329 * sp[28] + 1.583333333333302 * sp[29] + 5.58333333333333 * sp[26] + 1.833333333333307 * sp[27] + 9.333333333333361 * sp[31] + 2.999999999999945 * sp[32] + 9.33333333333341 * sp[27] + 3.666666666666637 * sp[30];
    A[173] = 3.083333333333343 * sp[33] + -1.5833333333334 * sp[34] + -1.583333333333327 * sp[28] + -1.583333333333389 * sp[31] + -9.500000000000036 * sp[34] + 13.37500000000007 * sp[35] + -8.458333333333329 * sp[29] + 3.916666666666726 * sp[32] + -3.499999999999975 * sp[28] + 3.375000000000018 * sp[29] + -4.458333333333328 * sp[26] + 2.416666666666689 * sp[27] + -11.33333333333335 * sp[31] + 17.66666666666672 * sp[32] + -11.33333333333338 * sp[27] + 8.583333333333387 * sp[30];
    A[174] = 25.92724864350687 * sp[33] + 37.71236166328278 * sp[34] + 9.428090415820609 * sp[28] + 9.428090415820728 * sp[31] + 16.49915822768621 * sp[34] + -64.8181216087669 * sp[35] + 20.03469213361888 * sp[29] + -18.85618083164134 * sp[32] + -25.92724864350688 * sp[28] + -36.53385036130506 * sp[29] + -8.249579113843083 * sp[26] + -18.85618083164123 * sp[27] + -25.92724864350676 * sp[31] + -124.9221980096236 * sp[32] + 2.357022603955038 * sp[27] + -58.92556509887898 * sp[30];
    A[175] = -31.75426480542914 * sp[33] + -7.216878364869834 * sp[34] + 1.443375672973942 * sp[28] + 1.443375672974203 * sp[31] + 105.3664241271069 * sp[34] + 57.73502691896258 * sp[35] + 23.09401076758507 * sp[29] + 10.10362971081851 * sp[32] + -7.216878364870604 * sp[28] + -28.8675134594813 * sp[29] + 5.773502691896287 * sp[26] + -15.87713240271471 * sp[27] + -7.216878364870379 * sp[31] + -50.51814855409183 * sp[32] + 27.42413778650705 * sp[27] + -31.75426480542941 * sp[30];
    A[176] = 53.33333333333353 * sp[33] + 14.16666666666678 * sp[34] + -30.83333333333357 * sp[28] + -30.8333333333335 * sp[31] + 14.16666666666678 * sp[34] + 219.1666666666673 * sp[35] + -30.83333333333355 * sp[29] + 84.16666666666703 * sp[32] + -30.83333333333357 * sp[28] + -30.83333333333355 * sp[29] + 39.16666666666677 * sp[26] + 39.16666666666663 * sp[27] + -30.8333333333335 * sp[31] + 84.16666666666703 * sp[32] + 39.16666666666663 * sp[27] + 153.3333333333336 * sp[30];
    A[177] = -58.92556509887915 * sp[33] + -25.92724864350691 * sp[34] + -40.06938426723757 * sp[28] + 2.357022603955278 * sp[31] + -18.85618083164142 * sp[34] + -22.39171473757429 * sp[35] + 5.892556509888045 * sp[29] + -11.78511301977593 * sp[32] + 37.71236166328276 * sp[28] + 34.17682775734988 * sp[29] + 5.892556509887815 * sp[26] + 2.357022603955083 * sp[27] + 37.71236166328265 * sp[31] + 37.71236166328262 * sp[32] + 9.428090415820694 * sp[27] + -2.35702260395507 * sp[30];
    A[178] = 12.99038105676654 * sp[33] + -4.330127018922336 * sp[34] + -4.330127018922371 * sp[28] + -12.99038105676664 * sp[31] + -25.98076211353321 * sp[34] + 10.82531754730547 * sp[35] + 2.165063509460637 * sp[29] + 12.99038105676643 * sp[32] + 25.98076211353317 * sp[28] + 10.82531754730545 * sp[29] + 36.80607966083882 * sp[26] + 21.65063509461088 * sp[27] + 25.98076211353303 * sp[31] + 25.98076211353282 * sp[32] + -8.660254037844012 * sp[27] + 12.99038105676609 * sp[30];
    A[179] = -104.1666666666669 * sp[33] + -45.83333333333358 * sp[34] + -55.83333333333328 * sp[28] + -0.8333333333332267 * sp[31] + -33.33333333333359 * sp[34] + -39.58333333333369 * sp[35] + 5.416666666666657 * sp[29] + -25.83333333333358 * sp[32] + 66.66666666666706 * sp[28] + 60.41666666666678 * sp[29] + 5.416666666666809 * sp[26] + -0.8333333333334103 * sp[27] + 66.66666666666687 * sp[31] + 66.66666666666686 * sp[32] + -3.333333333333258 * sp[27] + -104.1666666666666 * sp[30];
    A[180] = 5.892556509887876 * sp[33] + -3.299831645537255 * sp[34] + 0.4714045207910428 * sp[28] + 0.4714045207910712 * sp[31] + -1.649915822768607 * sp[34] + -2.474873734152929 * sp[35] + -2.003469213361903 * sp[29] + 0.471404520791032 * sp[32] + 16.73486048808164 * sp[28] + 3.181980515339498 * sp[29] + -7.660323462854287 * sp[26] + -5.185449728701323 * sp[27] + 4.006938426723789 * sp[31] + 4.006938426723837 * sp[32] + -10.13519719700728 * sp[27] + -4.006938426723801 * sp[30];
    A[181] = -11.78511301977579 * sp[33] + 8.956685895029656 * sp[34] + -3.299831645537234 * sp[28] + -3.299831645537289 * sp[31] + -3.771236166328268 * sp[34] + 2.592724864350744 * sp[35] + 1.6499158227686 * sp[29] + -3.299831645537262 * sp[32] + -12.2565175405668 * sp[28] + 5.421151989096823 * sp[29] + -1.178511301977546 * sp[26] + -6.128258770283468 * sp[27] + -0.9428090415820527 * sp[31] + -0.9428090415821071 * sp[32] + 3.771236166328307 * sp[27] + -3.771236166328288 * sp[30];
    A[182] = -5.89255650988792 * sp[33] + -17.44196726926825 * sp[34] + 5.185449728701389 * sp[28] + 5.18544972870138 * sp[31] + -4.006938426723786 * sp[34] + -10.72445284799604 * sp[35] + 3.88908729652602 * sp[29] + 5.185449728701363 * sp[32] + 0.2357022603955412 * sp[28] + -5.06759859850356 * sp[29] + -1.767766952966387 * sp[26] + -0.4714045207910238 * sp[27] + 1.649915822768633 * sp[31] + 1.649915822768647 * sp[32] + -3.064129385141751 * sp[27] + -1.649915822768615 * sp[30];
    A[183] = 5.892556509887932 * sp[33] + 9.19238815542516 * sp[34] + 5.421151989096883 * sp[28] + 9.192388155425123 * sp[31] + 7.542472332656516 * sp[34] + 8.367430244040809 * sp[35] + 5.067598598503618 * sp[29] + 5.892556509887902 * sp[32] + -10.84230397819377 * sp[28] + -4.360491817317075 * sp[29] + -18.97403196183908 * sp[26] + -6.835365551470019 * sp[27] + -5.185449728701391 * sp[31] + -5.185449728701417 * sp[32] + -5.18544972870136 * sp[27] + -4.006938426723801 * sp[30];
    A[184] = -11.78511301977582 * sp[33] + -20.74179891480548 * sp[34] + -8.485281374238545 * sp[28] + -20.74179891480541 * sp[31] + -8.01387685344756 * sp[34] + -14.37783788412652 * sp[35] + -3.064129385141705 * sp[29] + -9.42809041582068 * sp[32] + 0.4714045207910718 * sp[28] + -3.06412938514167 * sp[29] + 2.592724864350726 * sp[26] + 1.885618083164133 * sp[27] + 3.299831645537258 * sp[31] + 3.29983164553727 * sp[32] + 3.299831645537241 * sp[27] + 5.656854249492373 * sp[30];
    A[185] = -5.892556509887907 * sp[33] + 11.54941075938033 * sp[34] + -11.07800623858927 * sp[28] + 11.54941075938032 * sp[31] + -1.885618083164143 * sp[34] + 4.83189633810814 * sp[35] + -3.18198051533948 * sp[29] + 3.535533905932823 * sp[32] + -6.128258770283397 * sp[28] + 6.24610990048115 * sp[29] + -13.08147545195111 * sp[26] + 4.949747468305813 * sp[27] + -0.4714045207910201 * sp[31] + -0.4714045207910558 * sp[32] + -0.4714045207909976 * sp[27] + -1.649915822768619 * sp[30];
    A[186] = 2.357022603955125 * sp[33] + 4.006938426723697 * sp[34] + 4.006938426723801 * sp[28] + 4.006938426723781 * sp[31] + 0.2357022603954775 * sp[34] + -0.2357022603955419 * sp[35] + 4.478342947514787 * sp[29] + 4.006938426723751 * sp[32] + -11.07800623858926 * sp[28] + -12.96362432175338 * sp[29] + -8.249579113843069 * sp[26] + -8.720983634634084 * sp[27] + -7.778174593052062 * sp[31] + -8.720983634634061 * sp[32] + -7.77817459305209 * sp[27] + -7.542472332656548 * sp[30];
    A[187] = -0.9428090415820565 * sp[34] + -0.9428090415820791 * sp[28] + -0.9428090415820932 * sp[31] + 1.885618083164135 * sp[34] + 0.4714045207910509 * sp[35] + 0.4714045207910629 * sp[29] + -0.9428090415820465 * sp[32] + 24.51303508113368 * sp[28] + 11.78511301977577 * sp[29] + 11.78511301977582 * sp[26] + 10.37089945740267 * sp[27] + 13.19932658214894 * sp[31] + 5.656854249492389 * sp[32] + 13.199326582149 * sp[27] + 8.013876853447586 * sp[30];
    A[188] = -2.357022603955166 * sp[33] + 1.649915822768677 * sp[34] + 1.649915822768609 * sp[28] + 1.649915822768666 * sp[31] + -2.121320343559627 * sp[34] + 2.121320343559685 * sp[35] + -2.592724864350676 * sp[29] + 1.64991582276864 * sp[32] + -13.43502884254443 * sp[28] + 3.535533905932808 * sp[29] + -1.178511301977604 * sp[26] + 3.064129385141772 * sp[27] + -5.421151989096879 * sp[31] + 3.064129385141737 * sp[32] + -5.421151989096916 * sp[27] + 1.885618083164157 * sp[30];
    A[189] = -33.33333333333345 * sp[33] + -46.66666666666687 * sp[34] + -6.666666666666643 * sp[28] + -6.666666666666758 * sp[31] + -26.66666666666674 * sp[34] + -36.66666666666681 * sp[35] + 3.333333333333206 * sp[29] + -6.66666666666682 * sp[32] + 13.33333333333348 * sp[28] + 3.333333333333325 * sp[29] + -36.66666666666662 * sp[26] + -46.66666666666676 * sp[27] + 13.33333333333348 * sp[31] + 13.33333333333336 * sp[32] + -26.66666666666686 * sp[27] + -33.33333333333357 * sp[30];
    A[190] = 28.57738033247006 * sp[33] + 8.164965809276689 * sp[34] + 8.164965809277387 * sp[28] + 8.164965809277101 * sp[31] + -4.082482904639244 * sp[34] + -22.45365597551281 * sp[35] + 26.53613888015092 * sp[29] + 8.164965809276964 * sp[32] + 69.4022093788567 * sp[28] + -22.45365597551264 * sp[29] + -71.44345083117614 * sp[26] + -89.81462390205013 * sp[27] + -4.082482904638986 * sp[31] + -28.57738033247039 * sp[32] + -53.07227776030265 * sp[27] + -69.40220937885724 * sp[30];
    A[191] = -58.92556509887915 * sp[33] + -18.85618083164142 * sp[34] + 37.71236166328276 * sp[28] + 37.71236166328265 * sp[31] + -25.92724864350691 * sp[34] + -22.39171473757429 * sp[35] + 34.17682775734988 * sp[29] + 37.71236166328262 * sp[32] + -40.06938426723757 * sp[28] + 5.892556509888045 * sp[29] + 5.892556509887815 * sp[26] + 9.428090415820694 * sp[27] + 2.357022603955278 * sp[31] + -11.78511301977593 * sp[32] + 2.357022603955083 * sp[27] + -2.35702260395507 * sp[30];
    A[192] = 66.66666666666683 * sp[33] + 33.33333333333347 * sp[34] + 33.33333333333319 * sp[28] + -6.66666666666681 * sp[31] + 33.33333333333347 * sp[34] + 33.33333333333334 * sp[35] + -6.666666666666655 * sp[29] + -6.66666666666669 * sp[32] + 33.33333333333319 * sp[28] + -6.666666666666655 * sp[29] + 113.3333333333334 * sp[26] + 33.33333333333347 * sp[27] + -6.66666666666681 * sp[31] + -6.66666666666669 * sp[32] + 33.33333333333347 * sp[27] + 26.66666666666701 * sp[30];
    A[193] = 12.24744871391605 * sp[34] + 12.24744871391602 * sp[28] + 12.24744871391596 * sp[31] + 36.74234614174757 * sp[34] + 24.49489742783167 * sp[35] + 24.4948974278317 * sp[29] + 12.24744871391582 * sp[32] + -110.2270384252433 * sp[28] + -48.98979485566376 * sp[29] + -48.98979485566365 * sp[26] + 36.74234614174748 * sp[27] + -36.74234614174788 * sp[31] + -36.74234614174816 * sp[32] + 12.2474487139159 * sp[27] + 24.49489742783158 * sp[30];
    A[194] = 117.8511301977582 * sp[33] + 58.92556509887916 * sp[34] + 58.92556509887886 * sp[28] + 2.357022603955007 * sp[31] + 58.9255650988792 * sp[34] + 58.92556509887893 * sp[35] + 2.357022603955216 * sp[29] + 2.357022603954592 * sp[32] + 58.92556509887862 * sp[28] + -11.78511301977581 * sp[29] + 44.78342947514783 * sp[26] + -11.78511301977579 * sp[27] + -11.78511301977606 * sp[31] + -11.78511301977585 * sp[32] + -11.78511301977593 * sp[27] + -9.428090415820915 * sp[30];
    A[195] = -16.8874953737966 * sp[33] + -5.196152422706669 * sp[34] + 5.196152422706643 * sp[28] + 5.196152422706621 * sp[31] + -7.361215932167751 * sp[34] + -6.278684177437277 * sp[35] + 11.90784930203617 * sp[29] + 5.196152422706671 * sp[32] + -7.361215932167751 * sp[28] + 4.979646071760503 * sp[29] + -21.86714144555713 * sp[26] + -1.732050807568867 * sp[27] + 3.897114317029957 * sp[31] + 3.89711431702994 * sp[32] + -15.15544456622762 * sp[27] + -3.897114317029917 * sp[30];
    A[196] = 7.794228634059971 * sp[33] + -2.598076211353278 * sp[34] + 2.598076211353306 * sp[28] + 2.59807621135336 * sp[31] + 1.732050807568867 * sp[34] + -0.4330127018921175 * sp[35] + -2.165063509461185 * sp[29] + 2.598076211353387 * sp[32] + 1.732050807568875 * sp[28] + -5.629165124598742 * sp[29] + 13.42339375865882 * sp[26] + -0.8660254037845523 * sp[27] + -3.464101615137753 * sp[31] + -3.464101615137693 * sp[32] + 8.66025403784438 * sp[27] + -5.196152422706589 * sp[30];
    A[197] = -3.897114317029995 * sp[33] + -5.196152422706633 * sp[34] + 5.196152422706639 * sp[28] + 5.19615242270662 * sp[31] + -3.031088913245561 * sp[34] + -4.113620667976138 * sp[35] + 5.412658773652788 * sp[29] + 5.196152422706607 * sp[32] + -3.031088913245561 * sp[28] + -1.515544456622852 * sp[29] + -2.381569860407203 * sp[26] + -1.732050807568821 * sp[27] + -0.4330127018922288 * sp[31] + -0.4330127018922545 * sp[32] + -2.165063509461089 * sp[27] + 0.4330127018921683 * sp[30];
    A[198] = 16.88749537379659 * sp[33] + 11.69134295108993 * sp[34] + 22.08364779650326 * sp[28] + 11.69134295108997 * sp[31] + 9.526279441628866 * sp[34] + 10.60881119635944 * sp[35] + 2.814582562299453 * sp[29] + 3.897114317030008 * sp[32] + 9.526279441628859 * sp[28] + -0.6495190528383219 * sp[29] + 36.58957330989254 * sp[26] + 19.48557158514987 * sp[27] + -1.732050807568853 * sp[31] + -1.732050807568856 * sp[32] + -1.732050807568895 * sp[27] + 0.4330127018922156 * sp[30];
    A[199] = -7.794228634059968 * sp[33] + -10.39230484541325 * sp[34] + -5.196152422706671 * sp[28] + -10.39230484541322 * sp[31] + -6.062177826491108 * sp[34] + -8.227241335952218 * sp[35] + -1.299038105676685 * sp[29] + -3.464101615137746 * sp[32] + -6.062177826491103 * sp[28] + -3.031088913245603 * sp[29] + -16.88749537379653 * sp[26] + -17.32050807568879 * sp[27] + -0.8660254037844588 * sp[31] + -0.866025403784471 * sp[32] + -0.8660254037844314 * sp[27] + 3.464101615137788 * sp[30];
    A[200] = 3.897114317029971 * sp[33] + -1.299038105676654 * sp[34] + 9.093266739736631 * sp[28] + -1.299038105676635 * sp[31] + 0.8660254037844235 * sp[34] + -0.2165063509460481 * sp[35] + 0.6495190528382966 * sp[29] + -0.4330127018921688 * sp[32] + 0.8660254037844266 * sp[28] + -2.814582562299329 * sp[29] + 8.44374768689827 * sp[26] + -2.165063509461006 * sp[27] + -1.732050807568876 * sp[31] + -1.732050807568826 * sp[32] + -1.732050807568871 * sp[27] + -3.89711431702999 * sp[30];
    A[201] = 10.39230484541327 * sp[33] + 11.69134295108992 * sp[34] + 11.69134295108993 * sp[28] + 11.69134295108992 * sp[31] + 7.361215932167775 * sp[34] + 6.062177826491039 * sp[35] + 12.99038105676665 * sp[29] + 11.69134295108996 * sp[32] + 7.361215932167664 * sp[28] + 12.99038105676653 * sp[29] + -7.794228634059942 * sp[26] + -3.897114317029998 * sp[27] + -6.495190528383265 * sp[31] + -8.227241335952201 * sp[32] + -6.495190528383231 * sp[27] + -6.062177826491057 * sp[30];
    A[202] = -20.78460969082657 * sp[33] + -10.39230484541326 * sp[34] + -10.39230484541328 * sp[28] + -10.39230484541325 * sp[31] + -10.39230484541337 * sp[34] + -3.464101615137777 * sp[35] + -17.32050807568892 * sp[29] + -10.39230484541332 * sp[32] + -10.39230484541323 * sp[28] + -17.32050807568875 * sp[29] + 24.24871130596432 * sp[26] + 3.46410161513777 * sp[27] + 17.32050807568871 * sp[31] + 3.464101615137676 * sp[32] + 17.32050807568868 * sp[27] + 7.794228634059853 * sp[30];
    A[203] = 10.3923048454133 * sp[33] + -1.299038105676697 * sp[34] + -1.299038105676654 * sp[28] + -1.299038105676706 * sp[31] + 3.031088913245591 * sp[34] + -2.598076211353367 * sp[35] + 4.330127018922277 * sp[29] + -1.299038105676708 * sp[32] + 3.031088913245537 * sp[28] + 4.330127018922276 * sp[29] + -16.45448267190435 * sp[26] + 0.4330127018922961 * sp[27] + -10.82531754730546 * sp[31] + 4.763139720814385 * sp[32] + -10.82531754730546 * sp[27] + 2.598076211353324 * sp[30];
    A[204] = -36.74234614174779 * sp[33] + -36.74234614174762 * sp[34] + 36.74234614174766 * sp[28] + 36.74234614174777 * sp[31] + -24.49489742783195 * sp[34] + -30.61862178478961 * sp[35] + 42.86607049870581 * sp[29] + 36.74234614174805 * sp[32] + -24.49489742783192 * sp[28] + -6.123724356958153 * sp[29] + -30.61862178478986 * sp[26] + -12.24744871391627 * sp[27] + -24.49489742783157 * sp[27] + -36.7423461417473 * sp[30];
    A[205] = -67.50000000000026 * sp[33] + 90.00000000000014 * sp[28] + 90.0000000000002 * sp[31] + 7.500000000000156 * sp[34] + 3.750000000000028 * sp[35] + 93.75000000000048 * sp[29] + 90.00000000000067 * sp[32] + 7.49999999999897 * sp[28] + 48.74999999999933 * sp[29] + -41.25000000000006 * sp[26] + -30.00000000000063 * sp[27] + 52.50000000000029 * sp[31] + -22.49999999999978 * sp[32] + -37.49999999999962 * sp[27] + -67.49999999999964 * sp[30];
    A[206] = 12.99038105676654 * sp[33] + -25.98076211353321 * sp[34] + 25.98076211353317 * sp[28] + 25.98076211353303 * sp[31] + -4.330127018922336 * sp[34] + 10.82531754730547 * sp[35] + 10.82531754730545 * sp[29] + 25.98076211353282 * sp[32] + -4.330127018922371 * sp[28] + 2.165063509460637 * sp[29] + 36.80607966083882 * sp[26] + -8.660254037844012 * sp[27] + -12.99038105676664 * sp[31] + 12.99038105676643 * sp[32] + 21.65063509461088 * sp[27] + 12.99038105676609 * sp[30];
    A[207] = 36.74234614174757 * sp[34] + -110.2270384252433 * sp[28] + -36.74234614174788 * sp[31] + 12.24744871391605 * sp[34] + 24.49489742783167 * sp[35] + -48.98979485566376 * sp[29] + -36.74234614174816 * sp[32] + 12.24744871391602 * sp[28] + 24.4948974278317 * sp[29] + -48.98979485566365 * sp[26] + 12.2474487139159 * sp[27] + 12.24744871391596 * sp[31] + 12.24744871391582 * sp[32] + 36.74234614174748 * sp[27] + 24.49489742783158 * sp[30];
    A[208] = 135.0000000000003 * sp[33] + 67.5000000000002 * sp[34] + 67.50000000000021 * sp[28] + -22.49999999999983 * sp[31] + 67.5000000000002 * sp[34] + 67.50000000000053 * sp[35] + -22.50000000000014 * sp[29] + -22.49999999999986 * sp[32] + 67.50000000000021 * sp[28] + -22.50000000000014 * sp[29] + 247.4999999999996 * sp[26] + 67.50000000000006 * sp[27] + -22.49999999999983 * sp[31] + -22.49999999999986 * sp[32] + 67.50000000000006 * sp[27] + 60.00000000000005 * sp[30];
    A[209] = 64.95190528383273 * sp[34] + -38.97114317029978 * sp[28] + 12.99038105676645 * sp[31] + 21.65063509461126 * sp[34] + 43.30127018922175 * sp[35] + -8.660254037844128 * sp[29] + 12.99038105676672 * sp[32] + 21.65063509461125 * sp[28] + 43.30127018922177 * sp[29] + -8.660254037844549 * sp[26] + 99.5929214352094 * sp[27] + 21.65063509461107 * sp[31] + 21.65063509461082 * sp[32] + -12.99038105676655 * sp[27] + 43.30127018922255 * sp[30];
    A[210] = 10.41666666666662 * sp[33] + -5.833333333333392 * sp[34] + 0.8333333333333517 * sp[28] + 0.8333333333334049 * sp[31] + -2.916666666666664 * sp[34] + -4.37500000000002 * sp[35] + -3.541666666666699 * sp[29] + 0.8333333333333355 * sp[32] + 10.0833333333333 * sp[28] + -2.875000000000033 * sp[29] + 7.958333333333401 * sp[26] + 1.833333333333382 * sp[27] + -1.416666666666663 * sp[31] + -1.416666666666763 * sp[32] + 3.583333333333356 * sp[27] + 2.916666666666667 * sp[30];
    A[211] = -20.83333333333332 * sp[33] + 15.83333333333342 * sp[34] + -5.833333333333348 * sp[28] + -5.833333333333451 * sp[31] + -6.666666666666683 * sp[34] + 4.583333333333446 * sp[35] + 2.916666666666654 * sp[29] + -5.833333333333407 * sp[32] + -12.66666666666663 * sp[28] + 11.58333333333334 * sp[29] + -10.08333333333338 * sp[26] + 2.166666666666601 * sp[27] + 0.3333333333333502 * sp[31] + 0.3333333333335449 * sp[32] + -1.333333333333372 * sp[27] + 13.33333333333323 * sp[30];
    A[212] = -10.41666666666671 * sp[33] + -30.83333333333346 * sp[34] + 9.166666666666735 * sp[28] + 9.166666666666725 * sp[31] + -7.08333333333336 * sp[34] + -18.95833333333343 * sp[35] + 6.875000000000011 * sp[29] + 9.166666666666696 * sp[32] + -4.083333333333329 * sp[28] + -12.45833333333334 * sp[29] + 3.375000000000046 * sp[26] + 0.1666666666666976 * sp[27] + -0.5833333333333175 * sp[31] + -0.5833333333333943 * sp[32] + 1.083333333333329 * sp[27] + -12.91666666666666 * sp[30];
    A[213] = 10.41666666666673 * sp[33] + 16.25000000000007 * sp[34] + 9.583333333333377 * sp[28] + 16.25000000000001 * sp[31] + 13.33333333333334 * sp[34] + 14.79166666666665 * sp[35] + 8.958333333333389 * sp[29] + 10.41666666666667 * sp[32] + 0.3333333333333397 * sp[28] + 3.291666666666705 * sp[29] + 7.458333333333284 * sp[26] + 9.416666666666625 * sp[27] + 1.833333333333303 * sp[31] + 1.833333333333343 * sp[32] + 1.833333333333285 * sp[27] + 2.916666666666629 * sp[30];
    A[214] = -20.83333333333339 * sp[33] + -36.6666666666668 * sp[34] + -14.99999999999995 * sp[28] + -36.6666666666667 * sp[31] + -14.16666666666669 * sp[34] + -25.41666666666673 * sp[35] + -5.41666666666667 * sp[29] + -16.66666666666674 * sp[32] + -8.16666666666665 * sp[28] + -12.41666666666669 * sp[29] + -12.41666666666659 * sp[26] + -24.6666666666666 * sp[27] + -1.166666666666629 * sp[31] + -1.166666666666685 * sp[32] + -1.166666666666611 * sp[27] + 10.00000000000004 * sp[30];
    A[215] = -10.41666666666668 * sp[33] + 20.41666666666676 * sp[34] + -19.58333333333337 * sp[28] + 20.41666666666674 * sp[31] + -3.333333333333358 * sp[34] + 8.541666666666767 * sp[35] + -5.625000000000016 * sp[29] + 6.250000000000148 * sp[32] + -6.333333333333325 * sp[28] + 12.04166666666667 * sp[29] + -12.12500000000003 * sp[26] + 15.24999999999998 * sp[27] + 0.1666666666666687 * sp[31] + 0.1666666666668157 * sp[32] + 0.1666666666666603 * sp[27] + -12.91666666666649 * sp[30];
    A[216] = 4.166666666666613 * sp[33] + 7.083333333333215 * sp[34] + 7.083333333333389 * sp[28] + 7.083333333333356 * sp[31] + 0.4166666666666101 * sp[34] + -0.4166666666666909 * sp[35] + 7.916666666666639 * sp[29] + 7.083333333333309 * sp[32] + 8.416666666666639 * sp[28] + 13.58333333333323 * sp[29] + 1.91666666666671 * sp[26] + 3.08333333333335 * sp[27] + 2.749999999999956 * sp[31] + -8.916666666666849 * sp[32] + 2.749999999999976 * sp[27] + -3.33333333333343 * sp[30];
    A[217] = -1.666666666666662 * sp[34] + -1.666666666666694 * sp[28] + -1.666666666666723 * sp[31] + 3.333333333333337 * sp[34] + 0.8333333333333579 * sp[35] + 0.8333333333333881 * sp[29] + -1.666666666666641 * sp[32] + -12.66666666666666 * sp[28] + -7.166666666666632 * sp[29] + -7.166666666666744 * sp[26] + -3.666666666666703 * sp[27] + -4.666666666666666 * sp[31] + -7.999999999999927 * sp[32] + -4.666666666666683 * sp[27] + -5.833333333333274 * sp[30];
    A[218] = -4.166666666666672 * sp[33] + 2.916666666666784 * sp[34] + 2.91666666666666 * sp[28] + 2.916666666666764 * sp[31] + -3.749999999999972 * sp[34] + 3.750000000000083 * sp[35] + -4.583333333333341 * sp[29] + 2.916666666666718 * sp[32] + 4.249999999999994 * sp[28] + -2.249999999999952 * sp[29] + 9.416666666666705 * sp[26] + -1.083333333333285 * sp[27] + 1.916666666666688 * sp[31] + -13.08333333333321 * sp[32] + 1.9166666666667 * sp[27] + -6.666666666666619 * sp[30];
    A[219] = -58.92556509887918 * sp[33] + -82.49579113843089 * sp[34] + -11.78511301977574 * sp[28] + -11.78511301977594 * sp[31] + -47.14045207910327 * sp[34] + -64.81812160876713 * sp[35] + 5.892556509887697 * sp[29] + -11.78511301977606 * sp[32] + -18.85618083164123 * sp[28] + -22.39171473757411 * sp[29] + -8.249579113842936 * sp[26] + 16.49915822768605 * sp[27] + -4.714045207910251 * sp[31] + 80.13876853447539 * sp[32] + 9.428090415820547 * sp[27] + 54.21151989096816 * sp[30];
    A[220] = 50.51814855409158 * sp[33] + 14.43375672973964 * sp[34] + 14.43375672974089 * sp[28] + 14.43375672974039 * sp[31] + -7.216878364871373 * sp[34] + -39.69283100678732 * sp[35] + 46.90970937165681 * sp[29] + 14.43375672974015 * sp[32] + 44.74464586219577 * sp[28] + 72.89047148518956 * sp[29] + -13.71206889325342 * sp[26] + 31.75426480542935 * sp[27] + 105.3664241271056 * sp[31] + 62.06515393788342 * sp[32] + 18.76388374866263 * sp[27] + 50.5181485540914 * sp[30];
    A[221] = -104.1666666666669 * sp[33] + -33.33333333333359 * sp[34] + 66.66666666666706 * sp[28] + 66.66666666666687 * sp[31] + -45.83333333333358 * sp[34] + -39.58333333333369 * sp[35] + 60.41666666666678 * sp[29] + 66.66666666666686 * sp[32] + -55.83333333333328 * sp[28] + 5.416666666666657 * sp[29] + 5.416666666666809 * sp[26] + -3.333333333333258 * sp[27] + -0.8333333333332267 * sp[31] + -25.83333333333358 * sp[32] + -0.8333333333334103 * sp[27] + -104.1666666666666 * sp[30];
    A[222] = 117.8511301977582 * sp[33] + 58.9255650988792 * sp[34] + 58.92556509887862 * sp[28] + -11.78511301977606 * sp[31] + 58.92556509887916 * sp[34] + 58.92556509887893 * sp[35] + -11.78511301977581 * sp[29] + -11.78511301977585 * sp[32] + 58.92556509887886 * sp[28] + 2.357022603955216 * sp[29] + 44.78342947514783 * sp[26] + -11.78511301977593 * sp[27] + 2.357022603955007 * sp[31] + 2.357022603954592 * sp[32] + -11.78511301977579 * sp[27] + -9.428090415820915 * sp[30];
    A[223] = 21.65063509461126 * sp[34] + 21.65063509461125 * sp[28] + 21.65063509461107 * sp[31] + 64.95190528383273 * sp[34] + 43.30127018922175 * sp[35] + 43.30127018922177 * sp[29] + 21.65063509461082 * sp[32] + -38.97114317029978 * sp[28] + -8.660254037844128 * sp[29] + -8.660254037844549 * sp[26] + -12.99038105676655 * sp[27] + 12.99038105676645 * sp[31] + 12.99038105676672 * sp[32] + 99.5929214352094 * sp[27] + 43.30127018922255 * sp[30];
    A[224] = 208.3333333333337 * sp[33] + 104.166666666667 * sp[34] + 104.1666666666665 * sp[28] + 4.166666666666396 * sp[31] + 104.166666666667 * sp[34] + 104.1666666666666 * sp[35] + 4.166666666666755 * sp[29] + 4.166666666665641 * sp[32] + 104.1666666666665 * sp[28] + 4.166666666666755 * sp[29] + 104.1666666666664 * sp[26] + 4.166666666666581 * sp[27] + 4.166666666666396 * sp[31] + 4.166666666665641 * sp[32] + 4.166666666666581 * sp[27] + 183.3333333333316 * sp[30];
  }

};


class forms_cell_integral_1_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_1_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_1_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 6
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 6
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           6
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q12[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q12[0][0][1];
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q12[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q12[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q12[0][0][1];
    alignas(32) double sp[20];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c0 / sp[2];
    sp[4] = -1 * J_c1 / sp[2];
    sp[5] = sp[3] * sp[3];
    sp[6] = sp[3] * sp[4];
    sp[7] = sp[4] * sp[4];
    sp[8] = J_c3 / sp[2];
    sp[9] = -1 * J_c2 / sp[2];
    sp[10] = sp[9] * sp[9];
    sp[11] = sp[8] * sp[9];
    sp[12] = sp[8] * sp[8];
    sp[13] = sp[5] + sp[10];
    sp[14] = sp[6] + sp[11];
    sp[15] = sp[12] + sp[7];
    sp[16] = std::abs(sp[2]);
    sp[17] = sp[13] * sp[16];
    sp[18] = sp[14] * sp[16];
    sp[19] = sp[15] * sp[16];
    A[0] = 0.02162698412698435 * sp[19] + -0.01116071428571435 * sp[18] + -0.01116071428571435 * sp[18] + 0.05734126984127028 * sp[17];
    A[1] = -0.02986111111111126 * sp[19] + 0.005952380952380941 * sp[18] + 0.009920634920634989 * sp[18] + -0.04871031746031775 * sp[17];
    A[2] = 0.01765873015873016 * sp[19] + -0.004712301587301577 * sp[18] + -0.00471230158730161 * sp[18] + 0.01765873015873019 * sp[17];
    A[3] = -0.01542658730158742 * sp[19] + -0.02447916666666682 * sp[18] + 0.009052579365079402 * sp[18] + 0.01860119047619069 * sp[17];
    A[4] = 0.01746031746031744 * sp[19] + 0.02167658730158725 * sp[18] + -0.005704365079365079 * sp[18] + -0.01190476190476193 * sp[17];
    A[5] = -0.02385912698412706 * sp[19] + -0.03266369047619062 * sp[18] + 0.006820436507936553 * sp[18] + 0.01116071428571418 * sp[17];
    A[6] = -0.01314484126984128 * sp[19] + -0.008804563492063542 * sp[18] + 0.03067956349206367 * sp[18] + 0.02385912698412707 * sp[17];
    A[7] = 0.02777777777777796 * sp[19] + 0.01413690476190486 * sp[18] + -0.07276785714285773 * sp[18] + -0.06111111111111155 * sp[17];
    A[8] = -0.02058531746031761 * sp[19] + -0.007068452380952393 * sp[18] + 0.05820932539682566 * sp[18] + 0.05114087301587334 * sp[17];
    A[9] = 0.04349267900155149 * sp[19] + -0.0231493291459885 * sp[18] + -0.06243303921190627 * sp[18] + 0.03507474113028575 * sp[17];
    A[10] = 0.06529556615835209 * sp[19] + -0.05154913117764577 * sp[18] + -0.1271545235715235 * sp[18] + 0.06529556615835098 * sp[17];
    A[11] = -0.01686507936508148 * sp[19] + -0.007440476190475964 * sp[18] + 0.07192460317460263 * sp[18] + -0.01091269841269923 * sp[17];
    A[12] = 0.03507474113028569 * sp[19] + 0.1283735525368427 * sp[18] + -0.01192541198429714 * sp[18] + -0.124866078423815 * sp[17];
    A[13] = -0.1005208057964092 * sp[19] + -0.06314768569261534 * sp[18] + 0.07088005536926234 * sp[18] + -0.08505606644311343 * sp[17];
    A[14] = 0.06200396825396928 * sp[19] + 0.09598214285714186 * sp[18] + -0.02108134920634954 * sp[18] + 0.05307539682539826 * sp[17];
    A[15] = -0.02986111111111126 * sp[19] + 0.009920634920634989 * sp[18] + 0.005952380952380941 * sp[18] + -0.04871031746031775 * sp[17];
    A[16] = 0.068650793650794 * sp[19] + -0.01289682539682552 * sp[18] + -0.01289682539682552 * sp[18] + 0.06865079365079428 * sp[17];
    A[17] = -0.04871031746031762 * sp[19] + 0.005952380952380894 * sp[18] + 0.009920634920635002 * sp[18] + -0.02986111111111134 * sp[17];
    A[18] = 0.01746031746031743 * sp[19] + 0.02316468253968255 * sp[18] + -0.00421626984126978 * sp[18] + -0.01041666666666673 * sp[17];
    A[19] = -0.04384920634920641 * sp[19] + -0.0532738095238097 * sp[18] + 0.009424603174603202 * sp[18] + 0.01785714285714292 * sp[17];
    A[20] = 0.06111111111111144 * sp[19] + 0.07524801587301636 * sp[18] + -0.01165674603174616 * sp[18] + -0.02529761904761919 * sp[17];
    A[21] = 0.01041666666666666 * sp[19] + 0.004216269841269772 * sp[18] + -0.0231646825396826 * sp[18] + -0.01746031746031746 * sp[17];
    A[22] = -0.01785714285714293 * sp[19] + -0.009424603174603211 * sp[18] + 0.05327380952380986 * sp[18] + 0.04384920634920653 * sp[17];
    A[23] = 0.0252976190476193 * sp[19] + 0.01165674603174617 * sp[18] + -0.07524801587301649 * sp[18] + -0.06111111111111164 * sp[17];
    A[24] = -0.07856742013183758 * sp[19] + -0.009820927516479972 * sp[18] + 0.1360899955855056 * sp[18] + 0.07014948226057122 * sp[17];
    A[25] = -0.05326743555023485 * sp[19] + -0.0085915218629416 * sp[18] + 0.1838585678669348 * sp[18] + 0.08419691425682253 * sp[17];
    A[26] = -0.004960317460314325 * sp[19] + 0.01984126984126933 * sp[18] + -0.1626984126984119 * sp[18] + -0.1021825396825407 * sp[17];
    A[27] = -0.07014948226057124 * sp[19] + -0.1360899955855056 * sp[18] + 0.009820927516480078 * sp[18] + 0.07856742013183762 * sp[17];
    A[28] = 0.04639421805988025 * sp[19] + 0.04897167461876163 * sp[18] + -0.01288728279441061 * sp[18] + 0.03092947870658561 * sp[17];
    A[29] = -0.1240079365079384 * sp[19] + -0.240575396825396 * sp[18] + 0.01736111111111152 * sp[18] + 0.04365079365079577 * sp[17];
    A[30] = 0.01765873015873016 * sp[19] + -0.00471230158730161 * sp[18] + -0.004712301587301577 * sp[18] + 0.01765873015873019 * sp[17];
    A[31] = -0.04871031746031762 * sp[19] + 0.009920634920635002 * sp[18] + 0.005952380952380894 * sp[18] + -0.02986111111111134 * sp[17];
    A[32] = 0.05734126984127024 * sp[19] + -0.01116071428571433 * sp[18] + -0.01116071428571433 * sp[18] + 0.02162698412698437 * sp[17];
    A[33] = -0.02385912698412708 * sp[19] + -0.03067956349206368 * sp[18] + 0.008804563492063535 * sp[18] + 0.01314484126984132 * sp[17];
    A[34] = 0.06111111111111151 * sp[19] + 0.07276785714285773 * sp[18] + -0.01413690476190483 * sp[18] + -0.02777777777777797 * sp[17];
    A[35] = -0.05114087301587326 * sp[19] + -0.0582093253968257 * sp[18] + 0.007068452380952353 * sp[18] + 0.02058531746031755 * sp[17];
    A[36] = -0.01860119047619063 * sp[19] + -0.00905257936507939 * sp[18] + 0.02447916666666686 * sp[18] + 0.01542658730158744 * sp[17];
    A[37] = 0.01190476190476194 * sp[19] + 0.005704365079365088 * sp[18] + -0.02167658730158731 * sp[18] + -0.01746031746031749 * sp[17];
    A[38] = -0.01116071428571431 * sp[19] + -0.006820436507936567 * sp[18] + 0.03266369047619068 * sp[18] + 0.02385912698412713 * sp[17];
    A[39] = 0.1248660784238153 * sp[19] + 0.01192541198429706 * sp[18] + -0.1283735525368426 * sp[18] + -0.03507474113028564 * sp[17];
    A[40] = -0.003436608745177421 * sp[19] + -0.01718304372588152 * sp[18] + -0.0515491311776444 * sp[18] + -0.003436608745176622 * sp[17];
    A[41] = 0.100198412698412 * sp[19] + -0.07192460317460343 * sp[18] + 0.1026785714285715 * sp[18] + 0.1180555555555572 * sp[17];
    A[42] = -0.03507474113028573 * sp[19] + 0.0624330392119066 * sp[18] + 0.02314932914598853 * sp[18] + -0.04349267900155142 * sp[17];
    A[43] = -0.02319710902993977 * sp[19] + 0.00128872827944118 * sp[18] + 0.03221820698602831 * sp[18] + -0.01804219591217502 * sp[17];
    A[44] = -0.0620039682539693 * sp[19] + 0.1460813492063477 * sp[18] + 0.04092261904761973 * sp[18] + -0.06498015873016046 * sp[17];
    A[45] = -0.01542658730158742 * sp[19] + 0.009052579365079402 * sp[18] + -0.02447916666666682 * sp[18] + 0.01860119047619069 * sp[17];
    A[46] = 0.01746031746031743 * sp[19] + -0.00421626984126978 * sp[18] + 0.02316468253968255 * sp[18] + -0.01041666666666673 * sp[17];
    A[47] = -0.02385912698412708 * sp[19] + 0.008804563492063535 * sp[18] + -0.03067956349206368 * sp[18] + 0.01314484126984132 * sp[17];
    A[48] = 0.02162698412698432 * sp[19] + 0.0327876984126987 * sp[18] + 0.0327876984126987 * sp[18] + 0.1012896825396833 * sp[17];
    A[49] = -0.02986111111111126 * sp[19] + -0.03581349206349219 * sp[18] + -0.03978174603174631 * sp[18] + -0.09444444444444489 * sp[17];
    A[50] = 0.01765873015873012 * sp[19] + 0.0223710317460317 * sp[18] + 0.02237103174603175 * sp[18] + 0.0447420634920634 * sp[17];
    A[51] = 0.02058531746031755 * sp[19] + 0.0135168650793652 * sp[18] + 0.0787946428571432 * sp[18] + 0.02058531746031761 * sp[17];
    A[52] = -0.02777777777777795 * sp[19] + -0.01364087301587311 * sp[18] + -0.1005456349206357 * sp[18] + -0.02529761904761934 * sp[17];
    A[53] = 0.01314484126984126 * sp[19] + 0.004340277777777726 * sp[18] + 0.0438244047619049 * sp[18] + 0.01116071428571437 * sp[17];
    A[54] = -0.07856742013183657 * sp[19] + 0.02665680325901711 * sp[18] + -0.1529258713280416 * sp[18] + 0.0420896893563428 * sp[17];
    A[55] = -0.03522523963805746 * sp[19] + 0.07947157723220404 * sp[18] + 0.02104922856420357 * sp[18] + 0.1159855451497029 * sp[17];
    A[56] = -0.04513888888888802 * sp[19] + 0.04340277777777796 * sp[18] + 0.005704365079364766 * sp[18] + 0.05208333333333305 * sp[17];
    A[57] = 0.03507474113028559 * sp[19] + -0.09329881140655663 * sp[18] + 0.04700015311458278 * sp[18] + -0.2062394778460759 * sp[17];
    A[58] = 0.1005208057964093 * sp[19] + 0.03737312010379366 * sp[18] + 0.1714008611656717 * sp[18] + 0.1933092419161693 * sp[17];
    A[59] = 0.06200396825396915 * sp[19] + -0.03397817460317258 * sp[18] + 0.0830853174603189 * sp[18] + 0.04017857142857474 * sp[17];
    A[60] = 0.01746031746031744 * sp[19] + -0.005704365079365079 * sp[18] + 0.02167658730158725 * sp[18] + -0.01190476190476193 * sp[17];
    A[61] = -0.04384920634920641 * sp[19] + 0.009424603174603202 * sp[18] + -0.0532738095238097 * sp[18] + 0.01785714285714292 * sp[17];
    A[62] = 0.06111111111111151 * sp[19] + -0.01413690476190483 * sp[18] + 0.07276785714285773 * sp[18] + -0.02777777777777797 * sp[17];
    A[63] = -0.02986111111111126 * sp[19] + -0.03978174603174631 * sp[18] + -0.03581349206349219 * sp[18] + -0.09444444444444489 * sp[17];
    A[64] = 0.06865079365079411 * sp[19] + 0.08154761904761966 * sp[18] + 0.08154761904761966 * sp[18] + 0.1630952380952394 * sp[17];
    A[65] = -0.04871031746031763 * sp[19] + -0.05466269841269857 * sp[18] + -0.05863095238095271 * sp[18] + -0.09444444444444491 * sp[17];
    A[66] = -0.0252976190476192 * sp[19] + -0.01364087301587309 * sp[18] + -0.1005456349206356 * sp[18] + -0.02777777777777798 * sp[17];
    A[67] = 0.01785714285714288 * sp[19] + 0.008432539682539689 * sp[18] + 0.07113095238095249 * sp[18] + 0.01785714285714293 * sp[17];
    A[68] = -0.01041666666666659 * sp[19] + -0.006200396825396826 * sp[18] + -0.03358134920634902 * sp[18] + -0.0119047619047619 * sp[17];
    A[69] = 0.1487169023924081 * sp[19] + 0.002805979290422782 * sp[18] + 0.2946278254943956 * sp[18];
    A[70] = -0.006873217490354244 * sp[19] + -0.04725337024617496 * sp[18] + -0.177844502562879 * sp[18] + -0.1030982623552912 * sp[17];
    A[71] = 0.1289682539682536 * sp[19] + -0.09176587301587344 * sp[18] + -0.01636904761904669 * sp[18] + -0.1785714285714296 * sp[17];
    A[72] = -0.07014948226057133 * sp[19] + 0.06594051332493389 * sp[18] + -0.07997040977705124 * sp[18] + 0.1346870059402929 * sp[17];
    A[73] = -0.04639421805988043 * sp[19] + 0.002577456558881853 * sp[18] + -0.05928150085429083 * sp[18] + -0.04123930494211443 * sp[17];
    A[74] = -0.1240079365079384 * sp[19] + 0.116567460317458 * sp[18] + -0.1413690476190498 * sp[18] + 0.1428571428571429 * sp[17];
    A[75] = -0.02385912698412706 * sp[19] + 0.006820436507936553 * sp[18] + -0.03266369047619062 * sp[18] + 0.01116071428571418 * sp[17];
    A[76] = 0.06111111111111144 * sp[19] + -0.01165674603174616 * sp[18] + 0.07524801587301636 * sp[18] + -0.02529761904761919 * sp[17];
    A[77] = -0.05114087301587326 * sp[19] + 0.007068452380952353 * sp[18] + -0.0582093253968257 * sp[18] + 0.02058531746031755 * sp[17];
    A[78] = 0.01765873015873012 * sp[19] + 0.02237103174603175 * sp[18] + 0.0223710317460317 * sp[18] + 0.0447420634920634 * sp[17];
    A[79] = -0.04871031746031763 * sp[19] + -0.05863095238095271 * sp[18] + -0.05466269841269857 * sp[18] + -0.09444444444444491 * sp[17];
    A[80] = 0.05734126984127019 * sp[19] + 0.06850198412698461 * sp[18] + 0.06850198412698461 * sp[18] + 0.1012896825396833 * sp[17];
    A[81] = 0.01116071428571431 * sp[19] + 0.004340277777777709 * sp[18] + 0.04382440476190486 * sp[18] + 0.01314484126984124 * sp[17];
    A[82] = -0.0119047619047619 * sp[19] + -0.006200396825396824 * sp[18] + -0.03358134920634893 * sp[18] + -0.01041666666666651 * sp[17];
    A[83] = 0.01860119047619065 * sp[19] + 0.009548611111111239 * sp[18] + 0.04308035714285734 * sp[18] + 0.01860119047619056 * sp[17];
    A[84] = -0.08979133729352987 * sp[19] + -0.01543288609732573 * sp[18] + -0.1950155606843836 * sp[18] + -0.04208968935634289 * sp[17];
    A[85] = -0.02663371777511735 * sp[19] + -0.01073940232867695 * sp[18] + -0.007302793583500805 * sp[18] + -0.01288728279441243 * sp[17];
    A[86] = -0.03819444444444221 * sp[19] + 0.03596230158730133 * sp[18] + 0.1054067460317483 * sp[18] + 0.1264880952380962 * sp[17];
    A[87] = -0.03507474113028568 * sp[19] + -0.09750778034219236 * sp[18] + -0.05822407027627433 * sp[18] + -0.1641497884897318 * sp[17];
    A[88] = 0.02319710902993953 * sp[19] + 0.02448583730938029 * sp[18] + 0.05541531601596769 * sp[18] + 0.07474624020758355 * sp[17];
    A[89] = -0.06200396825396933 * sp[19] + -0.2080853174603168 * sp[18] + -0.1029265873015891 * sp[18] + -0.3139880952380982 * sp[17];
    A[90] = -0.01314484126984128 * sp[19] + 0.03067956349206367 * sp[18] + -0.008804563492063542 * sp[18] + 0.02385912698412707 * sp[17];
    A[91] = 0.01041666666666666 * sp[19] + -0.0231646825396826 * sp[18] + 0.004216269841269772 * sp[18] + -0.01746031746031746 * sp[17];
    A[92] = -0.01860119047619063 * sp[19] + 0.02447916666666686 * sp[18] + -0.00905257936507939 * sp[18] + 0.01542658730158744 * sp[17];
    A[93] = 0.02058531746031755 * sp[19] + 0.0787946428571432 * sp[18] + 0.0135168650793652 * sp[18] + 0.02058531746031761 * sp[17];
    A[94] = -0.0252976190476192 * sp[19] + -0.1005456349206356 * sp[18] + -0.01364087301587309 * sp[18] + -0.02777777777777798 * sp[17];
    A[95] = 0.01116071428571431 * sp[19] + 0.04382440476190486 * sp[18] + 0.004340277777777709 * sp[18] + 0.01314484126984124 * sp[17];
    A[96] = 0.1012896825396832 * sp[19] + 0.03278769841269869 * sp[18] + 0.03278769841269869 * sp[18] + 0.02162698412698432 * sp[17];
    A[97] = -0.09444444444444478 * sp[19] + -0.03978174603174631 * sp[18] + -0.03581349206349218 * sp[18] + -0.02986111111111125 * sp[17];
    A[98] = 0.04474206349206337 * sp[19] + 0.02237103174603178 * sp[18] + 0.02237103174603169 * sp[18] + 0.01765873015873014 * sp[17];
    A[99] = -0.2062394778460752 * sp[19] + 0.04700015311458271 * sp[18] + -0.0932988114065571 * sp[18] + 0.03507474113028557 * sp[17];
    A[100] = 0.1314502845029978 * sp[19] + 0.1576544261849666 * sp[18] + -0.01073940232867421 * sp[18] + 0.1039574145415858 * sp[17];
    A[101] = 0.1473214285714274 * sp[19] + 0.106894841269842 * sp[18] + 0.04935515873015865 * sp[18] + 0.05605158730158803 * sp[17];
    A[102] = 0.04208968935634261 * sp[19] + -0.1529258713280409 * sp[18] + 0.02665680325901707 * sp[18] + -0.07856742013183703 * sp[17];
    A[103] = 0.1030982623552904 * sp[19] + 0.0154647393532924 * sp[18] + 0.0773236967664685 * sp[18] + -0.05670404429540909 * sp[17];
    A[104] = 0.07440476190476294 * sp[19] + 0.01537698412698331 * sp[18] + 0.04712301587301662 * sp[18] + -0.007936507936508224 * sp[17];
    A[105] = 0.02777777777777796 * sp[19] + -0.07276785714285773 * sp[18] + 0.01413690476190486 * sp[18] + -0.06111111111111155 * sp[17];
    A[106] = -0.01785714285714293 * sp[19] + 0.05327380952380986 * sp[18] + -0.009424603174603211 * sp[18] + 0.04384920634920653 * sp[17];
    A[107] = 0.01190476190476194 * sp[19] + -0.02167658730158731 * sp[18] + 0.005704365079365088 * sp[18] + -0.01746031746031749 * sp[17];
    A[108] = -0.02777777777777795 * sp[19] + -0.1005456349206357 * sp[18] + -0.01364087301587311 * sp[18] + -0.02529761904761934 * sp[17];
    A[109] = 0.01785714285714288 * sp[19] + 0.07113095238095249 * sp[18] + 0.008432539682539689 * sp[18] + 0.01785714285714293 * sp[17];
    A[110] = -0.0119047619047619 * sp[19] + -0.03358134920634893 * sp[18] + -0.006200396825396824 * sp[18] + -0.01041666666666651 * sp[17];
    A[111] = -0.09444444444444478 * sp[19] + -0.03581349206349218 * sp[18] + -0.03978174603174631 * sp[18] + -0.02986111111111125 * sp[17];
    A[112] = 0.1630952380952392 * sp[19] + 0.08154761904761972 * sp[18] + 0.08154761904761972 * sp[18] + 0.06865079365079414 * sp[17];
    A[113] = -0.09444444444444483 * sp[19] + -0.05863095238095278 * sp[18] + -0.05466269841269854 * sp[18] + -0.0487103174603177 * sp[17];
    A[114] = 0.1346870059402914 * sp[19] + -0.0799704097770511 * sp[18] + 0.06594051332493478 * sp[18] + -0.07014948226057129 * sp[17];
    A[115] = 0.1030982623552916 * sp[19] + -0.1520699369740542 * sp[18] + 0.1022391101689942 * sp[18] + -0.1305911323167025 * sp[17];
    A[116] = -0.1071428571428564 * sp[19] + 0.01934523809523962 * sp[18] + -0.05605158730158706 * sp[18] + 0.0218253968253978 * sp[17];
    A[117] = 0.2946278254943941 * sp[18] + 0.002805979290422903 * sp[18] + 0.1487169023924091 * sp[17];
    A[118] = -0.2061965247105819 * sp[19] + -0.1030982623552909 * sp[18] + -0.103098262355291 * sp[18] + 0.1082531754730535 * sp[17];
    A[119] = -0.1458333333333373 * sp[18] + 0.004960317460317578 * sp[18] + -0.07043650793651017 * sp[17];
    A[120] = -0.02058531746031761 * sp[19] + 0.05820932539682566 * sp[18] + -0.007068452380952393 * sp[18] + 0.05114087301587334 * sp[17];
    A[121] = 0.0252976190476193 * sp[19] + -0.07524801587301649 * sp[18] + 0.01165674603174617 * sp[18] + -0.06111111111111164 * sp[17];
    A[122] = -0.01116071428571431 * sp[19] + 0.03266369047619068 * sp[18] + -0.006820436507936567 * sp[18] + 0.02385912698412713 * sp[17];
    A[123] = 0.01314484126984126 * sp[19] + 0.0438244047619049 * sp[18] + 0.004340277777777726 * sp[18] + 0.01116071428571437 * sp[17];
    A[124] = -0.01041666666666659 * sp[19] + -0.03358134920634902 * sp[18] + -0.006200396825396826 * sp[18] + -0.0119047619047619 * sp[17];
    A[125] = 0.01860119047619065 * sp[19] + 0.04308035714285734 * sp[18] + 0.009548611111111239 * sp[18] + 0.01860119047619056 * sp[17];
    A[126] = 0.04474206349206337 * sp[19] + 0.02237103174603169 * sp[18] + 0.02237103174603178 * sp[18] + 0.01765873015873014 * sp[17];
    A[127] = -0.09444444444444483 * sp[19] + -0.05466269841269854 * sp[18] + -0.05863095238095278 * sp[18] + -0.0487103174603177 * sp[17];
    A[128] = 0.1012896825396833 * sp[19] + 0.06850198412698466 * sp[18] + 0.06850198412698466 * sp[18] + 0.05734126984127032 * sp[17];
    A[129] = -0.1641497884897314 * sp[19] + -0.05822407027627442 * sp[18] + -0.09750778034219237 * sp[18] + -0.03507474113028571 * sp[17];
    A[130] = -0.2345485468582887 * sp[19] + -0.06142938132002961 * sp[18] + -0.1679642524204941 * sp[18] + -0.04209845712841184 * sp[17];
    A[131] = 0.2217261904761908 * sp[19] + 0.09945436507936603 * sp[18] + 0.1252480158730151 * sp[18] + 0.05109126984127019 * sp[17];
    A[132] = -0.04208968935634307 * sp[19] + -0.1950155606843831 * sp[18] + -0.01543288609732582 * sp[18] + -0.08979133729352988 * sp[17];
    A[133] = 0.1030982623552904 * sp[19] + 0.08763352300199807 * sp[18] + 0.02577456558882207 * sp[18] + -0.04639421805987926 * sp[17];
    A[134] = -0.07440476190476347 * sp[19] + -0.05902777777777986 * sp[18] + -0.02728174603174667 * sp[18] + -0.003968253968255101 * sp[17];
    A[135] = 0.04349267900155149 * sp[19] + -0.06243303921190627 * sp[18] + -0.0231493291459885 * sp[18] + 0.03507474113028575 * sp[17];
    A[136] = -0.07856742013183758 * sp[19] + 0.1360899955855056 * sp[18] + -0.009820927516479972 * sp[18] + 0.07014948226057122 * sp[17];
    A[137] = 0.1248660784238153 * sp[19] + -0.1283735525368426 * sp[18] + 0.01192541198429706 * sp[18] + -0.03507474113028564 * sp[17];
    A[138] = -0.07856742013183657 * sp[19] + -0.1529258713280416 * sp[18] + 0.02665680325901711 * sp[18] + 0.0420896893563428 * sp[17];
    A[139] = 0.1487169023924081 * sp[19] + 0.2946278254943956 * sp[18] + 0.002805979290422782 * sp[18];
    A[140] = -0.08979133729352987 * sp[19] + -0.1950155606843836 * sp[18] + -0.01543288609732573 * sp[18] + -0.04208968935634289 * sp[17];
    A[141] = -0.2062394778460752 * sp[19] + -0.0932988114065571 * sp[18] + 0.04700015311458271 * sp[18] + 0.03507474113028557 * sp[17];
    A[142] = 0.1346870059402914 * sp[19] + 0.06594051332493478 * sp[18] + -0.0799704097770511 * sp[18] + -0.07014948226057129 * sp[17];
    A[143] = -0.1641497884897314 * sp[19] + -0.09750778034219237 * sp[18] + -0.05822407027627442 * sp[18] + -0.03507474113028571 * sp[17];
    A[144] = 4.920634920634905 * sp[19] + 0.1984126984127022 * sp[18] + 0.1984126984127022 * sp[18] + 0.3968253968254029 * sp[17];
    A[145] = 0.02430049347996799 * sp[19] + -0.06075123369997438 * sp[18] + 0.2308546880599296 * sp[18] + 0.607512336999806 * sp[17];
    A[146] = -0.5191061687282037 * sp[19] + -0.8067190459965542 * sp[18] + -0.3016427737204514 * sp[18] + -0.3507474113028569 * sp[17];
    A[147] = -0.1984126984127004 * sp[19] + 4.305555555555531 * sp[18] + 0.01984126984127023 * sp[18] + -0.1984126984127 * sp[17];
    A[148] = -0.218704441319908 * sp[19] + -0.03645074021998962 * sp[18] + 0.2551551815399182 * sp[18] + -0.2187044413199273 * sp[17];
    A[149] = -0.3507474113028551 * sp[19] + 0.5401510134063866 * sp[18] + 0.03507474113028583 * sp[18] + 0.3226876183986342 * sp[17];
    A[150] = 0.06529556615835209 * sp[19] + -0.1271545235715235 * sp[18] + -0.05154913117764577 * sp[18] + 0.06529556615835098 * sp[17];
    A[151] = -0.05326743555023485 * sp[19] + 0.1838585678669348 * sp[18] + -0.0085915218629416 * sp[18] + 0.08419691425682253 * sp[17];
    A[152] = -0.003436608745177421 * sp[19] + -0.0515491311776444 * sp[18] + -0.01718304372588152 * sp[18] + -0.003436608745176622 * sp[17];
    A[153] = -0.03522523963805746 * sp[19] + 0.02104922856420357 * sp[18] + 0.07947157723220404 * sp[18] + 0.1159855451497029 * sp[17];
    A[154] = -0.006873217490354244 * sp[19] + -0.177844502562879 * sp[18] + -0.04725337024617496 * sp[18] + -0.1030982623552912 * sp[17];
    A[155] = -0.02663371777511735 * sp[19] + -0.007302793583500805 * sp[18] + -0.01073940232867695 * sp[18] + -0.01288728279441243 * sp[17];
    A[156] = 0.1314502845029978 * sp[19] + -0.01073940232867421 * sp[18] + 0.1576544261849666 * sp[18] + 0.1039574145415858 * sp[17];
    A[157] = 0.1030982623552916 * sp[19] + 0.1022391101689942 * sp[18] + -0.1520699369740542 * sp[18] + -0.1305911323167025 * sp[17];
    A[158] = -0.2345485468582887 * sp[19] + -0.1679642524204941 * sp[18] + -0.06142938132002961 * sp[18] + -0.04209845712841184 * sp[17];
    A[159] = 0.02430049347996799 * sp[19] + 0.2308546880599296 * sp[18] + -0.06075123369997438 * sp[18] + 0.607512336999806 * sp[17];
    A[160] = 5.416666666666709 * sp[19] + 0.4315476190476345 * sp[18] + 0.4315476190476345 * sp[18] + 1.130952380952401 * sp[17];
    A[161] = -0.1890134809847089 * sp[19] + -0.06873217490352437 * sp[18] + -0.2749286996141056 * sp[18] + -0.1890134809847029 * sp[17];
    A[162] = 0.1701034543599519 * sp[19] + 0.4495591293798427 * sp[18] + 0.1579532076199497 * sp[18] + -0.413108389159861 * sp[17];
    A[163] = -0.4017857142857219 * sp[19] + 3.593749999999994 * sp[18] + 0.558035714285723 * sp[18] + -0.4017857142857149 * sp[17];
    A[164] = 0.3007032652029458 * sp[19] + 0.1761261981902897 * sp[18] + 0.2792244605455829 * sp[18] + 0.3007032652029434 * sp[17];
    A[165] = -0.01686507936508148 * sp[19] + 0.07192460317460263 * sp[18] + -0.007440476190475964 * sp[18] + -0.01091269841269923 * sp[17];
    A[166] = -0.004960317460314325 * sp[19] + -0.1626984126984119 * sp[18] + 0.01984126984126933 * sp[18] + -0.1021825396825407 * sp[17];
    A[167] = 0.100198412698412 * sp[19] + 0.1026785714285715 * sp[18] + -0.07192460317460343 * sp[18] + 0.1180555555555572 * sp[17];
    A[168] = -0.04513888888888802 * sp[19] + 0.005704365079364766 * sp[18] + 0.04340277777777796 * sp[18] + 0.05208333333333305 * sp[17];
    A[169] = 0.1289682539682536 * sp[19] + -0.01636904761904669 * sp[18] + -0.09176587301587344 * sp[18] + -0.1785714285714296 * sp[17];
    A[170] = -0.03819444444444221 * sp[19] + 0.1054067460317483 * sp[18] + 0.03596230158730133 * sp[18] + 0.1264880952380962 * sp[17];
    A[171] = 0.1473214285714274 * sp[19] + 0.04935515873015865 * sp[18] + 0.106894841269842 * sp[18] + 0.05605158730158803 * sp[17];
    A[172] = -0.1071428571428564 * sp[19] + -0.05605158730158706 * sp[18] + 0.01934523809523962 * sp[18] + 0.0218253968253978 * sp[17];
    A[173] = 0.2217261904761908 * sp[19] + 0.1252480158730151 * sp[18] + 0.09945436507936603 * sp[18] + 0.05109126984127019 * sp[17];
    A[174] = -0.5191061687282037 * sp[19] + -0.3016427737204514 * sp[18] + -0.8067190459965542 * sp[18] + -0.3507474113028569 * sp[17];
    A[175] = -0.1890134809847089 * sp[19] + -0.2749286996141056 * sp[18] + -0.06873217490352437 * sp[18] + -0.1890134809847029 * sp[17];
    A[176] = 5.55555555555557 * sp[19] + 0.59027777777778 * sp[18] + 0.59027777777778 * sp[18] + 0.9126984126984268 * sp[17];
    A[177] = -0.3507474113028589 * sp[19] + -0.3016427737204456 * sp[18] + 0.2034334985556563 * sp[18] + -0.01402989645209937 * sp[17];
    A[178] = 0.0773236967664748 * sp[19] + 0.1675346763273511 * sp[18] + 0.06443641397205645 * sp[18] + 0.07732369676647204 * sp[17];
    A[179] = -0.6200396825396948 * sp[19] + 3.395337301587295 * sp[18] + 0.359623015873021 * sp[18] + -0.6200396825396993 * sp[17];
    A[180] = 0.03507474113028569 * sp[19] + -0.01192541198429714 * sp[18] + 0.1283735525368427 * sp[18] + -0.124866078423815 * sp[17];
    A[181] = -0.07014948226057124 * sp[19] + 0.009820927516480078 * sp[18] + -0.1360899955855056 * sp[18] + 0.07856742013183762 * sp[17];
    A[182] = -0.03507474113028573 * sp[19] + 0.02314932914598853 * sp[18] + 0.0624330392119066 * sp[18] + -0.04349267900155142 * sp[17];
    A[183] = 0.03507474113028559 * sp[19] + 0.04700015311458278 * sp[18] + -0.09329881140655663 * sp[18] + -0.2062394778460759 * sp[17];
    A[184] = -0.07014948226057133 * sp[19] + -0.07997040977705124 * sp[18] + 0.06594051332493389 * sp[18] + 0.1346870059402929 * sp[17];
    A[185] = -0.03507474113028568 * sp[19] + -0.05822407027627433 * sp[18] + -0.09750778034219236 * sp[18] + -0.1641497884897318 * sp[17];
    A[186] = 0.04208968935634261 * sp[19] + 0.02665680325901707 * sp[18] + -0.1529258713280409 * sp[18] + -0.07856742013183703 * sp[17];
    A[187] = 0.002805979290422903 * sp[18] + 0.2946278254943941 * sp[18] + 0.1487169023924091 * sp[17];
    A[188] = -0.04208968935634307 * sp[19] + -0.01543288609732582 * sp[18] + -0.1950155606843831 * sp[18] + -0.08979133729352988 * sp[17];
    A[189] = -0.1984126984127004 * sp[19] + 0.01984126984127023 * sp[18] + 4.305555555555531 * sp[18] + -0.1984126984127 * sp[17];
    A[190] = 0.1701034543599519 * sp[19] + 0.1579532076199497 * sp[18] + 0.4495591293798427 * sp[18] + -0.413108389159861 * sp[17];
    A[191] = -0.3507474113028589 * sp[19] + 0.2034334985556563 * sp[18] + -0.3016427737204456 * sp[18] + -0.01402989645209937 * sp[17];
    A[192] = 0.3968253968254035 * sp[19] + 0.1984126984127023 * sp[18] + 0.1984126984127023 * sp[18] + 4.920634920634905 * sp[17];
    A[193] = -0.1458029608799467 * sp[18] + -0.7290148043997451 * sp[18] + -0.4374088826398528 * sp[17];
    A[194] = 0.7014948226057134 * sp[19] + 0.350747411302856 * sp[18] + 0.3507474113028572 * sp[18] + 0.2805979290422594 * sp[17];
    A[195] = -0.1005208057964092 * sp[19] + 0.07088005536926234 * sp[18] + -0.06314768569261534 * sp[18] + -0.08505606644311343 * sp[17];
    A[196] = 0.04639421805988025 * sp[19] + -0.01288728279441061 * sp[18] + 0.04897167461876163 * sp[18] + 0.03092947870658561 * sp[17];
    A[197] = -0.02319710902993977 * sp[19] + 0.03221820698602831 * sp[18] + 0.00128872827944118 * sp[18] + -0.01804219591217502 * sp[17];
    A[198] = 0.1005208057964093 * sp[19] + 0.1714008611656717 * sp[18] + 0.03737312010379366 * sp[18] + 0.1933092419161693 * sp[17];
    A[199] = -0.04639421805988043 * sp[19] + -0.05928150085429083 * sp[18] + 0.002577456558881853 * sp[18] + -0.04123930494211443 * sp[17];
    A[200] = 0.02319710902993953 * sp[19] + 0.05541531601596769 * sp[18] + 0.02448583730938029 * sp[18] + 0.07474624020758355 * sp[17];
    A[201] = 0.1030982623552904 * sp[19] + 0.0773236967664685 * sp[18] + 0.0154647393532924 * sp[18] + -0.05670404429540909 * sp[17];
    A[202] = -0.2061965247105819 * sp[19] + -0.103098262355291 * sp[18] + -0.1030982623552909 * sp[18] + 0.1082531754730535 * sp[17];
    A[203] = 0.1030982623552904 * sp[19] + 0.02577456558882207 * sp[18] + 0.08763352300199807 * sp[18] + -0.04639421805987926 * sp[17];
    A[204] = -0.218704441319908 * sp[19] + 0.2551551815399182 * sp[18] + -0.03645074021998962 * sp[18] + -0.2187044413199273 * sp[17];
    A[205] = -0.4017857142857219 * sp[19] + 0.558035714285723 * sp[18] + 3.593749999999994 * sp[18] + -0.4017857142857149 * sp[17];
    A[206] = 0.0773236967664748 * sp[19] + 0.06443641397205645 * sp[18] + 0.1675346763273511 * sp[18] + 0.07732369676647204 * sp[17];
    A[207] = -0.7290148043997451 * sp[18] + -0.1458029608799467 * sp[18] + -0.4374088826398528 * sp[17];
    A[208] = 0.8035714285714407 * sp[19] + 0.4017857142857193 * sp[18] + 0.4017857142857193 * sp[18] + 5.357142857142865 * sp[17];
    A[209] = -0.05154913117763539 * sp[18] + -0.2577456558882179 * sp[18] + -0.1546473935329234 * sp[17];
    A[210] = 0.06200396825396928 * sp[19] + -0.02108134920634954 * sp[18] + 0.09598214285714186 * sp[18] + 0.05307539682539826 * sp[17];
    A[211] = -0.1240079365079384 * sp[19] + 0.01736111111111152 * sp[18] + -0.240575396825396 * sp[18] + 0.04365079365079577 * sp[17];
    A[212] = -0.0620039682539693 * sp[19] + 0.04092261904761973 * sp[18] + 0.1460813492063477 * sp[18] + -0.06498015873016046 * sp[17];
    A[213] = 0.06200396825396915 * sp[19] + 0.0830853174603189 * sp[18] + -0.03397817460317258 * sp[18] + 0.04017857142857474 * sp[17];
    A[214] = -0.1240079365079384 * sp[19] + -0.1413690476190498 * sp[18] + 0.116567460317458 * sp[18] + 0.1428571428571429 * sp[17];
    A[215] = -0.06200396825396933 * sp[19] + -0.1029265873015891 * sp[18] + -0.2080853174603168 * sp[18] + -0.3139880952380982 * sp[17];
    A[216] = 0.07440476190476294 * sp[19] + 0.04712301587301662 * sp[18] + 0.01537698412698331 * sp[18] + -0.007936507936508224 * sp[17];
    A[217] = 0.004960317460317578 * sp[18] + -0.1458333333333373 * sp[18] + -0.07043650793651017 * sp[17];
    A[218] = -0.07440476190476347 * sp[19] + -0.02728174603174667 * sp[18] + -0.05902777777777986 * sp[18] + -0.003968253968255101 * sp[17];
    A[219] = -0.3507474113028551 * sp[19] + 0.03507474113028583 * sp[18] + 0.5401510134063866 * sp[18] + 0.3226876183986342 * sp[17];
    A[220] = 0.3007032652029458 * sp[19] + 0.2792244605455829 * sp[18] + 0.1761261981902897 * sp[18] + 0.3007032652029434 * sp[17];
    A[221] = -0.6200396825396948 * sp[19] + 0.359623015873021 * sp[18] + 3.395337301587295 * sp[18] + -0.6200396825396993 * sp[17];
    A[222] = 0.7014948226057134 * sp[19] + 0.3507474113028572 * sp[18] + 0.350747411302856 * sp[18] + 0.2805979290422594 * sp[17];
    A[223] = -0.2577456558882179 * sp[18] + -0.05154913117763539 * sp[18] + -0.1546473935329234 * sp[17];
    A[224] = 1.240079365079385 * sp[19] + 0.6200396825396925 * sp[18] + 0.6200396825396925 * sp[18] + 5.61507936507941 * sp[17];
  }

};


class forms_form_0: public ufc::form
{
public:

  forms_form_0() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "f7ade342237e5af4964c4356cf0b121fecb7c546c2c72d54a3d7f9c3718a8755a939353c4e59adb32539a005c2463fb5e8af82bc1aadd81f9dfdc51a48bee4cd";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_0_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};


class forms_form_1: public ufc::form
{
public:

  forms_form_1() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "a3226853386d2b74b50fbefb85d9e0f4f839379042f756b24439e8ccc90d14f112726c9f00229d697576706f783f14fe1fb718aff5c3d4d48b40494a4aef7b2b";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_1_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};

// DOLFIN wrappers

// Standard library includes
#include <string>

// DOLFIN includes
#include <dolfin/common/NoDeleter.h>
#include <dolfin/mesh/Mesh.h>
#include <dolfin/mesh/MultiMesh.h>
#include <dolfin/fem/FiniteElement.h>
#include <dolfin/fem/DofMap.h>
#include <dolfin/fem/Form.h>
#include <dolfin/fem/MultiMeshForm.h>
#include <dolfin/function/FunctionSpace.h>
#include <dolfin/function/MultiMeshFunctionSpace.h>
#include <dolfin/function/GenericFunction.h>
#include <dolfin/function/CoefficientAssigner.h>
#include <dolfin/function/MultiMeshCoefficientAssigner.h>
#include <dolfin/adaptivity/ErrorControl.h>
#include <dolfin/adaptivity/GoalFunctional.h>
#include <dolfin/la/GenericVector.h>

namespace Forms
{

class Form_a_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a: public dolfin::Form
{
public:

  // Constructor
  Form_a(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_0>();
  }

  // Destructor
  ~Form_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_a: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_a(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_a(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class Form_L_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L: public dolfin::Form
{
public:

  // Constructor
  Form_L(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_1>();
  }

  // Destructor
  ~Form_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_L: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_L(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_L(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

// Class typedefs
typedef Form_a::TestSpace FunctionSpace;
typedef Form_a::MultiMeshTestSpace MultiMeshFunctionSpace;

}

#endif
